'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_COM.bas                                                     !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Com Schnittstelle                                                     !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !
'   !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'

$regfile = "m2561def.dat"                                   ' specify the used micro



'##########################################
'Definition von Config
'##########################################


Rem COM-Settings
$baud = 19200
Open "com1:" For Binary As #1                               'Communication
Config Serialin = Buffered , Size = 254                     '60
Config Serialout = Buffered , Size = 254                    '60

Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
$baud1 = 19200
Open "com2:" For Binary As #2                               'Communication
Config Serialin1 = Buffered , Size = 50

Enable Interrupts


'###################################################
'Funktionen definieren
'###################################################

Declare Sub Com1_init()
Declare Sub Com1_send(byval Text As String)
Declare Function Com1_recv() As Integer

Const Lf = 10
Const Cr = 13


Dim Remote_key As Integer
Dim Remote_key_old As Integer

Dim Sendtext As String * 80
Dim Printtext As String * 80


Goto Atendcom


'##################################
'User Program
'##################################


Sub Com1_init()

    Sendtext = "Init Com1 19200 Baud 8N1 "
    Com1_send Sendtext

End Sub


Sub Com1_send(byval Text As String)

    If Len(_date) < 8 Then _date = "00.00.00"
    If Len(_time) < 8 Then _time = "00:00:00"

    Printtext = _date
    Printtext = Printtext + ";"
    Printtext = Printtext + _time
    Printtext = Printtext + ";"
    Printtext = Printtext + Sendtext

    'With manual CR and LF
    'no Semikole is autom. CR and LF
    'Geht aber scheinbar nicht richtig
    Print #1 , Printtext ; Chr(cr) ; Chr(lf);


End Sub



Function Com1_recv() As Integer

   Remote_key = Inkey(#1)

   If Remote_key <> Remote_key_old Then
      Remote_key_old = Remote_key
       Com1_recv = Remote_key
       Sendtext = "Receive from PC: " + Str(remote_key)
       Com1_send Sendtext
   Else
       Com1_recv = 0
   End If

End Function

'####################
'Modul Endekennung
'####################
Atendcom: