'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_IO.bas                                                      !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Ein- und Ausgang Interface AT_IO                                      !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !
'   !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'

$regfile = "m2561def.dat"                                   ' specify the used micro


'##########################################
'Definition von Config
'##########################################






'##########################################
'Definition von Funktionen und Prozeduren
'##########################################



Declare Sub Read_io()                                       'Digitaleingnge
Declare Sub Write_io()                                      'Digitalausgnge

Declare Sub Read_ai()                                       'Analogeingnge

Declare Sub Read_kb()                                       'Tastatur


'##########################################
'Definition von Globalen Variablen
'##########################################


Const On = 1
Const Off = 0


Dim Wxx As Byte
Dim Pxx As Byte
Dim Mxx As Byte




Dim Keyb As Integer

Dim Wahlschalter As Byte


'Analogeingnge

Dim Analog As Byte

Dim Ai00 As Integer
Dim Ai01 As Integer
Dim Ai02 As Integer
Dim Ai03 As Integer
Dim Ai04 As Integer
Dim Ai05 As Integer
Dim Ai06 As Integer
Dim Ai07 As Integer
Dim Ai08 As Integer
Dim Ai09 As Integer
Dim Ai10 As Integer
Dim Ai11 As Integer
Dim Ai12 As Integer
Dim Ai13 As Integer
Dim Ai14 As Integer
Dim Ai15 As Integer

'Digitaleingnge

Dim Di00 As Bit                                             'Klemme 47-48
Dim Di01 As Bit                                             'Klemme 47-49
Dim Di02 As Bit                                             'Klemme 50-51
Dim Di03 As Bit                                             'Klemme 50-52
Dim Di04 As Bit
Dim Di05 As Bit
Dim Di06 As Bit
Dim Di07 As Bit

'Digitalausgnge

Dim Do00 As Bit
Dim Do01 As Bit
Dim Do02 As Bit
Dim Do03 As Bit
Dim Do04 As Bit
Dim Do05 As Bit
Dim Do06 As Bit
Dim Do07 As Bit



'####################
'Modul Anfangskennung
'####################
Goto Endio



'########################################
'Systemfunktionen fr die Folientastatur
'########################################
'Status: IO

Sub Read_kb() As Integer

Keyb = 255

'Tastatur aktiv setzen
Config Pinc.4 = Output
Portc.4 = 1

'Alle Ports ausschalten
Config Porta = Output
Config Pinc.0 = Output
Config Pinc.1 = Output
Config Pinc.2 = Output
Config Pinc.3 = Output

Porta = 0 : Portc.0 = 0 : Portc.1 = 0 : Portc.2 = 0 : Portc.3 = 0



'Ports fr Tastatur freigeben
Config Porta = Input
Config Pinc.0 = Input : Config Pinc.1 = Input : Config Pinc.2 = Input : Config Pinc.3 = Input

Waitms 10


Debounce Pinc.1 , 1 , Key_1
Debounce Pina.5 , 1 , Key_2
Debounce Pina.1 , 1 , Key_3
Debounce Pinc.0 , 1 , Key_4
Debounce Pina.4 , 1 , Key_5
Debounce Pina.0 , 1 , Key_6
Debounce Pinc.3 , 1 , Key_7
Debounce Pina.7 , 1 , Key_8
Debounce Pina.3 , 1 , Key_9
Debounce Pina.6 , 1 , Key_0
Debounce Pinc.2 , 1 , Key_stern
Debounce Pina.2 , 1 , Key_raute

Goto Next_check



Key_1:
Keyb = 49 : Goto Next_check
Key_2:
Keyb = 50 : Goto Next_check
Key_3:
Keyb = 51 : Goto Next_check
Key_4:
Keyb = 52 : Goto Next_check
Key_5:
Keyb = 53 : Goto Next_check
Key_6:
Keyb = 54 : Goto Next_check
Key_7:
Keyb = 55 : Goto Next_check
Key_8:
Keyb = 56 : Goto Next_check
Key_9:
Keyb = 57 : Goto Next_check
Key_0:
Keyb = 48 : Goto Next_check
Key_stern:
Keyb = 42 : Goto Next_check
Key_raute:
Keyb = 35 : Goto Next_check



Next_check:

Waitms 50

'Tastatur inaktiv
Portc.4 = 0

Porta = 0

Portc.0 = 0
Portc.1 = 0
Portc.2 = 0
Portc.3 = 0

Config Porta = Output
Config Portc = Output

Waitms 10

End Sub

'########################################
'Systemfunktionen fr Digitaleingnge
'########################################
'Status: IO
'
Sub Read_io()

'Eingnge Init
Config Porta = Output
Config Pinc.3 = Output

Waitms 5

Porta = 0 : Portc.3 = 0
Config Porta = Input

'Eingnge aktiv setzen
Config Pinc.3 = Output
 Portc.3 = 1                                                'Eingnge Port 12 aktiv setzen

'Kurz warten
Waitms 50

'Eingnge einlesen
Di00 = Pina.0
Di01 = Pina.1
Di02 = Pina.2
Di03 = Pina.3
Di04 = Pina.4 :
Di05 = Pina.5
Di06 = Pina.6
Di07 = Pina.7

'Eingnge wieder inaktiv setzen
Portc.3 = 0
Porta = 0

Config Porta = Output
Config Portc = Output

Waitms 10


End Sub


'########################################
'Systemfunktionen fr Digitalausgnge
'########################################
'Status: IO
'
Sub Write_io()

Config Porta = Output
Waitms 5

'Ausgnge reset Gruppe 1
Porta.0 = 0                                                 'Relais 1
Porta.1 = 0                                                 'Relais 2
Porta.2 = 0                                                 'Relais 3
Porta.3 = 0                                                 'Relais 4
Porta.4 = 0                                                 'Relais 5
Porta.5 = 0                                                 'Relais 6
Porta.6 = 0                                                 'Relais 7
Porta.7 = 0                                                 'Beeper


'Ausgnge setzen Gruppe 1
Porta.0 = Do00                                              'Relais 1
Porta.1 = Do01                                              'Relais 2
Porta.2 = Do02                                              'Relais 3
Porta.3 = Do03                                              'Relais 4
Porta.4 = Do04                                              'Relais 5
Porta.5 = Do05                                              'Relais 6
Porta.6 = Do06                                              'Relais 7
Porta.7 = Do07                                              'Beeper

'Ausgnge setzen Gruppe 2
'Portb.7 = Do08
'Portg.1 = Do09
'Portg.3 = Do10
'Portg.4 = Do11
'Porte.7 = Do12
'Portg.2 = Do13
'Portd.7 = Do14
'Portb.0 = Do15


'Ausgabe
Config Pinc.6 = Output
Portc.6 = 1

Waitms 50

Portc.6 = 0                                                 'bergabe an HC573
Porta = 0

Waitms 5


End Sub

'########################################
'Systemfunktionen fr Analogeingnge
'########################################
'Status: IO

Sub Read_ai()
Dim Pos As Integer

'Analog Muliplexer einrichten
Config Pinb.2 = Output
Config Pind.4 = Output
Config Pind.5 = Output

'1 Gruppe AI00-AI07
'Cpu Pin 21

'==================================


Ai00 = Getadc(0)
Ai01 = Getadc(1)
Ai02 = Getadc(2)
Ai03 = Getadc(3)
Ai04 = Getadc(4)
Ai05 = Getadc(5)
Ai06 = Getadc(6)

Incr Analog

'

If Analog > 7 Then Analog = 0

'Multiplexer
'AI07 aktivieren
Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 0
Waitms 100

If Analog = 0 Then

   Ai07 = Getadc(7)
   Pos = Ai07 / 4

   #if 0
      Lcdtext = "Analog " + Str(ai07)
      Clear_lcd 2
      Show_lcd 2 , 1 , Lcdtext
   #endif


   If Pos <= 4 Then                                         'AI=0
      Wahlschalter = 1
   End If
   If Pos > 4 And Pos <= 28 Then                            'AI=27
      Wahlschalter = 2
   End If
   If Pos > 28 And Pos <= 34 Then                           'AI=31
      Wahlschalter = 3
   End If
   If Pos > 34 And Pos <= 46 Then                           'AI=44
      Wahlschalter = 4
   End If
   If Pos > 46 And Pos <= 61 Then                           'I=59
      Wahlschalter = 5
   End If
   If Pos > 61 And Pos <= 103 Then                          'AI=102
      Wahlschalter = 6
   End If
   If Pos > 103 And Pos <= 130 Then                         'AI=128
      Wahlschalter = 7
   End If
   If Pos > 130 And Pos <= 166 Then                         'AI=164
      Wahlschalter = 8
   End If
   If Pos > 166 And Pos <= 194 Then                         'AI=192
      Wahlschalter = 9
   End If
   If Pos > 194 And Pos <= 224 Then                         'AI=223
      Wahlschalter = 10
   End If
   If Pos > 224 And Pos <= 246 Then                         'AI=244
      Wahlschalter = 11
   End If
   If Pos > 246 Then                                        'AI=255
      Wahlschalter = 12
   End If



'Multiplexer
'AI08 aktivieren
Portb.2 = 1 : Portd.4 = 0 : Portd.5 = 0

End If

'2 Gruppe AI08-AI15
'Multiplexer ber Ai07=Getadc(7)
'================================

 'Read Analogeingang 8
 If Analog = 1 Then
  Ai08 = Getadc(7)
 'AI09 aktivieren
  Portb.2 = 0 : Portd.4 = 1 : Portd.5 = 0
 End If

 'Read Analogeingang 9
 If Analog = 2 Then
   Ai09 = Getadc(7)
   'AI10 aktivieren
   Portb.2 = 1 : Portd.4 = 1 : Portd.5 = 0
 End If


 'Read Analogeingang 10
  If Analog = 3 Then
    Ai10 = Getadc(7)
    'AI11 aktivieren
    Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 1
  End If

 'Read Analogeingang 11
  If Analog = 4 Then
    Ai11 = Getadc(7)
    'AI12 aktivieren
    Portb.2 = 1 : Portd.4 = 0 : Portd.5 = 1
  End If

 'Read Analogeingang 12
  If Analog = 5 Then
    Ai12 = Getadc(7)
    'AI13 aktivieren
    Portb.2 = 0 : Portd.4 = 1 : Portd.5 = 1
  End If


 'Read Analogeingang 13
  If Analog = 6 Then
    Ai13 = Getadc(7)
    'AI14 aktivieren
    Portb.2 = 1 : Portd.4 = 1 : Portd.5 = 1
  End If


  'Read Analogeingang 14
  If Analog = 7 Then
    Ai14 = Getadc(7)
    'AI07 aktivieren
    Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 0
  End If



End Sub


'####################
'Modul Endekennung
'####################
Endio: