
'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_MAIN.bas                                                    !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Hauptprogramm                                                         !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:  AT_IO                                              !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.12 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'
'   nderung:        02.03.12
'   Gert geladen    22.02.12
'   Gert geladen    22.03.12
'   Gert geladen    11.05.12


$regfile = "m2561def.dat"                                   'specify the used micro
$crystal = 4000000                                          ' used crystal frequency
$baud = 19200                                               ' use baud rate
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space

Rem Ansteuerung der Metamorphosis LCD anzeige
Config Lcdpin = Pin , Rs = Portc.0 , E = Portc.5 , Db4 = Porta.0 , Db5 = Porta.1 , Db6 = Porta.2 , Db7 = Posta.3       'Config Lcd = 16 * 2
Config Lcd = 16 * 2


Rem COM-Settings
Open "com1:" For Binary As #1                               'Communication
Config Serialin = Buffered , Size = 254                     '60
Config Serialout = Buffered , Size = 254                    '60

Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
$baud1 = 19200
Open "com2:" For Binary As #2                               'Communication
Config Serialin1 = Buffered , Size = 50

Enable Interrupts










'###################################################
'Funktionen definieren
'###################################################

Declare Sub Main()

Declare Sub Lcd_init(byval Basic As Byte)
Declare Sub Lcd_show(byval Zeile As Integer , Byval Spalte As Integer , Text As String )
Declare Sub Lcd_clear(byval Zeile As Integer)
Declare Sub Lcd_locate(byval Zeile As Integer , Byval Spalte As Integer)
Declare Sub Lcd_cursor(byval Befehl As Byte)

Declare Sub Read_io()                                       'Digitaleingnge
Declare Sub Write_io()                                      'Digitalausgnge
Declare Sub Read_ai()                                       'Analogeingnge
Declare Sub Read_kb()                                       'Tastatur



Declare Sub Run_time()
Declare Sub Get_time()
Declare Sub Set_time()


'#########Anwender ################



Declare Sub Clock_control()

Declare Sub Menue()

Declare Sub Men_text()

Declare Sub Men_w01()
Declare Sub Men_w02()
Declare Sub Men_w03()
Declare Sub Men_w04()

Declare Sub Men_w12()

Declare Function Logo() As Integer

'Com Schnittstelle
Declare Sub Com1_init()
Declare Sub Com1_send(byval Text As String)
Declare Function Com1_recv() As Integer


Declare Sub Com_user()
Declare Sub Com_send_cycl(byval Fkt As Integer)
Declare Sub Com_send_para(byval Fkt As Integer)
Declare Sub Com_send_arch(byval Fkt As Integer)



'Heizung

Declare Sub Temperatur_control()
Declare Sub Init_eeprom()
Declare Sub Heizung()
Declare Sub Heizung_report()

Declare Sub Heizung_wasser()
Declare Sub Heizung_wasser_time()

Declare Sub Heizung_raum()
Declare Sub Heizung_raum_time()


'##################################################
'# Zuordunungsliste
'##################################################

Beeper Alias Do07                                           'Beeper
Brenner Alias Do06                                          'Relais 7 Klemme 2/3
Wasser Alias Do05                                           'Relais 6 Klemme 12/7
Heizen Alias Do04                                           'Relais 5 Klemme 12/8
Do_res03 Alias Do03
Do_res02 Alias Do02
Do_res01 Alias Do01
Do_res00 Alias Do00


Di_res07 Alias Di07
Di_res06 Alias Di06
Di_res05 Alias Di05
Di_res04 Alias Di04
Eingang4 Alias Di03
Eingang3 Alias Di02
Eingang2 Alias Di01
Eingang1 Alias Di00


Ai_res07 Alias Ai07
Ai_res06 Alias Ai06
Ai_res05 Alias Ai05
T_keller Alias Ai04
T_heizen Alias Ai03
T_wasser Alias Ai02
T_aussen Alias Ai01
T_innen Alias Ai00



'Variablen Fr At_user.bas
'=========================

Dim Temp_cycle As Byte

'Temperatur
Dim Tmin_wasser As Byte
Dim Tmax_wasser As Byte
Dim Tsol_wasser As Byte
Dim Takt_wasser As Byte

Dim Takt_keller As Byte
Dim Takt_reserve As Byte

'Zeit - Sollwerte
Dim Ti_nachlauf As Integer
Dim Ti_betrieb As Integer
Dim Ti_warten As Integer
Dim Ti_pause As Integer

'Steuerung Winterbetrieb d.h. heizen
Dim Takt_innen As Integer
Dim Takt_aussen As Integer
Dim Takt_heizen As Byte

Dim Tmin_heizen As Byte
Dim Tmax_heizen As Byte

Dim Tmin_raum As Byte
Dim Tmax_raum As Byte
Dim Tsol_raum As Byte


Dim Tmax_korr As Integer
Dim Tmin_korr As Integer
Dim Tsol_korr As Integer


'Steuerung Sommer/Winterbetrieb d.h. nur Wasser erwaermen
Dim Sommer As Bit
Dim Summer As Integer
Dim Somwin As Bit

Dim Wasser_uhr As Bit
Dim Heizen_uhr As Bit

Dim Notbetrieb As Byte
Dim Not_brenner As Integer

Dim Wasser_step As Byte
Dim Wmin_vorlauf As Integer
Dim Wmin_betrieb As Integer
Dim Wmin_warten As Integer
Dim Wmin_nachlauf As Integer
Dim Heiz_z1 As Byte
Dim Heiz_z2 As Byte
Dim Heiz_z3 As Byte
Dim Heiz_z4 As Byte


'Parameter

Dim Wasser_std_on As Byte
Dim Wasser_min_on As Byte

Dim Wasser_std_off As Byte
Dim Wasser_min_off As Byte

Dim Wasser_z1 As Byte
Dim Wasser_z2 As Byte

Dim Heizen_step As Byte

Dim H1_std_on As Byte
Dim H1_min_on As Byte

Dim H1_std_off As Byte
Dim H1_min_off As Byte
Dim H1_std As Byte


Dim Hti_betrieb As Integer
Dim Hti_warten As Integer
Dim Hti_korr As Byte

Dim Hmin_betrieb As Integer
Dim Hmin_warten As Integer

Dim Heizen_on As Byte
Dim Heizen_on_min As Byte
Dim H_tag As Bit
Dim H_sperr As Bit
Dim H_mini As Bit
Dim Tmax As Byte
Dim Tmin As Byte

Dim H_error As Byte
Dim Error_sensor As Byte


Dim St_heizen As Byte
Dim St_wasser As Byte

Dim Zeit_brenner As Integer
Dim Zeit_wasser As Integer
Dim Zeit_heizen As Integer

Dim Temp_min_innen As Integer
Dim Temp_max_innen As Integer
Dim Temp_mit_innen As Integer
Dim T_mittel_innen As Integer

Dim Temp_min_aussen As Integer
Dim Temp_max_aussen As Integer
Dim Temp_mit_aussen As Integer
Dim T_mittel_aussen As Integer

Dim Temp_min_wasser As Byte
Dim Temp_max_wasser As Byte
Dim Temp_mit_wasser As Integer
Dim T_mittel_wasser As Byte

Dim Temp_min_heizen As Byte
Dim Temp_max_heizen As Byte
Dim Temp_mit_heizen As Integer
Dim T_mittel_heizen As Byte


Dim Temp_nacht As Byte

'Archiv
Dim Arcptr As Integer

Dim Adatum(62) As String * 8

'Schaltungen
Dim Aanz_wasser(62) As Integer
Dim Aanz_brenner(62) As Integer

'Zeit
Dim Atim_wasser(62) As Integer
Dim Atim_brenner(62) As Integer
Dim Atim_heizen(62) As Integer

'Temperatur
Dim Amin_i(62) As Integer
Dim Amax_i(62) As Integer
Dim Amit_i(62) As Integer

Dim Amin_a(62) As Integer
Dim Amax_a(62) As Integer
Dim Amit_a(62) As Integer

Dim Amin_w(62) As Integer
Dim Amax_w(62) As Integer
Dim Amit_w(62) As Integer

Dim Amin_h(62) As Integer
Dim Amax_h(62) As Integer
Dim Amit_h(62) As Integer

Dim Br_time As String * 9
Dim Br_zeit As Integer

Dim Wa_time As String * 9
Dim Wa_zeit As Integer

'#########Anwender ################





'Steuerung Sommer/Winterbetrieb d.h. nur Wasser erwaermen
Dim Minsom As Byte
Dim Min_som_u As Byte
Dim Min_som_o As Byte


'Zeit Istwerte
Dim Wby_sec As Byte
Dim Wby_day As Byte
Dim Wby_min As Byte
Dim W1by_min As Byte

Dim Wday_warten As Byte
Dim W1min_warten As Byte




Dim W_brenner As Bit
Dim W_wasser As Bit

Dim Takt_aussen_old As Integer
Dim Takt_aussen_c As Integer
Dim Takt_innen_old As Integer
Dim Takt_innen_c As Integer



Dim H_min As Byte

Dim St_fh As Bit


Dim H_brenner As Bit
Dim H_heizen As Bit

Dim M_brenner As Byte
Dim M_brenner_min As Byte
Dim M_min As Byte
Dim M_wasser As Byte
Dim M_heizen As Byte
Dim M_tagnacht As Byte


Dim Zahl11 As Integer
Dim Zahl12 As Integer
Dim Zahl21 As Integer
Dim Zahl22 As Integer


'Bericht

Dim Min_old As Byte
Dim Std_old As Byte



Dim St_h As Bit
Dim St_w As Bit

Dim Ctemp As Byte


Dim Htemp_min As Byte
Dim Htemp_wait As Byte



Dim Rkey As Integer



'Com

Dim _sendsec As Byte
Dim Sendsec As Byte

Dim Czahl As Integer
Dim Cdatum As String * 8

Dim Ix As Integer
Dim Nx As Byte
Dim Text As String * 10


'##########################################
'Definition von Globalen Variablen
'##########################################




'#######LCD

Dim Lcdbasic As Bit

Dim Lcdtext As String * 16
Dim Mtext As String * 16
Dim Lcd1 As String * 16
Dim Lcd2 As String * 16
Dim Heiz_meld As String * 16





'#######IO

Const On = 1
Const Off = 0


Dim Wxx As Byte
Dim Pxx As Byte
Dim Mxx As Byte




Dim Keyb As Integer

Dim Wahlschalter As Byte


'Analogeingnge

Dim Analog As Byte

Dim Ai00 As Integer
Dim Ai01 As Integer
Dim Ai02 As Integer
Dim Ai03 As Integer
Dim Ai04 As Integer
Dim Ai05 As Integer
Dim Ai06 As Integer
Dim Ai07 As Integer
Dim Ai08 As Integer
Dim Ai09 As Integer
Dim Ai10 As Integer
Dim Ai11 As Integer
Dim Ai12 As Integer
Dim Ai13 As Integer
Dim Ai14 As Integer
Dim Ai15 As Integer

'Digitaleingnge

Dim Di00 As Bit                                             'Klemme 47-48
Dim Di01 As Bit                                             'Klemme 47-49
Dim Di02 As Bit                                             'Klemme 50-51
Dim Di03 As Bit                                             'Klemme 50-52
Dim Di04 As Bit
Dim Di05 As Bit
Dim Di06 As Bit
Dim Di07 As Bit

'Digitalausgnge

Dim Do00 As Bit
Dim Do01 As Bit
Dim Do02 As Bit
Dim Do03 As Bit
Dim Do04 As Bit
Dim Do05 As Bit
Dim Do06 As Bit
Dim Do07 As Bit



'#########Com

Const Lf = 10
Const Cr = 13


Dim Remote_key As Integer
Dim Remote_key_old As Integer

Dim Sendtext As String * 80
Dim Printtext As String * 80


'#########Zeit

Dim _msec As Byte
Dim _sec As Byte
Dim Sec_old As Byte
Dim Sec_alt As Byte

Dim _min As Byte
Dim _hour As Byte
Dim _day As Byte
Dim _month As Byte
Dim _year As Byte
Dim _imp As Byte

Dim Mday As Byte
Dim Week_day As Byte

Dim Ssec As String * 3
Dim Smin As String * 3
Dim Shour As String * 3
Dim Sday As String * 3
Dim Smonth As String * 3
Dim Syear As String * 3

Dim _date As String * 9
Dim _time As String * 9


'1-5 = Montag
'6-10 = Dienstag
'11-15 = Mittwoch
'16-20 = Donnerstag
'21-25 = Freitag
'26-30 = Samstag
'31-35 = Sonntag

Dim Korrtime As Bit
Dim Korrmin As Integer

'####Menue

Dim Startlogo As Integer
Dim Cylogo As Integer
Dim Cyimp As Integer


Dim _wxx As Byte
Dim _pxx As Byte


Dim Err_clock As Bit
Dim Err_clock_sec As Byte
Dim Err_clock_min As Integer

Dim Eeprom_write As Byte


Dim Wert As String * 10
Dim Zahl As Integer
Dim Zahl1 As Integer

Dim W1 As Byte
Dim W2 As Byte
Dim W3 As Byte

Dim Sm01 As Byte
Dim Sm02 As Byte
Dim Sm03 As Byte
Dim Sm04 As Byte
Dim Sm05 As Byte
Dim Sm06 As Byte
Dim Sm07 As Byte
Dim Sm08 As Byte

Dim Lcdpos As Byte


'###################################################
'Zyklisches Hauptprogramm
'###################################################

'Dim Temp As Integer
Dim Msec As Byte
Dim Korr As Byte

Dim F As Integer


Sub Main()

  Lcd_init 1

  Temp_max_aussen = -99
  Temp_min_aussen = 99

'Durch die Schleife wird Main zyklisch bearbeitet
 Do


   '###################################
   'Uhrzeit und Datum
   '###################################


    'Hier wird ca. jede Sekunde ein Softwareimpuls gebildet
    'Mit dem Zeitinterrupt kommt es zu Problemen


     Korr = 3
    'Feinjustierung der Uhr z.B. jede
     '#or _sec=xx# dauert bei Korr=4  ca. 7 min d.h. die Uhr luft etwas langsamer
     '#or _sec=xx# entfernen ca. 7 min d.h. die Uhr luft etwas schneller
     '60 min * 24 Std * 0,3 sec = 440 sec  d.h. ca. 7 min

    'Uhr langsamer laufen lassen
    If _sec = 10 Then Korr = 4
    If _min < 35 And _sec = 50 Then Korr = 4
    If _min < 35 And _sec = 40 Then Korr = 4

    Incr Msec
    If Msec => Korr Then
       Msec = 0
       _imp = 61
    End If



    Run_time




   '###################################
   'Digitaleingaenge, Tastatur, Analog
   '###################################

   'Digital
    Read_io

   'Tastatur
    Read_kb


   'Analog incl. Wahlschalter
    Read_ai


   '##################################
   'User Program
   '##################################

  'Nach einem Neustart das Startlogo eine Zeitlang anzeigen
  '###########################
  'User_Men.bas
   F = Logo()
   If F = Off Then

  'Zeiteingabe anfordern
  '###########################
  'User_Men.bas
  Clock_control




   'Empfang vom PC  und Senden an den PC
   '#####################################
     Com_user




  'Daten mit dem EEProm austauschen
  '##################################
  'user_prog.bas
  Init_eeprom

  'Anzeigen von Werten
  '##################################
  'user_men.bas
  Menue

  'Temperatur einlesen und normieren
  '##################################
  'User_prog.bas
  Temperatur_control

  'Heizung steuern
  '##################################
  'user_prog.bas
  Heizung




   '###################################
   'Digitalausgaenge
   '###################################

   'DO schalten
   Write_io

   End If

 Loop

End Sub






'####################################
'Systemfunktionen fr das LCD
'####################################

Sub Lcd_init(byval Basic As Byte)

If Basic = 1 Then
  Lcdbasic = 1
End If

   Lcd_clear 0

   Sendtext = "Init LCD 16*2"
End Sub




'Status: IO
'Als Parameter Text muss die Globale Variable LCDText benutzt werden
Sub Lcd_show(byval Zeile As Integer , Byval Spalte As Integer , Text As String)




'Positioniert die Zeile und Spalte und gibt einen Text aus
 Locate Zeile , Spalte
 Lcd Text



End Sub

'Status: IO
Sub Lcd_clear(byval Zeile As Integer)




   If Zeile = 0 Then
     Cls
   Else
     Locate Zeile , 1
     Lcd "                "
   End If




End Sub


Sub Lcd_locate(byval Zeile As Integer , Byval Spalte As Integer )





'Positioniert die Zeile und Spalte und gibt einen Text aus
 Locate Zeile , Spalte




End Sub

Sub Lcd_cursor(byval Befehl As Byte)



   If Lcdbasic = 1 Then

       If Befehl = 1 Then
         Cursor On Blink
       End If
       If Befehl = 0 Then
         Cursor Off Blink
       End If

   End If

End Sub


'########################################
'Systemfunktionen fr die Folientastatur
'########################################
'Status: IO

Sub Read_kb() As Integer

Keyb = 255

'Tastatur aktiv setzen
Config Pinc.4 = Output
Portc.4 = 1

'Alle Ports ausschalten
Config Porta = Output
Config Pinc.0 = Output
Config Pinc.1 = Output
Config Pinc.2 = Output
Config Pinc.3 = Output

Porta = 0 : Portc.0 = 0 : Portc.1 = 0 : Portc.2 = 0 : Portc.3 = 0



'Ports fr Tastatur freigeben
Config Porta = Input
Config Pinc.0 = Input : Config Pinc.1 = Input : Config Pinc.2 = Input : Config Pinc.3 = Input

Waitms 10


Debounce Pinc.1 , 1 , Key_1
Debounce Pina.5 , 1 , Key_2
Debounce Pina.1 , 1 , Key_3
Debounce Pinc.0 , 1 , Key_4
Debounce Pina.4 , 1 , Key_5
Debounce Pina.0 , 1 , Key_6
Debounce Pinc.3 , 1 , Key_7
Debounce Pina.7 , 1 , Key_8
Debounce Pina.3 , 1 , Key_9
Debounce Pina.6 , 1 , Key_0
Debounce Pinc.2 , 1 , Key_stern
Debounce Pina.2 , 1 , Key_raute

Goto Next_check



Key_1:
Keyb = 49 : Goto Next_check
Key_2:
Keyb = 50 : Goto Next_check
Key_3:
Keyb = 51 : Goto Next_check
Key_4:
Keyb = 52 : Goto Next_check
Key_5:
Keyb = 53 : Goto Next_check
Key_6:
Keyb = 54 : Goto Next_check
Key_7:
Keyb = 55 : Goto Next_check
Key_8:
Keyb = 56 : Goto Next_check
Key_9:
Keyb = 57 : Goto Next_check
Key_0:
Keyb = 48 : Goto Next_check
Key_stern:
Keyb = 42 : Goto Next_check
Key_raute:
Keyb = 35 : Goto Next_check



Next_check:

Waitms 50

'Tastatur inaktiv
Portc.4 = 0

Porta = 0

Portc.0 = 0
Portc.1 = 0
Portc.2 = 0
Portc.3 = 0

Config Porta = Output
Config Portc = Output

Waitms 10

End Sub

'########################################
'Systemfunktionen fr Digitaleingnge
'########################################
'Status: IO
'
Sub Read_io()

'Eingnge Init
Config Porta = Output
Config Pinc.3 = Output

Waitms 5

Porta = 0 : Portc.3 = 0
Config Porta = Input

'Eingnge aktiv setzen
Config Pinc.3 = Output
 Portc.3 = 1                                                'Eingnge Port 12 aktiv setzen

'Kurz warten
Waitms 50

'Eingnge einlesen
Di00 = Pina.0
Di01 = Pina.1
Di02 = Pina.2
Di03 = Pina.3
Di04 = Pina.4 :
Di05 = Pina.5
Di06 = Pina.6
Di07 = Pina.7

'Eingnge wieder inaktiv setzen
Portc.3 = 0
Porta = 0

Config Porta = Output
Config Portc = Output

Waitms 10


End Sub


'########################################
'Systemfunktionen fr Digitalausgnge
'########################################
'Status: IO
'
Sub Write_io()

Config Porta = Output
Waitms 5

'Ausgnge reset Gruppe 1
Porta.0 = 0                                                 'Relais 1
Porta.1 = 0                                                 'Relais 2
Porta.2 = 0                                                 'Relais 3
Porta.3 = 0                                                 'Relais 4
Porta.4 = 0                                                 'Relais 5
Porta.5 = 0                                                 'Relais 6
Porta.6 = 0                                                 'Relais 7
Porta.7 = 0                                                 'Beeper


'Ausgnge setzen Gruppe 1
Porta.0 = Do00                                              'Relais 1
Porta.1 = Do01                                              'Relais 2
Porta.2 = Do02                                              'Relais 3
Porta.3 = Do03                                              'Relais 4
Porta.4 = Do04                                              'Relais 5
Porta.5 = Do05                                              'Relais 6
Porta.6 = Do06                                              'Relais 7
Porta.7 = Do07                                              'Beeper

'Ausgnge setzen Gruppe 2
'Portb.7 = Do08
'Portg.1 = Do09
'Portg.3 = Do10
'Portg.4 = Do11
'Porte.7 = Do12
'Portg.2 = Do13
'Portd.7 = Do14
'Portb.0 = Do15


'Ausgabe
Config Pinc.6 = Output
Portc.6 = 1

Waitms 50

Portc.6 = 0                                                 'bergabe an HC573
Porta = 0

Waitms 5


End Sub

'########################################
'Systemfunktionen fr Analogeingnge
'########################################
'Status: IO

Sub Read_ai()
Dim Pos As Integer

'Analog Muliplexer einrichten
Config Pinb.2 = Output
Config Pind.4 = Output
Config Pind.5 = Output

'1 Gruppe AI00-AI07
'Cpu Pin 21

'==================================


Ai00 = Getadc(0)
Ai01 = Getadc(1)
Ai02 = Getadc(2)
Ai03 = Getadc(3)
Ai04 = Getadc(4)
Ai05 = Getadc(5)
Ai06 = Getadc(6)

Incr Analog

'

If Analog > 7 Then Analog = 0

'Multiplexer
'AI07 aktivieren
Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 0
Waitms 100

If Analog = 0 Then

   Ai07 = Getadc(7)
   Pos = Ai07 / 4

   #if 0
      Lcdtext = "Analog " + Str(ai07)
      Clear_lcd 2
      Show_lcd 2 , 1 , Lcdtext
   #endif


   If Pos <= 4 Then                                         'AI=0
      Wahlschalter = 1
   End If
   If Pos > 4 And Pos <= 28 Then                            'AI=27
      Wahlschalter = 2
   End If
   If Pos > 28 And Pos <= 34 Then                           'AI=31
      Wahlschalter = 3
   End If
   If Pos > 34 And Pos <= 46 Then                           'AI=44
      Wahlschalter = 4
   End If
   If Pos > 46 And Pos <= 61 Then                           'I=59
      Wahlschalter = 5
   End If
   If Pos > 61 And Pos <= 103 Then                          'AI=102
      Wahlschalter = 6
   End If
   If Pos > 103 And Pos <= 130 Then                         'AI=128
      Wahlschalter = 7
   End If
   If Pos > 130 And Pos <= 166 Then                         'AI=164
      Wahlschalter = 8
   End If
   If Pos > 166 And Pos <= 194 Then                         'AI=192
      Wahlschalter = 9
   End If
   If Pos > 194 And Pos <= 224 Then                         'AI=223
      Wahlschalter = 10
   End If
   If Pos > 224 And Pos <= 246 Then                         'AI=244
      Wahlschalter = 11
   End If
   If Pos > 246 Then                                        'AI=255
      Wahlschalter = 12
   End If



'Multiplexer
'AI08 aktivieren
Portb.2 = 1 : Portd.4 = 0 : Portd.5 = 0

End If


End Sub







'####################################
'Systemfunktionen fr Datum und Zeit
'####################################


  Sub Run_time()

  If _imp => 61 Then

      _imp = 0

      Incr _sec

  End If


  If _sec > 59 Then
     Incr _min
     _sec = 0
  End If

  If _min > 59 Then
     Incr _hour
     _min = 0
  End If

  If Week_day = 0 Or Week_day > 7 Then
     Week_day = 1
  End If

  If _hour > 23 Then
     Incr _day
     Incr Week_day
     _hour = 0
  End If


   If _day > 28 Then
     Select Case _month
        Case 1
           Mday = 31
        Case 2
           'Schaltjahr im Februar 2004,2208,2012 mit 29 Tagen
           Mday = _year And &H03
           If Mday = 0 Then
              Mday = 29
           Else
              Mday = 28
           End If
        Case 3
           Mday = 31
        Case 4
           Mday = 30
        Case 5
           Mday = 31
        Case 6
           Mday = 30
        Case 7
           Mday = 31
        Case 8
           Mday = 31
        Case 9
           Mday = 30
        Case 10
           Mday = 31
        Case 11
           Mday = 30
        Case 12
           Mday = 31
     End Select
     If _day > Mday Then
        _day = 1
        Incr _month
        If _month > 12 Then
           _month = 1
           Incr _year
        End If
     End If
  End If

  If _year > 99 Then
     _year = 0
  End If

  Get_time

  'Evtl. Korrektur fr Software Uhr
  If _time = "02:00:00" And Korrtime = 0 Then
     Korrtime = 1

     If Korrmin < 0 Then
        Zahl = 60 + Korrmin
        Wert = "01:"
        Wert = Wert + Str(zahl)
        Wert = Wert + ":00"
        _time = Wert
        Set_time
     End If

     If Korrmin > 0 Then
        Wert = "02:0"
        Wert = Wert + Str(korrmin)
        Wert = Wert + ":00"
        _time = Wert
        Set_time
     End If

  End If

  If _time = "02:30:00" And Korrtime = 1 Then
     Korrtime = 0
  End If



  End Sub





Sub Set_time()
     Dim S As String * 10

     S = Mid(_date , 1 , 2)
    _day = Val(s)

     S = Mid(_date , 4 , 2)
    _month = Val(s)

     S = Mid(_date , 7 , 2)
    _year = Val(s)

    S = Mid(_time , 1 , 2)
   _hour = Val(s)

    S = Mid(_time , 4 , 2)
   _min = Val(s)

    S = Mid(_time , 7 , 2)
   _sec = Val(s)

End Sub


Sub Get_time()

   If _day < 10 Then
        Sday = "0" + Str(_day)
      Else
        Sday = Str(_day)
      End If

      If _month < 10 Then
        Smonth = "0" + Str(_month)
      Else
        Smonth = Str(_month)
      End If

      If _year < 10 Then
        Syear = "0" + Str(_year)
      Else
        Syear = Str(_year)
      End If

      If _hour < 10 Then
        Shour = "0" + Str(_hour)
      Else
        Shour = Str(_hour)
      End If

       If _min < 10 Then
        Smin = "0" + Str(_min)
      Else
        Smin = Str(_min)
      End If

        If _sec < 10 Then
        Ssec = "0" + Str(_sec)
      Else
        Ssec = Str(_sec)
      End If


      _date = Sday + "." + Smonth + "." + Syear
      _time = Shour + ":" + Smin + ":" + Ssec


End Sub



Sub Clock_control()


'Alarm starten
If _day = 0 And _month = 0 And Err_clock = 0 Then

   Err_clock = 1
   Err_clock_min = 1800

   _time = "08:00:00"
   Set_time

   If Wxx > 1 Then
    Lcdtext = "Wahlschalter 1  "
    Lcd_show 1 , 1 , Lcdtext
    Lcdtext = "Datum? Uhrzeit? "
    Lcd_show 2 , 1 , Lcdtext
  End If


End If

'Alarm aus
If _day > 0 And _month > 0 Then
     Err_clock = 0
     Err_clock_min = 0
End If

'Alarm aktiv
If Err_clock = 1 Then

   If _sec <> Err_clock_sec Then
       'Beeper = Off
       Do07 = Off
       Err_clock_sec = _sec
       Err_clock_min = Err_clock_min + 1
   End If

   'Alle 30 min einen Beepston ausgeben
   If Err_clock_min >= 1800 Then
       'Beeper = On
       Do07 = On
       Err_clock_min = 0
   End If


End If


End Sub




Sub Menue()

   'Verwaltet Wahlschalter und Keyboard
   'Wahlschalter wurde gendert
    If Wxx <> Wahlschalter Then
      Wxx = Wahlschalter
      Pxx = 1
      _pxx = 0
      Mxx = 0
    End If


  'Parameter verndern
  If Keyb = Asc( "*") Then
     Decr Pxx

     'Obergrenze
     If Pxx = 0 And Wxx = 1 Then Pxx = 3                    'Datum
     If Pxx = 0 And Wxx = 2 Then Pxx = 12                   'Betrieb
     If Pxx = 0 And Wxx = 3 Then Pxx = 14                   'Eprom Parameter
     If Pxx = 0 And Wxx = 4 Then Pxx = 6                    'Handbetrieb


  End If

  If Keyb = Asc( "#") Then
     Incr Pxx


    'Obergrenzen

      If Wxx = 1 And Pxx > 3 Then Pxx = 1                   'Datum Uhr Betriebsart
      If Wxx = 2 And Pxx > 12 Then Pxx = 1                  'Betrieb
      If Wxx = 3 And Pxx > 14 Then Pxx = 1                  'Eprom Parameter
      If Wxx = 4 And Pxx > 6 Then Pxx = 1                   'Handbetrieb


 End If



  'Menue bearbeiten

  'Datum Uhrzeit und Betriebsarten
  Men_w01

  If Err_clock = 1 And Wxx > 1 Then
    Lcdtext = "Wahlschalter 1  "
    Lcd_show 1 , 1 , Lcdtext
    Lcdtext = "Datum? Uhrzeit? "
    Lcd_show 2 , 1 , Lcdtext
  End If


  If Err_clock = 0 Then

  'Betrieb Heizung/Warmwasser
  Men_w02


  'EEProm Verwaltung
  Men_w03



  'Test Relais
  Men_w04





  'Logo
  Men_w12

  'Reserve
  If Wxx >= 5 And Wxx <= 11 Then
      If _wxx <> Wxx Or _pxx <> Pxx Then

      _wxx = Wxx
      _pxx = Pxx

       Men_text
       Lcd_clear 1
       Lcd_clear 2
       Lcdtext = Mtext
       Lcd_show 1 , 1 , Lcdtext

      End If

  End If


  End If

End Sub



 'Ermittelt den Menue Text z.B. 12/1
 'wenn sich Wahlschalter oder Programm gendert hat

Sub Men_text()



      If Wxx < 10 Then
         Lcdtext = "0" + Str(wxx)
      Else
         Lcdtext = Str(wxx)
      End If
      If Pxx < 10 Then
         Lcdtext = Lcdtext + "/" + Str(pxx) + " "
      Else
         Lcdtext = Lcdtext + "/" + Str(pxx) + " "
      End If

      Mtext = Lcdtext




End Sub




'Datum und Uhrzeit

Sub Men_w01()

If Wxx <> 01 Then
Exit Sub
End If

 If _wxx <> Wxx Or _pxx <> Pxx Then

      _wxx = Wxx
      _pxx = Pxx

      If Pxx = 1 Then Mxx = 1
      If Pxx = 2 Then Mxx = 2
      If Pxx = 3 Then Mxx = 3


 End If


If _sec <> Sec_old Then
      Sec_old = _sec


'Anzeigen Datum und Uhrzeit
If Pxx = 1 Then
   Mxx = 11


      Men_text
      Lcdtext = Mtext + _date + "   "
      Lcd_show 1 , 1 , Lcdtext
      Lcdtext = "     " + _time + "   "
      Lcd_show 2 , 1 , Lcdtext

      If Summer = 0 Then
         Lcdtext = "Au"
         Lcd_show 1 , 15 , Lcdtext
      End If
      If Summer = 1 Then
         Lcdtext = "So"
         Lcd_show 1 , 15 , Lcdtext
      End If
      If Summer = 2 Then
         Lcdtext = "Wi"
         Lcd_show 1 , 15 , Lcdtext
      End If


End If

End If

'Eingabe Datum
If Pxx = 2 And Mxx = 2 Then
   Mxx = 12
   Men_text
   Lcd1 = "Set Date"
   Lcd_clear 1
   Lcdtext = Mtext + Lcd1
   Lcd_show 1 , 1 , Lcdtext
   Lcdtext = "     " + _date + "   "
   Lcd_show 2 , 1 , Lcdtext


   Lcdpos = 6
   Lcd_locate 2 , 6
   Lcd_cursor On

End If

'Eingabe der Zeit
If Pxx = 3 And Mxx = 3 Then
   Mxx = 13
   Men_text
   Lcd1 = "Set Time"
   Lcd_clear 1
   Lcdtext = Mtext + Lcd1
   Lcd_show 1 , 1 , Lcdtext
   Lcdtext = "     " + _time + "   "
   Lcd_show 2 , 1 , Lcdtext

   Lcdpos = 6
   Lcd_locate 2 , 6
   Lcd_cursor On

End If








'Eingabe der Werte

If Mxx > 10 Then


  'Taste 0,1, ... 9
  If Keyb >= Asc( "0") And Keyb <= Asc( "9") Then



      Select Case Lcdpos

         Case 0:




         Case 6:
            W1 = Keyb - 48
            W1 = W1 * 10

            'Eingegebene Zahl Anzeigen
            Lcdtext = Chr(keyb)
            Lcd_show 2 , 6 , Lcdtext

            'Eingabe zur nchsten Position
            Lcdpos = 7
            Lcd_locate 2 , 7
            Lcd_cursor On

         Case 7:
            W1 = W1 + Keyb
            W1 = W1 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 7 , Lcdtext

            Lcdpos = 9
            Lcd_locate 2 , 9
            Lcd_cursor On


        Case 9:
            W2 = Keyb - 48
            W2 = W2 * 10

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 9 , Lcdtext

            Lcdpos = 10
            Lcd_locate 2 , 10
            Lcd_cursor On

         Case 10:
            W2 = W2 + Keyb
            W2 = W2 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 10 , Lcdtext

            Lcdpos = 12
            Lcd_locate 2 , 12
            Lcd_cursor On

        Case 12:
            W3 = Keyb - 48
            W3 = W3 * 10

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 12 , Lcdtext

            Lcdpos = 13
            Lcd_locate 2 , 13
            Lcd_cursor On

         Case 13:
            W3 = W3 + Keyb
            W3 = W3 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 13 , Lcdtext

           'Daten bernehmen
            Pxx = 1

            If Mxx = 12 Then
               If W1 > 31 Then W1 = 31
               If W2 > 12 Then W2 = 12

               If W1 < 10 Then
                  _date = "0" + Str(w1) + "."
               Else
                  _date = Str(w1) + "."
               End If

               If W2 < 10 Then
                  _date = _date + "0" + Str(w2) + "."
               Else
                  _date = _date + Str(w2) + "."
               End If

               If W3 < 10 Then
                  _date = _date + "0" + Str(w3)
               Else
                  _date = _date + Str(w3)
               End If

               Pxx = 3

            End If

            If Mxx = 13 Then
               If W1 > 24 Then W1 = 23
               If W2 > 59 Then W2 = 59
               If W3 > 59 Then W3 = 59

               If W1 < 10 Then
                  _time = "0" + Str(w1) + ":"
               Else
                  _time = Str(w1) + ":"
               End If

               If W2 < 10 Then
                  _time = _time + "0" + Str(w2) + ":"
               Else
                  _time = _time + Str(w2) + ":"
               End If

               If W3 < 10 Then
                  _time = _time + "0" + Str(w3)
               Else
                  _time = _time + Str(w3)
               End If
            End If



            Set_time

      End Select


  End If

End If



End Sub





'Betrieb

Sub Men_w02()

If Wxx <> 2 Then
  Exit Sub
End If




  If _wxx <> Wxx Or _pxx <> Pxx Then
      _wxx = Wxx
      _pxx = Pxx

  End If

       'Grundstellung d.h. alle Ausgnge welche von Hand ein waren
       'wieder ausschalten
       If Keyb = Asc( "0") Then
        M_brenner = 0
        M_wasser = 0
        M_heizen = 0
        Beeper = 0
        M_tagnacht = 0
      End If

      'Einschalten oder Ausschalten
      If Keyb = Asc( "1") Then
         If M_brenner = 0 Or M_brenner = 2 Then
           M_brenner = 1
         Else
           M_brenner = 2
         End If
      End If

      If Keyb = Asc( "2") Then
         If M_wasser = 0 Or M_wasser = 2 Then
           M_wasser = 1
         Else
           M_wasser = 2
         End If

      End If

      If Keyb = Asc( "3") Then
        If M_heizen = 0 Or M_heizen = 2 Then
           M_heizen = 1
        Else
           M_heizen = 2
        End If

      End If


      'Beeper Ein Aus
      If Keyb = Asc( "4") Then
         If Beeper = 0 Then
           Beeper = 1
         Else
            Beeper = 0
         End If
      End If


      'Tag und Nachtbetrieb schalten
      If Keyb = Asc( "7") Then
        M_tagnacht = M_tagnacht + 1
        If M_tagnacht = 3 Then M_tagnacht = 0
      End If


      'Sommer/Winter Umschaltung
      If Keyb = Asc( "8") Then
              If Summer = 0 Then
                  Summer = 1
                  'Lcdtext = "*** Sommer *** "
              Else
                  If Summer = 1 Then
                     Summer = 2
                     'Lcdtext = "*** Winter *** "
                  Else
                     Summer = 0
                     'Lcdtext = "***Automatik***"
                  End If
              End If
      End If






  If Sm02 <> _sec Then
     Sm02 = _sec

      Men_text
      If Sommer = 1 Then
        If Notbetrieb = 0 Then
         If Wasser_uhr = 1 Then
           Lcd1 = "ST      "
         Else
           Lcd1 = "SN      "
         End If

        Else
         Lcd1 = "NS      "
        End If

      Else
        If Notbetrieb = 0 Then
          If Heizen_uhr = 1 Then
            If M_tagnacht = 0 Then
            Lcd1 = "WT      "
            Else
            Lcd1 = "wt      "
            End If

          Else
            If M_tagnacht = 0 Then
            Lcd1 = "WN      "
            Else
            Lcd1 = "wn      "
            End If
          End If

        Else
          Lcd1 = "NW      "
        End If
      End If


      Lcdtext = Mtext + Lcd1
      Lcd_show 1 , 1 , Lcdtext


'Uhrzeitanzeige
If Pxx = 1 Then


      Lcdtext = "Zeit    "
      Lcd_show 1 , 9 , Lcdtext


      Lcd2 = Mid(_date , 1 , 5)


      Lcdtext = " " + Lcd2 + " " + _time + " "
      Lcd_clear 2
      Lcd_show 2 , 1 , Lcdtext

End If



'Temperaturen anzeigen -Innentemperatur
If Pxx = 2 Then
   Lcdtext = ""

    Lcdtext = "Temp. TI"
    Lcd_show 1 , 9 , Lcdtext

    'Innentemperatur
   Lcdtext = "l="
   Lcdtext = Lcdtext + Str(temp_min_innen)

   Lcdtext = Lcdtext + " "
   Lcdtext = Lcdtext + Str(takt_innen)

   Lcdtext = Lcdtext + " h="
   Lcdtext = Lcdtext + Str(temp_max_innen)

  Lcd_clear 2
  Lcd_show 2 , 1 , Lcdtext

End If

'Temperaturen anzeigen - Aussentemperatur
If Pxx = 3 Then
   Lcdtext = ""




    Lcdtext = "Temp. TA"
    Lcd_show 1 , 9 , Lcdtext

    'Aussentemperatur
   Lcdtext = "l="
   If Temp_min_aussen = 0 Then Lcdtext = Lcdtext + " 00"

   If Temp_min_aussen > 0 And Temp_min_aussen < 10 Then
      Lcdtext = Lcdtext + " 0"
     Lcdtext = Lcdtext + Str(temp_min_aussen)
   End If

   If Temp_min_aussen < 0 And Temp_min_aussen > -10 Then
      Lcdtext = Lcdtext + "-0"
      Zahl = Temp_min_aussen * -1
      Lcdtext = Lcdtext + Str(zahl)
   End If

   If Temp_min_aussen < -9 Or Temp_min_aussen > 9 Then
      Lcdtext = Lcdtext + Str(temp_min_aussen)
   End If

   Lcdtext = Lcdtext + " "
   If Takt_aussen = 0 Then Lcdtext = Lcdtext + " 00"

   If Takt_aussen > 0 And Takt_aussen < 10 Then
      Lcdtext = Lcdtext + " 0"
      Lcdtext = Lcdtext + Str(takt_aussen)
   End If
   If Takt_aussen < 0 And Takt_aussen > -10 Then
      Lcdtext = Lcdtext + "-0"
      Zahl = Takt_aussen * -1
      Lcdtext = Lcdtext + Str(zahl)
   End If


   Lcdtext = Lcdtext + " "
   If Takt_aussen < -9 Or Takt_aussen > 9 Then
     Lcdtext = Lcdtext + Str(takt_aussen)
   End If

   Lcdtext = Lcdtext + " h="

   If Temp_max_aussen = 0 Then Lcdtext = Lcdtext + " 00"
   If Temp_max_aussen > 0 And Temp_max_aussen < 10 Then
      Lcdtext = Lcdtext + " 0"
      Lcdtext = Lcdtext + Str(temp_max_aussen)
   End If
   If Temp_max_aussen < 0 And Temp_max_aussen > -10 Then
      Lcdtext = Lcdtext + "-0"
      Zahl = Temp_max_aussen * -1
      Lcdtext = Lcdtext + Str(zahl)
   End If

   If Temp_max_aussen < -9 Or Temp_max_aussen > 9 Then
     Lcdtext = Lcdtext + Str(temp_max_aussen)
   End If

   Lcd_clear 2
   Lcd_show 2 , 1 , Lcdtext

End If



'Schaltpunkte Wassertemperatur
If Pxx = 4 Then
   Lcdtext = ""

    Lcdtext = "Wasser  "
    Lcd_show 1 , 9 , Lcdtext

   Lcdtext = "u= "
   Lcdtext = Lcdtext + Str(tmin_wasser)

   Lcdtext = Lcdtext + "  "
   Lcdtext = Lcdtext + Str(takt_wasser)

   Lcdtext = Lcdtext + "  o= "
   Lcdtext = Lcdtext + Str(tmax_wasser)
   Lcdtext = Lcdtext + "    "

    Lcd_clear 2
   Lcd_show 2 , 1 , Lcdtext

End If

'Schaltpunkte Vorlauftemperatur
If Pxx = 5 Then
   Lcdtext = ""

   Lcdtext = "Heizen  "
   Lcd_show 1 , 9 , Lcdtext

   Lcdtext = "u= "
   Lcdtext = Lcdtext + Str(tmin)                            'Mit Korrektur

   Lcdtext = Lcdtext + "  "
   Lcdtext = Lcdtext + Str(takt_heizen)

   Lcdtext = Lcdtext + "  o= "
   Lcdtext = Lcdtext + Str(tmax)                            'Mit Korrektur
   Lcdtext = Lcdtext + "    "

   Lcd_clear 2
   Lcd_show 2 , 1 , Lcdtext

End If

'Temperaturen anzeigen - Raum Keller
If Pxx = 6 Then
   Lcdtext = ""

    Lcdtext = "Temp.   "
    Lcd_show 1 , 9 , Lcdtext

    'Temperatur im Heizraum
   Lcdtext = "TK= "
   Lcdtext = Lcdtext + Str(takt_keller)

   'Reserve
   Lcdtext = Lcdtext + " TR= "
   Lcdtext = Lcdtext + Str(takt_reserve)
   Lcdtext = Lcdtext + "   "


   Lcd_clear 2
   Lcd_show 2 , 1 , Lcdtext

End If


'Diagnose Wasser
If Pxx = 7 Then
   Lcdtext = "Wasser  "
   Lcd_show 1 , 9 , Lcdtext
   Lcd_clear 2

   If Wasser_uhr = 0 And Wasser_step = 255 Then
      Lcdtext = "Nachtabsenkung  "
      Lcd_show 2 , 1 , Lcdtext
   End If


   'Vorlauf
   If Wasser_step = 1 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Vorlauf  min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = 2 - Wmin_vorlauf
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If

   'Betrieb

   If Wasser_step = 2 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Brenner  min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = Ti_betrieb - Wmin_betrieb
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext
   End If
   'Nachlauf
   If Wasser_step = 3 And Wasser_uhr = 1 Then
          Lcd_clear 2
          Lcdtext = "Nachlauf min "
          Lcd_show 2 , 1 , Lcdtext
          Zahl = Ti_nachlauf - Wmin_nachlauf
          Lcdtext = Str(zahl)
          Lcd_show 2 , 14 , Lcdtext
   End If
      'Pause
   If Wasser_step = 4 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Pause    min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = Ti_pause - Wmin_warten
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If
   'Warten
   If Wasser_step = 5 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Warten   min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = Ti_warten - Wmin_warten
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If

   'Notlauf da Vorlauf kleiner 28 Grad
   If Heiz_z4 > 0 And Heiz_z4 < 100 Then
       Lcd_clear 2
       Lcdtext = "Tv<Min   min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = 30 - Heiz_z4
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If


End If


'Diagnose Heizen
If Pxx = 8 Then

     Lcdtext = "Heizen  "
     Lcd_show 1 , 9 , Lcdtext

   'Betrieb
   If Heizen_step <> 1 And Heizen_step <> 2 Then
       Lcd_clear 2
       Lcdtext = Heiz_meld
       If Len(heiz_meld) > 0 Then
         Lcd_show 2 , 1 , Lcdtext
       Else
         Lcdtext = "Heizung Aus     "
         Lcd_show 2 , 1 , Lcdtext
       End If
   End If




      If Heizen_step = 1 Then
         Lcd_clear 2
         Lcdtext = "Brenner  min "
         Lcd_show 2 , 1 , Lcdtext
         Zahl = Hti_betrieb - Hmin_betrieb
         Lcdtext = Str(zahl)
         Lcd_show 2 , 14 , Lcdtext
      End If
      If Heizen_step = 2 Then
         Lcd_clear 2
         Lcdtext = "Pause    min "
         Lcd_show 2 , 1 , Lcdtext

         Zahl = Hti_warten - Hti_korr
         If Zahl <= 5 Then Zahl = 5
         If Heizen_uhr = 0 Then Zahl = 30

         Zahl = Zahl - Hmin_warten
         Lcdtext = Str(zahl)
         Lcd_show 2 , 14 , Lcdtext
      End If





End If






'Betriebsanzeige
If Pxx = 9 Then



      Lcdtext = "Ausgang "
      Lcd_show 1 , 9 , Lcdtext

      If Brenner = 1 Then
         Lcdtext = "B=1 "
      Else
         Lcdtext = "B=0 "
      End If
      If Wasser = 1 Then
         Lcdtext = Lcdtext + "W=1 "
      Else
         Lcdtext = Lcdtext + "W=0 "
      End If
      If Heizen = 1 Then
         Lcdtext = Lcdtext + "H=1"
      Else
         Lcdtext = Lcdtext + "H=0"
      End If

      Lcd_clear 2
      If M_heizen = 0 And M_brenner = 0 And M_wasser = 0 Then
      Lcdtext = Lcdtext + "     "
      Lcd_show 2 , 1 , Lcdtext
      Else
      Lcdtext = Lcdtext + " Hand"
      Lcd_show 2 , 1 , Lcdtext
      End If



End If


'Diagnose Heizen
If Pxx = 10 Then

      Lcdtext = "Heizen "
      Lcd_show 1 , 10 , Lcdtext


      Lcdtext = Br_time
      Lcdtext = Lcdtext + " "

      'Schaltzahl des Brenners
      If St_heizen < 10 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(st_heizen)
      Lcdtext = Lcdtext + " "

      'Laufzeit Brenner fr Heizen
      If Br_zeit < 10 Then
          Lcdtext = Lcdtext + "00"
      End If
      If Br_zeit > 9 And Br_zeit < 100 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(br_zeit)
      Lcdtext = Lcdtext + " "

      Lcd_clear 2
      Lcd_show 2 , 1 , Lcdtext

End If


'Diagnose Wasser
If Pxx = 11 Then

      Lcdtext = "Wasser "
      Lcd_show 1 , 10 , Lcdtext


      Lcdtext = Wa_time
      Lcdtext = Lcdtext + " "

      'Schaltzahl der Wasserpumpe
      If St_wasser < 10 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(st_wasser)
      Lcdtext = Lcdtext + " "

      'Laufzeit der Wasserpumpe
      If Wa_zeit < 10 Then
          Lcdtext = Lcdtext + "00"
      End If
      If Wa_zeit > 9 And Wa_zeit < 100 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(wa_zeit)
      Lcdtext = Lcdtext + " "


     Lcd_clear 2
     Lcd_show 2 , 1 , Lcdtext


End If






If Pxx = 12 Then

         Men_text
         Lcdtext = "Brenner"
         Lcd_show 1 , 10 , Lcdtext

         Lcd2 = ""
         If Zeit_brenner < 10 Then
          Lcd2 = Lcd2 + "00"
         End If
         If Zeit_brenner > 9 And Zeit_brenner < 100 Then
          Lcd2 = Lcd2 + "0"
         End If


         Lcd2 = Lcd2 + Str(zeit_brenner)
         Lcd2 = Lcd2 + " "



      'Laufzeit des Brenners fr Wasser
      Lcdtext = ""
      If Wa_zeit < 10 Then
          Lcdtext = Lcdtext + "00"
      End If
      If Wa_zeit > 9 And Wa_zeit < 100 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcd2 = Lcd2 + "W="
      Lcd2 = Lcd2 + Lcdtext
      Lcd2 = Lcd2 + Str(wa_zeit)

     'Laufzeit Brenner fr Heizen
      Lcdtext = ""
      If Br_zeit < 10 Then
          Lcdtext = Lcdtext + "00"
      End If
      If Br_zeit > 9 And Br_zeit < 100 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcd2 = Lcd2 + " H="
      Lcd2 = Lcd2 + Lcdtext
      Lcd2 = Lcd2 + Str(br_zeit)
      Lcd2 = Lcd2 + " "


      Lcd_clear 2
      Lcd_show 2 , 1 , Lcd2


End If





End If


End Sub



'EEprom Verwaltung
Sub Men_w03()

If Wxx <> 3 Then
Exit Sub
End If



      If _pxx <> Pxx Then
         _pxx = Pxx
         Mxx = 1
      End If

     If Sm03 <> _sec Then
        Sm03 = _sec


         If Pxx = 1 Then
            Mxx = 11

            Men_text
            Lcd1 = "R=0 D=1 W=2       "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(eeprom_write) + "              "
            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Locate 2 , 1
            Lcd_cursor On


         End If


          If Pxx = 2 And Mxx = 1 Then
            Mxx = 12

            Men_text
            Lcd1 = "Wasser Temp  "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(tsol_wasser) + "  C        "
            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On


         End If

          If Pxx = 3 And Mxx = 1 Then
             Mxx = 13


            Men_text
            Lcd1 = "Raum Temp T"
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(tsol_raum) + "  C       "
            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On




         End If


         If Pxx = 4 And Mxx = 1 Then
             Mxx = 14


            Men_text
            Lcd1 = "Raum Temp N"
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(temp_nacht) + "  C       "
            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On




         End If



           If Pxx = 5 And Mxx = 1 Then
            Mxx = 15

            Men_text
            Lcd1 = "Wasser On       "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If Wasser_std_on > 9 And Wasser_min_on > 9 Then
            Lcd2 = Str(wasser_std_on) + ":" + Str(wasser_min_on) + " Uhr         "
            End If
            If Wasser_std_on < 10 And Wasser_min_on < 10 Then
            Lcd2 = "0" + Str(wasser_std_on) + ":0" + Str(wasser_min_on) + " Uhr         "
            End If
            If Wasser_std_on < 10 And Wasser_min_on > 9 Then
            Lcd2 = "0" + Str(wasser_std_on) + ":" + Str(wasser_min_on) + " Uhr         "
            End If
            If Wasser_std_on > 9 And Wasser_min_on < 10 Then
            Lcd2 = Str(wasser_std_on) + ":0" + Str(wasser_min_on) + " Uhr         "
            End If


            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If

           If Pxx = 6 And Mxx = 1 Then
             Mxx = 16

            Men_text
            Lcd1 = "Wasser Off      "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If Wasser_std_off > 9 And Wasser_min_off > 9 Then
            Lcd2 = Str(wasser_std_off) + ":" + Str(wasser_min_off) + " Uhr         "
            End If
            If Wasser_std_off < 10 And Wasser_min_off < 10 Then
            Lcd2 = "0" + Str(wasser_std_off) + ":0" + Str(wasser_min_off) + " Uhr         "
            End If
            If Wasser_std_off < 10 And Wasser_min_off > 9 Then
            Lcd2 = "0" + Str(wasser_std_off) + ":" + Str(wasser_min_off) + " Uhr         "
            End If
            If Wasser_std_off > 9 And Wasser_min_off < 10 Then
            Lcd2 = Str(wasser_std_off) + ":0" + Str(wasser_min_off) + " Uhr         "
            End If

            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If


           If Pxx = 7 And Mxx = 1 Then
             Mxx = 17

            Men_text
            Lcd1 = "Heizen On       "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If H1_std_on > 9 And H1_min_on > 9 Then
            Lcd2 = Str(h1_std_on) + ":" + Str(h1_min_on) + " Uhr         "
            End If
            If H1_std_on < 10 And H1_min_on < 10 Then
            Lcd2 = "0" + Str(h1_std_on) + ":0" + Str(h1_min_on) + " Uhr         "
            End If
            If H1_std_on < 10 And H1_min_on > 9 Then
            Lcd2 = "0" + Str(h1_std_on) + ":" + Str(h1_min_on) + " Uhr         "
            End If
            If H1_std_on > 9 And H1_min_on < 10 Then
            Lcd2 = Str(h1_std_on) + ":0" + Str(h1_min_on) + " Uhr         "
            End If

            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If

           If Pxx = 8 And Mxx = 1 Then
              Mxx = 18

            Men_text
            Lcd1 = "Heizen Off      "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If H1_std_off > 9 And H1_min_off > 9 Then
            Lcd2 = Str(h1_std_off) + ":" + Str(h1_min_off) + " Uhr         "
            End If
            If H1_std_off < 10 And H1_min_off < 10 Then
            Lcd2 = "0" + Str(h1_std_off) + ":0" + Str(h1_min_off) + " Uhr         "
            End If
            If H1_std_off < 10 And H1_min_off > 9 Then
            Lcd2 = "0" + Str(h1_std_off) + ":" + Str(h1_min_off) + " Uhr         "
            End If
            If H1_std_off > 9 And H1_min_off < 10 Then
            Lcd2 = Str(h1_std_off) + ":0" + Str(h1_min_off) + " Uhr         "
            End If

            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If







         If Pxx = 9 And Mxx = 1 Then
            Mxx = 19

            Men_text
            Lcd1 = "Wasser Nach    "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(ti_nachlauf) + " min           "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If

         If Pxx = 10 And Mxx = 1 Then
            Mxx = 20

            Men_text
            Lcd1 = "Wasser Betrieb "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(ti_betrieb) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If

           If Pxx = 11 And Mxx = 1 Then
            Mxx = 21

            Men_text
            Lcd1 = "Wasser Warten  "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(ti_warten) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If





         If Pxx = 12 And Mxx = 1 Then
            Mxx = 22

            Men_text
            Lcd1 = "Heizen Betrieb "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(hti_betrieb) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If

         If Pxx = 13 And Mxx = 1 Then
            Mxx = 23

            Men_text
            Lcd1 = "Heizen Pause   "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(hti_warten) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If


         If Pxx = 14 And Mxx = 1 Then
            Mxx = 24

            Lcd1 = "-<10 0=10 +>10  "
            'Lcd1 = "Min Korrektur "
            Lcd_show 1 , 1 , Lcd1

            If Korrmin = 0 Then Wert = "10"
            If Korrmin > 0 Then
              Zahl = Korrmin + 10
              Wert = Str(zahl)
            End If
            If Korrmin < 0 Then
              Wert = "0"
              Zahl = Korrmin * -1
              Wert = Wert + Str(zahl)
            End If


            Lcd2 = Wert + " KorrFaktor   "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If



End If




      'Eingabe der Werte
      '#################

      If Mxx = 11 Then
        'Taste 0,1, ... 9
         If Keyb >= Asc( "0") And Keyb <= Asc( "2") Then


            Eeprom_write = Keyb - 48

            'Eingegebene Zahl Anzeigen
            Lcdtext = Chr(keyb) + "     "
            Lcd_show 2 , 1 , Lcdtext
         End If

      End If


      If Mxx >= 12 And Mxx <= 24 Then
        'Taste 0,1, ... 9
         If Keyb >= Asc( "0") And Keyb <= Asc( "9") Then



         Select Case Lcdpos

            Case 1:
            W1 = Keyb - 48
            W1 = W1 * 10

            'Eingegebene Zahl Anzeigen
            Lcdtext = Chr(keyb)
            Lcd_show 2 , 1 , Lcdtext

            'Eingabe zur nchsten Position
            Lcdpos = 2
            Lcd_locate 2 , 2
            Lcd_cursor On

            Case 2:
            W1 = W1 + Keyb
            W1 = W1 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 2 , Lcdtext


            If Mxx = 12 Then
               Tsol_wasser = W1
            End If

            'Raumtemperatur Tags mit 3 stellen
            If Mxx = 13 Then
              W1 = W1 * 10
              Lcdpos = 3
              Lcd_locate 2 , 3
              Lcd_cursor On
            End If
            'Raumtemperatur Nachts mit 3 stellen
            If Mxx = 14 Then
              W1 = W1 * 10
              Lcdpos = 3
              Lcd_locate 2 , 3
              Lcd_cursor On
            End If


            If Mxx > 15 And Mxx < 21 Then

            Lcdpos = 4
            Lcd_locate 2 , 4
            Lcd_cursor On

            If Mxx = 15 Then
               Wasser_std_on = W1
            End If
            If Mxx = 16 Then
               Wasser_std_off = W1
            End If
            If Mxx = 17 Then
               H1_std_on = W1
            End If
            If Mxx = 18 Then
               H1_std_off = W1
            End If

            If Mxx = 19 Then
              Ti_nachlauf = W1
            End If
            If Mxx = 20 Then
              Ti_betrieb = W1
            End If

            End If


            If Mxx = 21 Then
               Lcdpos = 4
               Lcd_locate 2 , 3
               Lcd_cursor On
            End If

            If Mxx = 22 Then
              Hti_betrieb = W1
            End If
            If Mxx = 23 Then
              Hti_warten = W1
            End If

            If Mxx = 24 Then

              If W1 = 10 Then
                Korrmin = 0
              End If
              If W1 < 10 Then
                Korrmin = W1 * -1
              End If
              If W1 > 10 Then
                Korrmin = W1 - 10
              End If

            End If

            Case 3:
            W1 = W1 + Keyb
            W1 = W1 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 3 , Lcdtext

            If Mxx = 13 Then
             Tsol_raum = W1
            End If
            If Mxx = 14 Then
             Temp_nacht = W1
            End If


            Case 4:
            W2 = Keyb - 48

            If Mxx = 21 Then
               Ti_warten = W1 * 10
               Ti_warten = Ti_warten + W2
            End If


            W2 = W2 * 10

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 4 , Lcdtext

            Lcdpos = 5
            Lcd_locate 2 , 5
            Lcd_cursor On

            Case 5:
            W2 = W2 + Keyb
            W2 = W2 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 5 , Lcdtext




            If Mxx = 15 Then
               Wasser_min_on = W2
            End If
            If Mxx = 16 Then
               Wasser_min_off = W2
            End If
            If Mxx = 17 Then
               H1_min_on = W2
            End If
            If Mxx = 18 Then
               H1_min_off = W2
            End If

            End Select


         End If

      End If




End Sub







'Handbetrieb
Sub Men_w04()

If Wxx <> 4 Then
Exit Sub
End If

 If _wxx <> Wxx Or _pxx <> Pxx Then
      _wxx = Wxx
      _pxx = Pxx

      Men_text

 End If




 If Sm04 <> _sec Then
     Sm04 = _sec






      Lcd1 = "Analoginp. "
      Lcdtext = Mtext + Lcd1
      Lcd_show 1 , 1 , Lcdtext

 'Innentemperatur
 If Pxx = 1 Then

      Lcd2 = "AI00 "

      Wert = Str(ai00) + " " + Str(takt_innen) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If
  'Aussentemperatur
  If Pxx = 2 Then

      Lcd2 = "AI01 "

      Wert = Str(ai01) + " " + Str(takt_aussen) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If

  'Wassertemperatur
  If Pxx = 3 Then

      Lcd2 = "AI02 "

      Wert = Str(ai02) + " " + Str(takt_wasser) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If

  'Vorlauftemperatur Heizung
  If Pxx = 4 Then

      Lcd2 = "AI03 "

      Wert = Str(ai03) + " " + Str(takt_heizen) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If

  'Raumtemperatur Keller
  If Pxx = 5 Then

      Lcd2 = "AI04 "

      'KTY 81 210
      'Zahl1 = 865 - Ai04
      'Zahl = Zahl1 / 2
      'Zahl = Zahl + Zahl1

      Wert = Str(ai04) + " " + Str(takt_keller) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If

  'Reserve
  If Pxx = 6 Then

      Lcd2 = "AI05 "

      'KTY 81 210
      'Zahl1 = 865 - Ai04
      'Zahl = Zahl1 / 2
      'Zahl = Zahl + Zahl1

      Wert = Str(ai05) + " " + Str(takt_reserve) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If








End If


End Sub














'StartLogo Anzeigen
Sub Men_w12()

If Wxx <> 12 Then
Exit Sub
End If

    If Startlogo = -1 Then
        Startlogo = 0
    End If


End Sub





Function Logo() As Integer

If Startlogo = -1 Then
    Logo = Off
Else
    Logo = On

        If Cylogo = 0 And Startlogo = 0 Then
         Lcdtext = "*CoSoMa V050212*"
         Lcd_show 1 , 1 , Lcdtext
         Lcd_clear 2
        End If



         Cylogo = Cylogo + 1
         If Cylogo >= 2 Then
            Cylogo = 0

             Startlogo = Startlogo + 1
             If Startlogo >= 15 Then Startlogo = -1



         End If


End If
End Function




'##################Heizung

Sub Heizung()
  Dim Som As Bit

'Wenn Wahlschalter in Stellung 3 -12.... knnen die Ausgaenge
'im Testbetrieb geschaltet werden
'Automatikfunktionen muessen unwirksam sein, da sie evtl. die
'Ausgnge verndern

   'Im Mai, Juni,Juli,August ist Sommer d.h. Heizung nicht ntig
   If _month = 5 Or _month = 6 Or _month = 7 Or _month = 8 Then
      Som = 1
      Somwin = 0
   End If
   'Im Jan, Feb, Mrz, Nov, Dez ist Winter mit Heizung
   If _month = 1 Or _month = 2 Or _month = 3 Or _month = 10 Or _month = 11 Or _month = 12 Then
      Som = 0
      Somwin = 0
   End If

   'In den bergangsmonaten abhngig von der Raumtemperatur
   'April, Sept
   If _month = 0 Or _month = 4 Or _month = 9 Then
        Som = 0
        Somwin = 1
   End If

   'Automatisch oder von Hand einstellen
   If Summer = 0 Then Sommer = Som
   If Summer = 1 Then Sommer = 1
   If Summer = 2 Then Sommer = 0

   'Wasser erwrmen im sommer und im Winter
   '########################################
   Heizung_wasser_time
   Heizung_wasser


   'Damit dies fr alle Temperaturen funktioniert
   'muss der Kesselwassertemperaturregler auf 90 Grad
   'eingestellt sein

   'Temperatur in Abhngigkeit von der Aussentemperatur
   If Takt_aussen > 15 Then
      Tmin_heizen = 40
      Tmax_heizen = 50
   End If

   If Takt_aussen > 10 And Takt_aussen <= 15 Then
      Tmin_heizen = 45
      Tmax_heizen = 55
   End If

   If Takt_aussen > 5 And Takt_aussen <= 10 Then
      Tmin_heizen = 55
      Tmax_heizen = 65
   End If

   If Takt_aussen > 0 And Takt_aussen <= 5 Then
      Tmin_heizen = 65
      Tmax_heizen = 75
   End If

   If Takt_aussen > -5 And Takt_aussen <= 0 Then
      Tmin_heizen = 70
      Tmax_heizen = 80
   End If

   If Takt_aussen > -10 And Takt_aussen <= -5 Then
      Tmin_heizen = 70
      Tmax_heizen = 80
   End If

   If Takt_aussen > -15 And Takt_aussen < -10 Then
      Tmin_heizen = 75
      Tmax_heizen = 85
   End If
   If Takt_aussen < -15 Then
      Tmin_heizen = 75
      Tmax_heizen = 85
   End If



   'Heizung nur im Winter und der bergangszeit
   '###########################################
   If Sommer = 0 Then
      'Raumheizung nur im Winter
      Heizung_raum_time
      Heizung_raum
   Else
      H_heizen = 0
      H_brenner = 0
      H_error = 0
   End If


   Heizung_report


'Wahlschalter in Stellung 3 ist Handbetrieb
'd.h. Ausgnge werden nun nicht mehr von der
'Automatik gesteuert

   'Ausgnge schalten

   If M_wasser = 0 Then
      Wasser = W_wasser
   End If


   If M_brenner = 0 Then
      Brenner = W_brenner Or H_brenner
   End If

   If M_heizen = 0 Then
      Heizen = H_heizen
   End If


   If M_wasser = 1 Then
     Wasser = 1
   End If
   If M_heizen = 1 Then
     Heizen = 1
   End If

   If M_brenner = 1 Then
     Brenner = 1

     If _min <> M_min Then
       If Heizen_uhr = 1 Or Wasser_uhr = 1 Then
        M_min = _min
        M_brenner_min = M_brenner_min + 1
        If M_brenner_min = 2 Then
           Heizen = 1
           Wasser = 1
        End If

        If M_brenner_min > 15 Then
           Brenner = 0
        End If
        If M_brenner_min > 25 Then
           Wasser = 0
        End If
        If M_brenner_min > 40 Then
           M_brenner_min = 0
        End If
       End If
     End If


   End If

   If M_wasser = 2 Then
     Wasser = 0
   End If
   If M_brenner = 2 Then
     Brenner = 0
     M_brenner_min = 0
   End If
   If M_heizen = 2 Then
     Heizen = 0
   End If





End Sub


'Messgeber KTY 81 210
' 70 Grad 819  (Errechnet)

' 40 Grad 839  (Gemessen)
' 25 Grad 849  (Gemessen)
'
'                    1 Digit = 1,5 Grad     865= 0 Grad
'
'
'

' - 40 Grad  889 (Errechnet)


'Messgeber fr T_wasser  Wassertank
' 40 Grad 967  (Gemessen)
' 62 Grad 979  (Vergleich mit KTY)
'

'  0 Grad = 865      bis 955   gilt t= w - 869 / 3
'  5 Grad = 880      ab  955   gilt t= w - 955 + 30
' 10 Grad = 895
' 15 Grad = 910
' 20 Grad = 926
' 25 Grad = 940

' 30 Grad = 955
' 40 Grad = 965
' 50 Grad = 975
' 60 Grad = 985
' 70 Grad = 995
' 80 Grad = 1005
' 90 Grad = 1015

'Messgeber fr T_raum    Wohnzimmer
' 0 Grad = 850      t=w-845 / 4
' 5 Grad = 870
'10 Grad = 890
'15 Grad = 910    880 ohm
'20 Grad = 930   1020 ohm
'21 Grad = 930                w- 845 / 4
'22 Grad = 930
'25 Gred = 950
'30 Grad = 970
'35 Grad = 990

'Messgeber fr T_aussen
' 1 Grad = 25 Ohm = 2,5
'Ohm    Wert
'2000=  825
'1000=  925
'0500=  975
'0250= 1000

'24 Grad   500 Ohm               975
'23
'22
'21
'20*Grad = 600 611 Ohm 959       965  1 Grad = 25 Ohm = 2,5
'19                    956
'18                    953
'17                    950
'16        700         947       955
'15 Grad =             944
'14 Grad =     790 Ohm 941
'13*Grad =     815 Ohm 938
'12 Grad = 800 840 ohm 935       945
'11
'10
'09
'08 Grad = 900 Ohm               935
'07
'06
'05
'04        1000 ohm              925
'03
'02
'01
'00 Grad   1100                  915
'01
'02
'03
'04        1200                  905

Sub Temperatur_control()

Temp_cycle = Temp_cycle + 1
If Temp_cycle < 10 Then
  Exit Sub
Else
   Temp_cycle = 0
End If

'AI0
'T_innen Geber im Wohnzimmer

   'Zahl = T_innen - 843
   '13.10.11 Von 844 Nach 843
   'Zahl = Zahl / 4

   Zahl = T_innen - 925
   Zahl = Zahl * 3
   Zahl = Zahl + 200


   'Anfangswerte setzen nach Steuerungsneustart
   If Takt_innen_old = 0 And Takt_innen = 0 Then
     Takt_innen = Zahl
     Zahl11 = Takt_innen - 60
     Zahl12 = Takt_innen + 60
     Br_time = _time
     Wa_time = _time
   End If


   'Fehlmessungen
   If Zahl < 50 Then
      Zahl = Takt_innen
      Error_sensor = 1
   End If

   If Zahl > 280 Then
      Zahl = Takt_innen
      Error_sensor = 1
   End If

   If Takt_innen < 50 Then
     Takt_innen = Zahl
     Zahl11 = Takt_innen - 60
     Zahl12 = Takt_innen + 60
   End If
   If Takt_innen > 280 Then
     Takt_innen = Zahl
     Zahl11 = Takt_innen - 60
     Zahl12 = Takt_innen + 60
   End If


  'Messung ausfhren
   If Zahl > Zahl11 And Zahl < Zahl12 Then
    Takt_innen_c = Takt_innen_c + 1
    Takt_innen_old = Takt_innen_old + Zahl
   End If

  If Takt_innen_c > 100 Then
    Takt_innen_old = Takt_innen_old / Takt_innen_c

     If Takt_innen_old > Takt_innen Then
      Takt_innen = Takt_innen + 3
     End If
     If Takt_innen_old < Takt_innen Then
      Takt_innen = Takt_innen - 3
     End If



    Zahl11 = Takt_innen - 30
    Zahl12 = Takt_innen + 30

    Takt_innen_c = 0
    Takt_innen_old = 0
  End If




'AI1
'T_aussen Geber an der Hauswand
'Gemessen 955=27 Grad
'Gemessen 944=22 Grad
'Gemessen 928=14 Grad
'Gemessen 937=18 Grad
'Gemessen 900=1  Grad

  Zahl = T_aussen - 900                                     '944
  Zahl = Zahl / 2

 'Anfangswerte setzen nach Steuerungsneustart
  If Takt_aussen_old = 0 And Takt_aussen = 0 Then
     Takt_aussen = Zahl

     Zahl21 = Takt_aussen - 6
     Zahl22 = Takt_aussen + 6

  End If

  'Fehlmessungen
   If Zahl < -25 Then
      Zahl = Takt_aussen
      Error_sensor = 2
   End If

   If Zahl > 35 Then
      Zahl = Takt_aussen
      Error_sensor = 2
   End If






  'Messung ausfhren
   If Zahl => Zahl21 And Zahl < Zahl22 Then
    Takt_aussen_c = Takt_aussen_c + 1
    Takt_aussen_old = Takt_aussen_old + Zahl
   End If





   If Takt_aussen_c > 100 Then
    Takt_aussen_old = Takt_aussen_old / Takt_aussen_c

    If Takt_aussen_old > Takt_aussen Then
      Takt_aussen = Takt_aussen + 1
    End If
    If Takt_aussen_old < Takt_aussen Then
      Takt_aussen = Takt_aussen - 1
    End If

    Zahl21 = Takt_aussen - 4
    Zahl22 = Takt_aussen + 6

    Takt_aussen_c = 0
    Takt_aussen_old = 0

  End If





'AI2
'T_wasser Geber am Wassertank




 '  If T_wasser < 955 Then
 '  Takt_wasser = T_wasser - 869
 '  Takt_wasser = Takt_wasser / 3
 '  Else
 '  Takt_wasser = T_wasser - 954
 '  Takt_wasser = Takt_wasser + 30
 '  End If


  'Umwandlung auf Wassertemperatur, wenn der Geber direkt an der
  'Wasserpumpe angeschlossen ist, ist keine Korrektur notwendig.

  'Umwendlung auf Wassertemperatur, wenn der Geber am
  'Wassertank angeschlossen ist
   'Takt_wasser = Takt_wasser + 15

   If T_wasser >= 910 And T_wasser <= 915 Then
     Takt_wasser = 13
   End If
   If T_wasser > 915 And T_wasser <= 920 Then
     Takt_wasser = 18
   End If
   If T_wasser > 920 And T_wasser <= 930 Then
     Takt_wasser = 23
   End If
   If T_wasser > 930 And T_wasser <= 940 Then
     Takt_wasser = 28
   End If
   If T_wasser > 950 And T_wasser < 970 Then
     Takt_wasser = 33
   End If

   If T_wasser => 970 Then                                  'Grsser 33 Grad
    Zahl = T_wasser - 982
    Takt_wasser = Zahl + 48
   End If


  'Umwandlung auf Wassertemperatur, wenn der Geber am
  'Wassertank angeschlossen ist
   Takt_wasser = Takt_wasser - 3

  If Takt_wasser < 10 Then Error_sensor = 3
  If Takt_wasser > 85 Then Error_sensor = 3



'AI3
'T_heizen  Geber am Heizungsvorlauf


'   If T_heizen < 955 Then
'   Takt_heizen = T_heizen - 869
'   Takt_heizen = Takt_heizen / 3
'   Else
'   Takt_heizen = T_heizen - 955
'   Takt_heizen = Takt_heizen + 30
'   End If


   'Bereich 995 = 54 bis 999=62 bis 1008=80 bis 1014=90
   If T_heizen => 995 Then
     Zahl = T_heizen - 1008
     Zahl = Zahl * 2
     Zahl = Zahl + 80
   End If
   If T_heizen > 950 And T_heizen < 995 Then
     Zahl = T_heizen - 950
     Zahl = Zahl + 10
   End If
   If T_heizen > 900 And T_heizen <= 950 Then
     Zahl = 15
   End If


    If T_heizen = 940 Then Zahl = 24
    If T_heizen = 941 Then Zahl = 24
    If T_heizen = 942 Then Zahl = 25
    If T_heizen = 943 Then Zahl = 25
    If T_heizen = 944 Then Zahl = 26
    If T_heizen = 945 Then Zahl = 26
    If T_heizen = 946 Then Zahl = 27

    If T_heizen = 947 Then Zahl = 28
    If T_heizen = 948 Then Zahl = 29
    If T_heizen = 949 Then Zahl = 30
    If T_heizen = 950 Then Zahl = 30
    If T_heizen = 951 Then Zahl = 31
    If T_heizen = 952 Then Zahl = 32
    If T_heizen = 953 Then Zahl = 33
    If T_heizen = 954 Then Zahl = 33
    If T_heizen = 955 Then Zahl = 34
    If T_heizen = 956 Then Zahl = 34
    If T_heizen = 957 Then Zahl = 35
    If T_heizen = 958 Then Zahl = 35
    If T_heizen = 959 Then Zahl = 36
    If T_heizen = 960 Then Zahl = 36
    If T_heizen = 961 Then Zahl = 37
    If T_heizen = 962 Then Zahl = 37



   If T_heizen = 963 Then Zahl = 38                         '* Gemessen
   If T_heizen = 964 Then Zahl = 38
   If T_heizen = 965 Then Zahl = 39
   If T_heizen = 966 Then Zahl = 39
   If T_heizen = 968 Then Zahl = 40
   If T_heizen = 969 Then Zahl = 40
   If T_heizen = 970 Then Zahl = 41
   If T_heizen = 971 Then Zahl = 41


   If T_heizen = 972 Then Zahl = 42
   If T_heizen = 973 Then Zahl = 42
   If T_heizen = 974 Then Zahl = 43
   If T_heizen = 975 Then Zahl = 43

   If T_heizen = 976 Then Zahl = 44                         '* Gemessen
   If T_heizen = 977 Then Zahl = 45
   If T_heizen = 978 Then Zahl = 45
   If T_heizen = 979 Then Zahl = 46
   If T_heizen = 980 Then Zahl = 47
   If T_heizen = 981 Then Zahl = 48
   If T_heizen = 982 Then Zahl = 48
   If T_heizen = 983 Then Zahl = 49
   If T_heizen = 984 Then Zahl = 50                         '*Gemessen
   If T_heizen = 985 Then Zahl = 51
   If T_heizen = 986 Then Zahl = 52
   If T_heizen = 987 Then Zahl = 53
   If T_heizen = 988 Then Zahl = 54
   If T_heizen = 989 Then Zahl = 55
   If T_heizen = 990 Then Zahl = 56
   If T_heizen = 991 Then Zahl = 57
   If T_heizen = 992 Then Zahl = 58                         '*Gemessen
   If T_heizen = 993 Then Zahl = 59
   If T_heizen = 994 Then Zahl = 59
   If T_heizen = 995 Then Zahl = 60                         '*
   If T_heizen = 996 Then Zahl = 62
   If T_heizen = 997 Then Zahl = 64
   If T_heizen = 998 Then Zahl = 65
   If T_heizen = 999 Then Zahl = 66                         '*
   If T_heizen = 1001 Then Zahl = 70                        '*
   If T_heizen = 1002 Then Zahl = 71
   If T_heizen = 1003 Then Zahl = 72
   If T_heizen = 1004 Then Zahl = 73                        '*
   If T_heizen = 1005 Then Zahl = 74
   If T_heizen = 1006 Then Zahl = 76
   If T_heizen = 1007 Then Zahl = 78
   If T_heizen = 1008 Then Zahl = 79                        '*
   If T_heizen = 1009 Then Zahl = 80
   If T_heizen = 1010 Then Zahl = 83
   If T_heizen = 1011 Then Zahl = 86
   If T_heizen = 1012 Then Zahl = 88
   If T_heizen = 1013 Then Zahl = 90
   If T_heizen = 1014 Then Zahl = 92


  If Zahl < 10 Then
     Error_sensor = 4
     Takt_heizen = 10
  End If

  If Zahl > 88 Then
      Error_sensor = 4
      Takt_heizen = 88
  End If

  If Zahl => 10 And Zahl <= 88 Then
      Takt_heizen = Zahl
  End If


'AI4
'890 =           0 Grad
'852 =          19
'853            19,5
'854=           20
'855=           20,5
'856=22 Grad    21
'  5            21,5
'  4 23         22
'  3            22,5
'  2 24         23
'  1            23,5
'  0 25         24
'  9            24,5
'  8 26         25
'  7            25,5
'846=27 Grad    26

'900 - 846 / 2 =27 Grad
'900 = 0 Grad

'856 =15 Grad

'T_Keller  Geber im Heizraum
'KTY 81 210
      'Zahl1 = 865 - T_keller
      Zahl1 = 886 - T_keller
      Takt_keller = Zahl1 / 2
      'Takt_keller = Takt_keller + Zahl1

  If Takt_keller < -10 Then Error_sensor = 5
  If Takt_keller > 30 Then
     Takt_keller = 0
     Error_sensor = 1
  End If


'AI5
'Reserve

'KTY 81 210
      'Zahl1 = 865 - Ai05
      Zahl1 = 886 - Ai_res05
      Takt_reserve = Zahl1 / 2

      If Takt_reserve > 30 Then Takt_reserve = 0

      'Takt_reserve = Takt_reserve + Zahl1



End Sub




'Umlaufpuffer fr max. 2 Monate

Sub Heizung_report()

If Adatum(arcptr) <> _date And _day <> 0 And _day <= 31 And _month <> 0 And _month <= 12 Then
    Arcptr = Arcptr + 1
    If Arcptr >= 63 Then Arcptr = 1

    Br_zeit = 0
    Wa_zeit = 0

    St_wasser = 0
    St_heizen = 0

    Zeit_brenner = 0
    Zeit_heizen = 0
    Zeit_wasser = 0

    T_mittel_innen = 0
    T_mittel_aussen = 0
    T_mittel_wasser = 0
    T_mittel_heizen = 0

    Temp_min_wasser = 0
    Temp_max_wasser = 0

    Temp_min_heizen = 0
    Temp_max_heizen = 0

    Temp_min_innen = 0
    Temp_max_innen = 0

    Temp_min_aussen = 99
    Temp_max_aussen = -99

 End If



 If _min <> Min_old Then
    Min_old = _min

  'Brenner
  If Brenner = 1 Then
     Zeit_brenner = Zeit_brenner + 1

    If H_brenner = 1 Then
        Br_zeit = Br_zeit + 1
    Else
    If W_brenner = 1 And H_brenner = 0 Then
        Wa_zeit = Wa_zeit + 1
    End If
    End If

  End If

  'Wasserpumpe
  If Wasser = 1 Then
     Zeit_wasser = Zeit_wasser + 1
  End If

  'Heizungspumpe
  If Heizen = 1 Then
     Zeit_heizen = Zeit_heizen + 1
  End If

 End If

 'Werte um 8 Uhr
 If _hour = 8 And _min = 5 Then
     Temp_mit_innen = Takt_innen
     Temp_mit_aussen = Takt_aussen
     Temp_mit_wasser = Takt_wasser
     Temp_mit_heizen = Takt_heizen

 End If

 'If _hour <> Std_old Then
 '    Std_old = _hour
 '    Incr Ctemp

 '    Temp_mit_innen = Temp_mit_innen + Takt_innen
 '    Temp_mit_aussen = Temp_mit_aussen + Takt_aussen
 '    Temp_mit_wasser = Temp_mit_wasser + Takt_wasser
 '    Temp_mit_heizen = Temp_mit_heizen + Takt_heizen

 '    T_mittel_innen = Temp_mit_innen / Ctemp
 '    T_mittel_aussen = Temp_mit_aussen / Ctemp
 '    T_mittel_wasser = Temp_mit_aussen / Ctemp
 '    T_mittel_heizen = Temp_mit_aussen / Ctemp

 '    If Std_old = 0 Then Ctemp = 0

 'End If

 If Temp_min_innen = 0 Then Temp_min_innen = 900
 If Temp_min_aussen = 0 Then Temp_min_aussen = 100
 If Temp_min_wasser = 0 Then Temp_min_wasser = 100
 If Temp_min_heizen = 0 Then Temp_min_heizen = 100

 If T_mittel_innen = 0 Then T_mittel_innen = Takt_innen
 If T_mittel_aussen = 0 Then T_mittel_aussen = Takt_aussen
 If T_mittel_wasser = 0 Then T_mittel_wasser = Takt_wasser
 If T_mittel_heizen = 0 Then T_mittel_heizen = Takt_heizen


 If Takt_innen < Temp_min_innen Then Temp_min_innen = Takt_innen
 If Takt_innen > Temp_max_innen Then Temp_max_innen = Takt_innen

 If Takt_wasser < Temp_min_wasser Then Temp_min_wasser = Takt_wasser
 If Takt_wasser > Temp_max_wasser Then Temp_max_wasser = Takt_wasser

 If Takt_heizen < Temp_min_heizen Then Temp_min_heizen = Takt_heizen
 If Takt_heizen > Temp_max_heizen Then Temp_max_heizen = Takt_heizen

 If Takt_aussen < Temp_min_aussen Then Temp_min_aussen = Takt_aussen
 If Takt_aussen > Temp_max_aussen Then Temp_max_aussen = Takt_aussen

 If St_h = 1 Then
    St_h = 0
    St_heizen = St_heizen + 1
 End If

 If St_w = 1 Then
    St_w = 0
    St_wasser = St_wasser + 1
 End If





     Adatum(arcptr) = _date

     Atim_wasser(arcptr) = Zeit_wasser
     Atim_brenner(arcptr) = Zeit_brenner
     Atim_heizen(arcptr) = Zeit_heizen

     Aanz_wasser(arcptr) = St_wasser
     Aanz_brenner(arcptr) = St_heizen

     Amin_i(arcptr) = Temp_min_innen
     Amax_i(arcptr) = Temp_max_innen
     Amit_i(arcptr) = T_mittel_innen

     Amin_a(arcptr) = Temp_min_aussen
     Amax_a(arcptr) = Temp_max_aussen
     Amit_a(arcptr) = T_mittel_aussen

     Amin_w(arcptr) = Temp_min_wasser
     Amax_w(arcptr) = Temp_max_wasser
     Amit_w(arcptr) = T_mittel_wasser

     Amin_h(arcptr) = Temp_min_heizen
     Amax_h(arcptr) = Temp_max_heizen
     Amit_h(arcptr) = T_mittel_heizen

End Sub


Sub Init_eeprom()

Dim H As Byte
Dim L As Byte

'Werte aus dem EEprom lesen
If Eeprom_write = 0 Then
   Eeprom_write = 100

Readeeprom Ti_nachlauf , 2


Readeeprom H , 4
Readeeprom L , 5
Ti_betrieb = H
'Ti_betrieb = H * 255
'Ti_betrieb = Ti_betrieb + L

Readeeprom H , 6
Ti_warten = H

Readeeprom H , 8
Ti_pause = H
'Ti_pause = H * 255
'Ti_pause = Ti_warten + L


Readeeprom Wasser_std_on , 10
Readeeprom Wasser_min_on , 11

Readeeprom Wasser_std_off , 12
Readeeprom Wasser_min_off , 13

Readeeprom Tsol_wasser , 14


Readeeprom H , 104
Readeeprom L , 105
Hti_betrieb = H

Readeeprom H , 106
Hti_warten = H
'Ti_pause = H * 255
'Ti_pause = Ti_warten + L

Readeeprom H1_std_on , 110
Readeeprom H1_min_on , 111

Readeeprom H1_std_off , 112
Readeeprom H1_min_off , 113

Readeeprom Tsol_raum , 114

Readeeprom H , 116
Readeeprom L , 117

If L >= 0 Then
 Korrmin = L
Else
 Korrmin = H * -1
End If

Readeeprom Temp_nacht , 118

End If


'Defaultwerte eintragen
If Eeprom_write = 1 Then
   Eeprom_write = 101

   'Wasser
   '#######

   'Zeiten
   Ti_betrieb = 20                                          'd.h. Brenner luft max. 15 min
   Ti_nachlauf = 40                                         'Nachlauf 20 min
   Ti_pause = 1                                             'Min 1 bis nchster Start ber Temperatur
   Ti_warten = 240                                          'Min. 240 min warten bis zum nchsten Starttzeiten

   Wasser_std_on = 7
   Wasser_min_on = 15
   Wasser_std_off = 18
   Wasser_min_off = 0


   'Grad Tmin = Ein Soll-2    Grad Tmax = Aus  Soll+13
   Tsol_wasser = 55


   'Heizung
   '#######

   Hti_betrieb = 40                                         'd.h. luft max. 20 min
   Hti_warten = 40                                          'd.h. luft 10 min

   H1_std_on = 6
   H1_min_on = 30

   H1_std_off = 20
   H1_min_off = 30

   Tsol_raum = 220
   Temp_nacht = 185

   Korrmin = 0

End If



'EEProm eintragen
If Eeprom_write = 2 Then
   Eeprom_write = 102

Writeeeprom Ti_nachlauf , 2


'H = Ti_betrieb / 255
'L = H * 255
'L = Ti_betrieb - L

H = Ti_betrieb
Writeeeprom H , 4
Writeeeprom L , 5


'H = Ti_warten / 255
'L = H * 255
'L = Ti_warten - L
H = Ti_warten
Writeeeprom H , 6
Writeeeprom L , 7

'H = Ti_pause / 255
'L = H * 255
'L = Ti_pause - L
H = Ti_pause
Writeeeprom H , 8
Writeeeprom L , 9

Writeeeprom Wasser_std_on , 10
Writeeeprom Wasser_min_on , 11
Writeeeprom Wasser_std_off , 12
Writeeeprom Wasser_min_off , 13


Writeeeprom Tsol_wasser , 14


H = Hti_betrieb
Writeeeprom H , 104
Writeeeprom L , 105

H = Hti_warten
Writeeeprom H , 106
Writeeeprom L , 107


Writeeeprom H1_std_on , 110
Writeeeprom H1_min_on , 111
Writeeeprom H1_std_off , 112
Writeeeprom H1_min_off , 113

Writeeeprom Tsol_raum , 114

If Korrmin < 0 Then
   H = Korrmin * -1
   L = 0
   Writeeeprom H , 116
   Writeeeprom L , 117
Else
  H = 0
   Writeeeprom H , 116
  Writeeeprom Korrmin , 117
End If

Writeeeprom Temp_nacht , 118

End If

'Brenner wird bei dieser Wassertemp. eingeschaltet
   Tmin_wasser = Tsol_wasser - 5
'Brenner wird bei dieser Kesselwassertemp ausgeschaltet
'Das Kesselwasser erwrmt das Brauchwasser weiter wenn die
'Wasserpumpe luft
   Tmax_wasser = Tsol_wasser + 5

 'Schaltpunkte fr Raumheizung
   Zahl1 = Tsol_raum                                        'z.B. 220
   Tmin_raum = Zahl1 - 5                                    'z.B. 215
   Tmax_raum = Zahl1 + 5                                    'z.B. 225

End Sub


 'Ablauf
'Step 255  Neustart
'Step 1    Vorlauf d.h. Brenner aus und Wasser ein
'Step 2    Brenner ein und Wasser ein
'Step 3    Nachlauf d.h. Brenner aus und Wasser ein
'Step 4    Wartezeit zum nchsten Start d.h. Brenner aus und Wasser aus
'Step 5    Warten

'Start nur wenn eine Zeitschaltuhr die Freigabe gibt
'Steuerung ber Temperatur oder ber Zeit

'Buderus - Sommerbetrieb
'Wasser =45   Heizung =65
'Der Sensor des Wasserbehlter meldet 45 Grad
'Nun wird die Wasserpumpe eingeschaltet
'Der Brenner luft ca. 5 min bis der Wasserbehlter 65 Grad meldet
'Nachdem der Brenner aus ist luft die Wasserpumpe noch ca. 3 min
'Das Wasser im Behlter braucht ca. 4 Stunden bis es von 65 bis 45 Grad
'abgekhlt ist und ein neuer Zyklus beginnt.
'Am Tag luft der Brenner also ca. 45 min und die Pumpe ca. 60 min
'Der Brenner verbraucht ca. 1,5 qm Gas pro Tag

Sub Heizung_wasser()

   'Wartungslauf der Heizungspumpe im Sommerbetrieb
   'Alle 20 Tage fr 5 min ein
   If Sommer = 1 And Wasser_uhr = 1 Then
      If _day <> Wby_day Then
          Wby_day = _day

          Wday_warten = Wday_warten + 1
          If Wday_warten = 20 Then
            Wday_warten = 0
            H_heizen = 1                                    'Heizungspumpe ein
          End If

         If H_heizen = 1 And _min <> W1by_min Then
           W1by_min = _min
           W1min_warten = W1min_warten + 1
           If W1min_warten >= 5 Then
              W1min_warten = 0
              H_heizen = 0                                  'Heizungspumpe aus
           End If

         End If


       End If
   End If

   'Zeiten bilden
   If _min <> Wby_min Then
      Wby_min = _min

      'Vorlauf
      If Wasser_step = 1 Then
         Wmin_vorlauf = Wmin_vorlauf + 1
      End If


        'Run
      If Wasser_step = 2 Then
         Wmin_betrieb = Wmin_betrieb + 1
      End If

       'Warten
      If Wasser_step = 4 Or Wasser_step = 5 Then
       Wmin_warten = Wmin_warten + 1

       If Ti_pause <= Wmin_warten Then
          Wasser_step = 5
       End If


      End If

      'Nachlauf
      If Wasser_step = 3 Then
         Wmin_nachlauf = Wmin_nachlauf + 1
      End If




       '10 min Warten wenn minimum Wassertemperatur erreicht ist
       If Takt_wasser <= Tmin_wasser Then
            Wasser_z1 = Wasser_z1 + 1
            If Wasser_z1 > 10 Then Wasser_z1 = 100
       Else
            Wasser_z1 = 0
       End If

       '2 min Warten wenn Kesselwasser fr Wassererwrmung erreicht ist
       Zahl1 = Tsol_wasser + 15
       If Takt_heizen >= Zahl1 Then
            Wasser_z2 = Wasser_z2 + 1
            If Wasser_z2 > 1 Then Wasser_z2 = 100
       Else
            Wasser_z2 = 0
       End If

      '30 min Warten wenn absolutes minimum der Vorlauftemperatur erreicht ist
      'Der Brenner erwrmt Kesselwasser (geringe Menge) Mit diesem
      'Kesselwasser werden die Heizkrper und das Brauchwasser erwrmt.
      'Damit es nicht zu Korrosion kommt kann aufgrund spezieller Werkstoffe
      'das Kesselwasser bis 30 Grad abgesenkt werden.
       If Takt_heizen <= 30 And H_mini = 0 Then
            Heiz_z4 = Heiz_z4 + 1
            If Heiz_z4 > 30 Then Heiz_z4 = 100
       Else
            Heiz_z4 = 0
       End If

   End If

   If _sec <> Wby_sec Then
      Wby_sec = _sec

   End If


   'Neustart, wenn Zeit abgelaufen und Zeitschaltuhr in den
   'Tagesbetrieb wechselt
   If Wasser_step = 255 And Wasser_uhr = 1 Then

        If Takt_wasser <= Tmin_wasser Then
            W_wasser = On

            Wasser_step = 1
            Wmin_betrieb = 0
        End If

   End If

  'Vorlauf Fertig wenn Zeit abgelaufen
   'If Wasser_step = 1 And 2 <= Wmin_vorlauf Then
    If Wasser_step = 1 Then
        St_w = 1

        W_brenner = On
        Wa_time = _time

        Wasser_step = 2


        Wmin_vorlauf = 0
        Wmin_nachlauf = 0
        Wmin_betrieb = 0
        Wmin_warten = 0
    End If


   'Run Fertig wenn Temperatur erreicht
   'Es wird das Kesselwasser erwrmt. Dieses Wasser gibt die
   'Wrme an das Brauchwasser ab.
   'Bis das Brauchwasser seine Temperatur erreicht hat dauert
   'es nun ca. 20 min
   'Beispiel: Kesselwasser wird mit Brenner auf ca. 65 Grad erwrmt,
   '          wenn Takt_wasser =50 Grad ist. Ist der Brenner aus luft
   '          die Pumpe noch 20 min und erwrmt das Wasser auf ca. 54 Grad
   '          Luft gleichzeitig die Heizungspumpe wird diese Temperatur
   '          nicht erreicht da nun auch Wrme ber die Heizkrper verloren geht.

   If Wasser_step = 2 And Wasser_z2 = 100 Then
       W_brenner = Off
       Wmin_vorlauf = 0
       Wmin_nachlauf = 0
       Wmin_betrieb = 0
       Wasser_step = 3
   End If

   'Run Fertig wenn Zeit abgelaufen
   If Wasser_step = 2 And Ti_betrieb <= Wmin_betrieb Then
        W_brenner = Off
        Wmin_vorlauf = 0
        Wmin_nachlauf = 0
        Wmin_betrieb = 0
        Wasser_step = 3
   End If


  'Nachlauf Fertig wenn Zeit abgelaufen
   If Wasser_step = 3 And H_mini = 0 And Wmin_nachlauf >= Ti_nachlauf Then
        W_wasser = Off
        Wmin_vorlauf = 0
        Wmin_nachlauf = 0
        Wmin_betrieb = 0
        Wmin_warten = 0
        Wasser_step = 4
   End If

   'Nach 7 min alles wieder aus, wenn Einschaltung durch
   'min. absolute Vorlauftemperatur von 30 Grad erfolgt ist
   'd.h. von 30 auf ca. 40 Grad
   If Wasser_step = 3 And H_mini = 1 And Wmin_nachlauf => 7 Then
       Wasser_step = 5

       W_brenner = Off
       W_wasser = Off

       Wmin_vorlauf = 0
       Wmin_nachlauf = 0
       Wmin_betrieb = 0
       Wmin_warten = 0

       H_mini = 0
   End If




   'Neu Start Wassererwrmung wenn Temperatur zu niedrig ist
   If Wasser_step = 5 And Wasser_z1 = 100 And Wasser_uhr = 1 Then


       Wasser_step = 255
       Wmin_betrieb = 0


   End If

   'Zwangseinschaltung alle 240 min
   'Neu Start Wassererwrmung wenn Wartezeit abgelaufen
   If Wasser_step = 5 And Ti_warten <= Wmin_warten And Wasser_uhr = 1 Then


       Wasser_step = 255
       Wmin_betrieb = 0


   End If

   'Aus wenn Nachtabsenkung
   If Wasser_uhr = 0 And Wasser_step > 3 Then
       Wasser_step = 255                                    'Warten auf Tagbetrieb

       W_brenner = Off
       W_wasser = Off

       Wmin_vorlauf = 0
       Wmin_nachlauf = 0
       Wmin_betrieb = 0
       Wmin_warten = 0

   End If

   'Ein wenn Kesselwasser fr 30 min kleiner 30 Grad
   'Rostschutz rund um die Uhr
   'In 06 min/Brenner von 27 Grad auf 42 Grad
   'In 20 min/Brenner von 27 Grad auf 70 Grad d.h. Wasser von 48 auf 54
   If H_mini = 0 And Heiz_z4 = 100 Then
           St_w = 1

           W_brenner = On                                   'Brenner Ein
           Wa_time = _time

           W_wasser = On                                    'Wasserpumpe Ein
           Wmin_vorlauf = 0
           Wmin_nachlauf = 0
           Wmin_betrieb = 0
           Wasser_step = 3
           H_mini = 1
           Heiz_z4 = 0
   End If



End Sub



Sub Heizung_wasser_time()

     'Einschalten
     If _hour >= Wasser_std_on And _hour < Wasser_std_off And Wasser_uhr = 0 Then
        If _hour = Wasser_std_on And _min >= Wasser_min_on Then
               Wasser_uhr = 1
               Wasser_step = 5
        End If
        If _hour > Wasser_std_on Then
               Wasser_uhr = 1
               Wasser_step = 5
        End If

     End If

     'Ausschalten
     If _hour >= Wasser_std_on And _hour < Wasser_std_off Then
     Else
        If _hour = Wasser_std_off And _min >= Wasser_min_off Then
            Wasser_uhr = 0
        End If
        If _hour <> Wasser_std_off Then
            Wasser_uhr = 0
        End If

     End If





End Sub








Sub Heizung_raum()

'Zeiten bilden
'################

 If _min <> H_min Then
      H_min = _min


         'Verzgerung fr die Heizungspumpe
         '=================================
         If Heizen_on = 1 Then
            Heizen_on_min = Heizen_on_min + 1
            If Heizen_on_min >= 10 Then
               Heizen_on = 2
               Heizen_on_min = 0
            End If

         End If





         'Step =1  Brenner ein
         '====================

         'Ermtteln wie lange der Brenner luft
         If H_brenner = 1 Then
            Hmin_betrieb = Hmin_betrieb + 1
            Hmin_warten = 0
         End If


         'Step =2  Warten nach Brenner ein
         '================================

         'Wartezeit verkrzen damit es schneller Warm wird
         If Heizen_uhr = 1 Then

              Zahl = Tsol_raum - Takt_innen

              Hti_korr = 0                                  '40 min > 21,8

              'Abhngig von der Innentemperatur
              If Zahl > 2 Then Hti_korr = 5                 '35 min <21,8
              If Zahl > 5 Then Hti_korr = 10                '30 min < 21,5
              If Zahl > 10 Then Hti_korr = 15               '25 min < 21,0
              If Zahl > 15 Then Hti_korr = 20               '20 min < 20,5
              If Zahl > 20 Then Hti_korr = 25               '15 min < 20,0

              'Abhngig von der Aussentemperatur
              If Takt_aussen <= 0 Then
                Hti_korr = Hti_korr + 10
              End If
              If Takt_aussen <= -5 Then
                Hti_korr = Hti_korr + 20
              End If

              'If Takt_aussen <= 5 Then
              '  Hti_korr = Hti_korr + 5
              'End If
              'If Takt_aussen > 0 Then
              '  Hti_korr = 10
              'end If
              'If Takt_aussen > 7 Then
              '  Hti_korr = 0
              'End If

              Zahl = Hti_warten - Hti_korr

              'Mindestwartezeit = 5 min
              If Zahl <= 5 Then
               Zahl = 5
              End If


            'Heizung ohne Zeit schalten, wenn Vorlauf zu niedrig
             If Takt_aussen <= 0 Then
             Zahl1 = Tmin_heizen - 5
             If Takt_heizen < Zahl1 Then
               Zahl = 0
             End If
             End If

         End If

         If Heizen_uhr = 0 Then
            Zahl = 30
         End If


         'Wartezeit nachdem der Brenner gelaufen ist
         If Heizen_step = 2 Then
            Hmin_betrieb = 0
            Hmin_warten = Hmin_warten + 1
            If Hmin_warten > Zahl Then
               Hmin_warten = 0
               Heizen_step = 0
            End If
         End If



       '
       '2 min Warten wenn Vorlauf zu niedrig
       If Takt_heizen <= Tmin And Heizen_step = 0 Then
         Heiz_z1 = Heiz_z1 + 1
         If Heiz_z1 > 2 Then Heiz_z1 = 100
       Else
         Heiz_z1 = 0
       End If

       '1 min Warten wenn maximum der Vorlauftemperatur erreicht ist
       If H_brenner = 1 And Takt_heizen => Tmax Then
            Heiz_z2 = Heiz_z2 + 1
            If Heiz_z2 > 1 Then Heiz_z2 = 100
       Else
            Heiz_z2 = 0
       End If

       '5 min Warten wenn maximum der Raumtemperatur erreicht ist
       If H_brenner = 1 And Takt_innen => Tmax_raum Then
            Heiz_z3 = Heiz_z3 + 1
            If Heiz_z3 > 5 Then Heiz_z3 = 100
       Else
            Heiz_z3 = 0
       End If



 End If





'Tagesbetrieb und Nachtbetrieb
'#############################


If Heizen_uhr = 1 Or Heizen_uhr = 0 Then


      If Heizen_uhr = 0 And H_tag = 1 Then
        H_tag = 0
      End If

      If Heizen_uhr = 1 Then

         'Ein wenn Umschaltung auf Tagesbetrieb
         If H_tag = 0 Then
            H_tag = 1
            Heizen_on = 2
         End If

         'Innentemperatur zu hoch
         If Takt_innen >= Tsol_raum And Heizen_on = 1 Then
             Heizen_on = 0
             Heizen_on_min = 0
         End If

         'Sofort Ein da Innentemperatur unter Minimum
         If Takt_innen <= Tmin_raum And H_heizen = 0 Then
            Heizen_on = 2
         End If

         'Ein nach Wartezeit
         If Takt_innen <= Tsol_raum And Heizen_on = 0 And H_heizen = 0 Then
            Heizen_on = 1
            Heizen_on_min = 0
         End If

     End If

     '##################
     'Pumpe Ein
     '##################

     'Heizungspumpe ein
     If Heizen_uhr = 1 And Heizen_on = 2 And Takt_aussen < 17 Then

          'Heizungspumpe ein
          H_heizen = 1

          Heizen_on = 0

      End If

     'Nachtabsenkung
     'Temp_nacht=185   d.h. 18,5 Grad
     If Heizen_uhr = 0 And Takt_innen <= Temp_nacht And Takt_aussen < 0 Then

          'Heizungspumpe ein
          H_heizen = 1

          Heizen_on = 0


      End If




    'Brenner evtl. einschalten
    'Step =0 Warten auf Brenner Einschaltung
    'Step =1 Brenner ein
    'Step =2 Pause bis nchster Start mglich

    If Heizen_step = 0 Then

     'Brenner ein wenn VorlaufTemperatur zu niedrig und Raumtemperatur zu niedrig
     'Brenner luft ca. 6 min um von 60 bis 67 Grad zu heizen Verbrauch ca 0,15 qm
     'bis die Temperatur wieder unter 60 geht dauert es dann ca. 30 min
      If Heizen_uhr = 1 And H_heizen = 1 And Heiz_z1 = 100 And Takt_innen <= Tsol_raum Then
          H_brenner = 1
          Heizen_step = 1
          Br_time = _time
          Heiz_z1 = 0
      End If



      'Nachtabsenkung (Frostschutz und zu starkes auskhlen in der Nacht)
      Zahl = Temp_nacht - 10                                'Z.b. 175 = 17 , 5 Grad
      If Heizen_uhr = 0 And H_heizen = 1 And Takt_innen <= Zahl And Heiz_z1 = 100 Then
          H_brenner = 1
          Heizen_step = 1
          Br_time = _time
          Heiz_z1 = 0
      End If


    End If





    'Erhhung bis Raumtemperatur erreicht ist
    'Damit wird schneller geheizt
    Tmax_korr = Tsol_raum - Takt_innen
    If Tmax_korr < 0 Or Tmax_korr <= 15 Then
       Tmax_korr = 0
    End If

   'Z.B. 22 Grad Soll   Temp=16,17
    If Tmax_korr > 30 Then
       Tmax_korr = 10
    End If
    'Z.B. 22 Grad Soll   Temp=18,19
    If Tmax_korr > 15 And Tmax_korr <= 30 Then
       Tmax_korr = 5
    End If

    'If Heizen_uhr = 1 Then
      'Temperatur zu niedrig
     ' If Zahl >= 5 Then
      '   Tmax_korr = 5
      'End If
      'If Zahl >= 10 Then
      '   Tmax_korr = 10
     ' End If
      'If Zahl >= 20 Then
      '   Tmax_korr = 15
      'End If

      'Temperatur zu hoch
      'If Zahl < 0 Then
      ' Tmax_korr = 55 - Tmax_heizen
      'End If

   ' End If


    Zahl = Tmax_heizen + Tmax_korr
    If Zahl => 85 Then
       Tmax_korr = 85 - Tmax_heizen
       'Tmin_korr = Tmax_korr / 3
       'Tmin_korr = Tmin_korr * 2

    End If

    If Heizen_uhr = 1 Then
         Tmin_korr = 0
         If Tmax_korr > 5 Then
            If Tmin_heizen <= 65 Then Tmin_korr = 5
         End If

         Tmax = Tmax_heizen + Tmax_korr
         Tmin = Tmin_heizen + Tmin_korr
         If Tmin < 30 Then Tmin = 30
         If Tmax > 85 Then Tmax = 85
    Else
         'Nachts

               Tmax = 55
               Tmin = 35

         If Takt_aussen < -5 Then
               Tmax = 65
               Tmin = 40
         End If

    End If

    'Brenner aus wenn max. der Vorlauftemperatur erreicht ist
    If H_brenner = 1 And Heiz_z2 = 100 Then
       H_brenner = 0
       Heizen_step = 2                                      'Wartezeit
       St_fh = 0
       Heiz_z2 = 0
    End If

    'Brenner aus luft zu lange
    If H_brenner = 1 And Hmin_betrieb >= Hti_betrieb Then
       H_brenner = 0
       Heizen_step = 2                                      'Wartezeit
       St_fh = 0
    End If



   '#####################
   'Abschaltung
   '#####################


      Heiz_meld = "Aus: min<Tv<max "


    'Zwangsabschaltung und Meldungen

      'Wartezeit bis Brenner ein
      If Heiz_z1 > 0 And Heiz_z1 < 100 Then
         Zahl = 3 - Heiz_z1
         Heiz_meld = "Tv<Tmin " + Str(zahl) + " min "
      End If

     'Wartezeit bis Pumpe ein
      If Heizen_on = 1 Then
         Zahl = 10 - Heizen_on_min
         Heiz_meld = "TI<Tsoll " + Str(zahl) + " min "
      End If

      'Keine Heizung notwendig da zu Warm
      'Meist im Mrz, April und September, Oktober
    '  If Takt_aussen > 17 And Takt_innen > Tsol_raum Then
       If Takt_aussen => 15 And Takt_innen > 210 Then
         H_brenner = 0                                      'Brenner aus
         H_heizen = 0                                       'Heizungspumpe aus
         Heizen_step = 0
         Heizen_on = 0
         Heizen_on_min = 0
         Heiz_meld = "Aus: TA=>15 Grad"
      End If


      'Zwangsabschaltung innen zu warm    Winter
      If Takt_innen >= Tsol_raum And Takt_aussen < 18 Then
         Heiz_meld = "Aus: TI>Tsoll   "
      End If

      'Zwangsabschaltung innen 5 min ber maximale Raumtemperatur
      If Heiz_z3 = 100 Then
         H_brenner = 0                                      'Brenner aus
         Heizen_step = 0
         Heizen_on = 0
         Heizen_on_min = 0
         Heiz_meld = "Aus: TI>maximum "
      End If

      'Nachtabsenkung mit Forstschutz luft
      If Heizen_uhr = 0 And H_heizen = 1 Then
          Heiz_meld = "Ein: Frotsschutz"
      End If

      'Heizungspumpe aus wenn Wasser Nachlauf luft
      'Wrme komplett fr die Wassererwrmung nutzen
      If H_heizen = 1 And W_brenner = 1 Then
         H_sperr = 1
         H_heizen = 0
      End If
      If H_heizen = 0 And H_sperr = 1 And W_brenner = 0 Then
         H_sperr = 0
         H_heizen = 1
      End If


      'Zwangsabschaltung Nachtbetrieb
      Zahl = Temp_nacht + 10                                'D.h. 195 = 19 , 5
      If Takt_innen > Zahl And Heizen_uhr = 0 And Heizen_step = 0 Then
         H_brenner = 0                                      'Brenner aus
         H_heizen = 0                                       'Heizungspume aus
         Heizen_step = 0
         Heizen_on = 0
         Heizen_on_min = 0
         H_sperr = 0
         Heiz_meld = "Nachtabsenkung  "
      End If




End If










'Schaltspiele zhlen
If H_brenner = 1 And St_fh = 0 Then
          St_fh = 1
          St_h = 1
End If



End Sub





Sub Heizung_raum_time()

     'Damit nach der Nachtabsenkung der Raum
     'aufgeheizt wird, wird je nach Aussentemperatur
     'frher mit dem Tagesbetrieb begonnen
     If Heizen_uhr = 0 Then
         Zahl1 = 0
         If Takt_aussen < 0 Then
            Zahl1 = -1
         End If
         If Takt_aussen < -5 Then
            Zahl1 = -2
         End If

         H1_std = H1_std_on + Zahl1

     End If


     'Einschalten
     If _hour >= H1_std And _hour < H1_std_off And Heizen_uhr = 0 Then
        If _hour = H1_std And _min >= H1_min_on Then
               Heizen_uhr = 1
        End If
        If _hour > H1_std Then
             Heizen_uhr = 1
        End If
     End If

     'Ausschalten
     If _hour >= H1_std And _hour < H1_std_off Then
     Else
        If _hour = H1_std_off And _min >= H1_min_off Then
            Heizen_uhr = 0
        End If
         If _hour <> H1_std_off Then
            Heizen_uhr = 0
        End If
     End If

    'Heizen ber Bedienung steuern
    If M_tagnacht = 1 Then
       Heizen_uhr = 1
    End If
    If M_tagnacht = 2 Then
       Heizen_uhr = 0
    End If



End Sub



'############################################
'Option - Kopplung zum PC
'############################################


Sub Com1_init()

    Sendtext = "Init Com1 19200 Baud 8N1 "
    Com1_send Sendtext

End Sub


Sub Com1_send(byval Text As String)

    If Len(_date) < 8 Then _date = "00.00.00"
    If Len(_time) < 8 Then _time = "00:00:00"

    Printtext = _date
    Printtext = Printtext + ";"
    Printtext = Printtext + _time
    Printtext = Printtext + ";"
    Printtext = Printtext + Sendtext

    'With manual CR and LF
    'no Semikole is autom. CR and LF
    'Geht aber scheinbar nicht richtig
    Print #1 , Printtext ; Chr(cr) ; Chr(lf);


End Sub



Function Com1_recv() As Integer

   Remote_key = Inkey(#1)

   If Remote_key <> Remote_key_old Then
      Remote_key_old = Remote_key
       Com1_recv = Remote_key
       Sendtext = "Receive from PC: " + Str(remote_key)
       Com1_send Sendtext
   Else
       Com1_recv = 0
   End If

End Function




Sub Com_user()

    'Reaktion auf Befehle vom PC
    Rkey = Com1_recv()
    If Rkey = 86 Then                                       'V - Variable
        Com_send_cycl 1
    End If
    If Rkey = 80 Then                                       'P - Parameter ""
        Com_send_para 1
    End If
    If Rkey = 65 Then                                       'A - Archiv ""
        Com_send_arch 1
    End If

    'Zyklisch Senden an den PC
    Com_send_cycl 0



End Sub


'Zyklischen werden die Betriebswerte gesendet
'oder wenn PC ein V sendet
Sub Com_send_cycl(fkt As Integer)

If _sec <> _sendsec Then
   _sendsec = _sec
   Sendsec = Sendsec + 1
End If

If Sendsec => 30 Or Fkt = 1 Then
   Sendsec = 0

   Sendtext = "V001;" + Str(takt_innen)
   Sendtext = Sendtext + ";AI00 Temperatur Wohnen"
   Com1_send Sendtext

   Sendtext = "V002;" + Str(takt_aussen)
   Sendtext = Sendtext + ";AI01 Temperatur Aussen"
   Com1_send Sendtext

   Sendtext = "V003;" + Str(takt_wasser)
   Sendtext = Sendtext + ";[C] AI02 Temperatur Wasser"
   Com1_send Sendtext

   Sendtext = "V004;" + Str(takt_heizen)
   Sendtext = Sendtext + ";[C] AI03 Temperatur Heizen"
   Com1_send Sendtext

   Sendtext = "V005;" + Str(do06)
   Sendtext = Sendtext + ";[C] DO06 Brenner"
   Com1_send Sendtext

   Sendtext = "V006;" + Str(do05)
   Sendtext = Sendtext + ";DO05 Wasserpumpe"
   Com1_send Sendtext

   Sendtext = "V007;" + Str(do04)
   Sendtext = Sendtext + ";DO04 Heizungspumpe"
   Com1_send Sendtext

   Sendtext = "V008;" + Str(sommer)
   Sendtext = Sendtext + ";Sommer(1)/Winter(0)"
   Com1_send Sendtext

   Sendtext = "V009;" + Str(wasser_uhr)
   Sendtext = Sendtext + ";Wasser Tag(1)/Nacht(0)"
   Com1_send Sendtext


   Sendtext = "V010;" + Str(heizen_uhr)
   Sendtext = Sendtext + ";Heizen Tag(1)/Nacht(0)"
   Com1_send Sendtext

   Sendtext = "V011;" + Str(notbetrieb)
   Sendtext = Sendtext + ";Notbetrieb Aus(0) Stufe 1-7"
   Com1_send Sendtext


   '####Wasser###

   Sendtext = "V012;" + Str(wasser_step)
   Sendtext = Sendtext + ";Step Wasser"
   Com1_send Sendtext


   If Wasser_step = 1 Then
   Czahl = Ti_nachlauf - Wmin_vorlauf
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[sec] Wasser Vorlaufzeit"


   End If

   If Wasser_step = 2 Then
   Czahl = Ti_betrieb - Wmin_betrieb
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Wasser Betriebszeit"
   End If

   If Wasser_step = 3 Then
   Czahl = Ti_nachlauf - Wmin_nachlauf
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[sec] Wasser Nachlaufzeit"
   End If

   If Wasser_step = 4 Then
   Czahl = Ti_pause - Wmin_warten
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Wasser Pausenzeit"
   End If

   If Wasser_step = 5 Then
   Czahl = Ti_warten - Wmin_warten
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Wasser Wartezeit"
   End If

   Com1_send Sendtext

   '####Heizen###


   Sendtext = "V014;" + Str(tmin_heizen)
   Sendtext = Sendtext + ";[C] Tmin Heizen Vorlauf"
   Com1_send Sendtext

   Sendtext = "V015;" + Str(tmax_heizen)
   Sendtext = Sendtext + ";[C] Tmax Heizen Vorlauf"
   Com1_send Sendtext

   Sendtext = "V016;" + Str(heizen_step)
   Sendtext = Sendtext + ";Step Wasser"
   Com1_send Sendtext



   If Heizen_step = 1 Then
   Czahl = Hti_betrieb - Hmin_betrieb
   Sendtext = "V017;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Heizen Betriebszeit"
   End If

   If Heizen_step = 2 Then
   Czahl = Hti_warten - Hmin_warten
   Sendtext = "V017;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Heizen Pausenzeit"
   End If

   If Heizen_step = 3 Then
   Czahl = Hmin_warten
   Sendtext = "V017;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Heizen Wartezeit"
   End If


End If

End Sub

'Wenn PC ein P sendet dann die Parameterwerte zurck
Sub Com_send_para(fkt As Integer)


'####Wasser####

   Cdatum = Str(wasser_std_on) + ":" + Str(wasser_min_on) + ":00"

   Sendtext = "P001;" + Cdatum
   Sendtext = Sendtext + ";Tagesbetrieb Ein"
   Com1_send Sendtext

     Cdatum = Str(wasser_std_off) + ":" + Str(wasser_min_off) + ":00"
   Sendtext = "P002;" + Cdatum
   Sendtext = Sendtext + ";Nachtbetrieb Ein"
   Com1_send Sendtext

   Sendtext = "P003;" + Str(tsol_wasser)
   Sendtext = Sendtext + ";[C] Soll Wassertemperatur"
   Com1_send Sendtext

   Sendtext = "P004;" + Str(ti_betrieb)
   Sendtext = Sendtext + ";[min] Zeit Brenner Ein"
   Com1_send Sendtext

   Sendtext = "P005;" + Str(ti_pause)
   Sendtext = Sendtext + ";[min] Zeit Brenner Pause"
   Com1_send Sendtext

   Sendtext = "P006;" + Str(ti_nachlauf)
   Sendtext = Sendtext + ";[sec] Vor-/Nachlaufzeit"
   Com1_send Sendtext

   Sendtext = "P007;" + Str(ti_warten)
   Sendtext = Sendtext + ";[min] Wartezeit"
   Com1_send Sendtext




'####Heizen###


    Cdatum = Str(h1_std_on) + ":" + Str(h1_min_on) + ":00"

   Sendtext = "P008;" + Cdatum
   Sendtext = Sendtext + ";Tag Betrieb Ein"
   Com1_send Sendtext

   Cdatum = Str(h1_std_off) + ":" + Str(h1_min_off) + ":00"

   Sendtext = "P009;" + Cdatum
   Sendtext = Sendtext + ";Nachtbetrieb Ein"
   Com1_send Sendtext

   Sendtext = "P010;" + Str(tsol_raum)
   Sendtext = Sendtext + ";[C] Soll Raumtemperatur Tag"
   Com1_send Sendtext

   Sendtext = "P011;" + Str(temp_nacht)
   Sendtext = Sendtext + ";[C] Soll Raumtemperatur Nacht"
   Com1_send Sendtext





End Sub



'Wenn PC ein A sendet dann die Parameterwerte zurck
Sub Com_send_arch(fkt As Integer)

   Nx = 0
   For Ix = 1 To 62
     If Len(adatum(ix)) > 0 Then
       Incr Nx
     End If
   Next Ix

          Sendtext = Str(nx)
          Sendtext = Sendtext + ";Tage im Archiv"
          Com1_send Sendtext



     For Ix = 1 To 62

      If Len(adatum(ix)) > 0 Then

          Text = "A000;" + Adatum(ix)
          Sendtext = Text
          Sendtext = Sendtext + ";Archivname"
          Com1_send Sendtext

          Sendtext = "A001;"
          Sendtext = Sendtext + Str(aanz_wasser(ix) )
          Sendtext = Sendtext + ";Anzahl Schaltungen Wasserpumpe"
          Com1_send Sendtext


          Sendtext = "A002;"
          Sendtext = Sendtext + Str(aanz_brenner(ix))
          Sendtext = Sendtext + ";Anzahl Schaltungen Brenner"
          Com1_send Sendtext

          Sendtext = "A003;"
          Sendtext = Sendtext + Str(atim_wasser(ix))
          Sendtext = Sendtext + ";[min] Time Wasserpumpe"
          Com1_send Sendtext

          Sendtext = "A004;"
          Sendtext = Sendtext + Str(atim_brenner(ix))
          Sendtext = Sendtext + ";[min] Time Brenner"
          Com1_send Sendtext

          Sendtext = "A005;"
          Sendtext = Sendtext + Str(atim_heizen(ix))
          Sendtext = Sendtext + ";[min] Time Heizungspumpe"
          Com1_send Sendtext

          Sendtext = "A006;"
          Sendtext = Sendtext + Str(amin_i(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Innen"
          Com1_send Sendtext

          Sendtext = "A007;"
          Sendtext = Sendtext + Str(amax_i(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Innen"
          Com1_send Sendtext

          Sendtext = "A008;"
          Sendtext = Sendtext + Str(amit_i(ix))
          Sendtext = Sendtext + ";[C] Temperatur 8 Uhr Innen"
          Com1_send Sendtext

          Sendtext = "A009;"
          Sendtext = Sendtext + Str(amin_a(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Aussen"
          Com1_send Sendtext

          Sendtext = "A010;"
          Sendtext = Sendtext + Str(amax_a(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Aussen"
          Com1_send Sendtext

          Sendtext = "A011;"
          Sendtext = Sendtext + Str(amit_a(ix))
          Sendtext = Sendtext + ";[C] Temperatur 8 Uhr Aussen"
          Com1_send Sendtext

          Sendtext = "A012;"
          Sendtext = Sendtext + Str(amin_w(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Wasser"
          Com1_send Sendtext

          Sendtext = "A013;"
          Sendtext = Sendtext + Str(amax_w(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Wasser"
          Com1_send Sendtext

          Sendtext = "A014;"
          Sendtext = Sendtext + Str(amit_w(ix))
          Sendtext = Sendtext + ";[C] Temperatur 8 Uhr Wasser"
          Com1_send Sendtext

          Sendtext = "A015;"
          Sendtext = Sendtext + Str(amin_h(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Heizungs Vorlauf"
          Com1_send Sendtext

          Sendtext = "A016;"
          Sendtext = Sendtext + Str(amax_h(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Heizungs Vorlauf"
          Com1_send Sendtext

          Sendtext = "A017;"
          Sendtext = Sendtext + Str(amit_h(ix))
          Sendtext = Sendtext + ";[C] Temperatur 8 Uhr Heizungs Vorlauf"
          Com1_send Sendtext


       End If
      Next Ix


End Sub















'#############################
'Modul Ende
'#############################

End