'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_User.bas                                                    !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Anwendung:         AT_Test                                                             !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'



$regfile = "m2561def.dat"                                   ' specify the used micro


$include "AT_IO.bas"

$include "User_var.bas"
$include "User_com.bas"
$include "User_men.bas"







'###################################################
'Funktionen definieren
'###################################################

Declare Sub Usercycle()


Declare Sub Temperatur_control()

Declare Sub Init_eeprom()

Declare Sub Heizung()

Declare Sub Heizung_report()

Declare Sub Heizung_wasser()
Declare Sub Heizung_wasser_time()

Declare Sub Heizung_raum()
Declare Sub Heizung_raum_not()
Declare Sub Heizung_raum_time()




'###################################################

'Allgemeines

Dim Arcptr As Integer


'Steuerung Sommer/Winterbetrieb d.h. nur Wasser erwaermen
Dim Minsom As Byte
Dim Min_som_u As Byte
Dim Min_som_o As Byte


'Zeit Istwerte
Dim Wby_sec As Byte
Dim Wby_day As Byte
Dim Wby_min As Byte
Dim W1by_min As Byte

Dim Wday_warten As Byte
Dim W1min_warten As Byte
Dim Wasser_z1 As Byte
Dim Wasser_z2 As Byte




Dim W_brenner As Bit
Dim W_wasser As Bit


Dim Takt_aussen_old As Integer
Dim Takt_aussen_c As Integer
Dim Takt_innen_old As Integer
Dim Takt_innen_c As Integer
Dim Takt_innen_nk As Integer


Dim H_min As Byte

Dim St_fh As Bit


Dim H_brenner As Bit
Dim H_heizen As Bit
Dim Htu_heizen As Byte
Dim Heizen_on As Byte
Dim Heizen_on_min As Byte
Dim H_tag As Bit
Dim H_sperr As Bit
Dim H_mini As Bit
Dim Tmax As Byte
Dim Tmin As Byte

'Bericht

Dim Min_old As Byte
Dim Std_old As Byte



Dim St_h As Bit
Dim St_w As Bit

Dim Ctemp As Byte


Dim Htemp_min As Byte
Dim Htemp_wait As Byte



Dim Rkey As Integer

Dim Heiz_z1 As Byte
Dim Heiz_z2 As Byte
Dim Heiz_z3 As Byte

Dim Zahl11 As Integer
Dim Zahl12 As Integer
Dim Zahl21 As Integer
Dim Zahl22 As Integer


Goto Enduser


'##################################
'User Program
'##################################

Sub Usercycle()
  Local F As Integer

  'Nach einem Neustart das Startlogo eine Zeitlang anzeigen
  '###########################
  'User_Men.bas
  F = Logo()
  If F = On Then Exit Sub

  'Zeiteingabe anfordern
  '###########################
  'User_Men.bas
   Clock_control




   'Empfang vom PC  und Senden an den PC
   '#####################################

    'Reaktion auf Befehle vom PC
    Rkey = Com1_recv()
    If Rkey = 86 Then                                       'V - Variable
        Com_send_cycl 1
    End If
    If Rkey = 80 Then                                       'P - Parameter ""
        Com_send_para 1
    End If
    If Rkey = 65 Then                                       'A - Archiv ""
        Com_send_arch 1
    End If

    'Zyklisch Senden an den PC
    Com_send_cycl 0



  'Daten mit dem EEProm austauschen
  '##################################
  'user_prog.bas
  Init_eeprom

  'Anzeigen von Werten
  '##################################
  'user_men.bas
  Menue

  'Temperatur einlesen und normieren
  '##################################
  'User_prog.bas
  Temperatur_control

  'Heizung steuern
  '##################################
  'user_prog.bas
  Heizung



End Sub






Sub Heizung()
  Dim Som As Bit

'Wenn Wahlschalter in Stellung 3 -12.... knnen die Ausgaenge
'im Testbetrieb geschaltet werden
'Automatikfunktionen muessen unwirksam sein, da sie evtl. die
'Ausgnge verndern

   'Im Mai, Juni,Juli,August ist Sommer d.h. Heizung nicht ntig
   If _month = 5 Or _month = 6 Or _month = 7 Or _month = 8 Then
      Som = 1
      Somwin = 0
   End If
   'Im Jan, Feb, Mrz, Nov, Dez ist Winter mit Heizung
   If _month = 1 Or _month = 2 Or _month = 3 Or _month = 10 Or _month = 11 Or _month = 12 Then
      Som = 0
      Somwin = 0
   End If

   'In den bergangsmonaten abhngig von der Raumtemperatur
   'April, Sept
   If _month = 0 Or _month = 4 Or _month = 9 Then
        Som = 0
        Somwin = 1
   End If

   'Automatisch oder von Hand einstellen
   If Summer = 0 Then Sommer = Som
   If Summer = 1 Then Sommer = 1
   If Summer = 2 Then Sommer = 0

   'Wasser erwrmen im sommer und im Winter
   '########################################
   Heizung_wasser_time

   Heizung_wasser


   'Damit dies fr alle Temperaturen funktioniert
   'muss der Kesselwassertemperaturregler auf 90 Grad
   'eingestellt sein

   'Temperatur in Abhngigkeit von der Aussentemperatur
   'Dies sind die Basiswerte, welche aufgrund der
   'Innentemperatur angepasst werden
   If Takt_aussen > 15 Then
      Htu_heizen = 30
      Tmin_heizen = 45
      Tmax_heizen = 52
   End If

   If Takt_aussen > 10 And Takt_aussen <= 15 Then
      Htu_heizen = 30
      Tmin_heizen = 50
      Tmax_heizen = 57
   End If

   If Takt_aussen > 5 And Takt_aussen <= 10 Then
      Htu_heizen = 35
      Tmin_heizen = 55
      Tmax_heizen = 62
   End If

   If Takt_aussen > 0 And Takt_aussen <= 5 Then
      Htu_heizen = 34
      Tmin_heizen = 60
      Tmax_heizen = 67
   End If

   If Takt_aussen > -5 And Takt_aussen <= 0 Then
      Htu_heizen = 40
      Tmin_heizen = 65
      Tmax_heizen = 70
   End If

   If Takt_aussen > -10 And Takt_aussen <= -5 Then
      Htu_heizen = 45
      Tmin_heizen = 70
      Tmax_heizen = 75
   End If

   If Takt_aussen > -15 And Takt_aussen <= -10 Then
      Htu_heizen = 45
      Tmin_heizen = 75
      Tmax_heizen = 80
   End If
   If Takt_aussen <= -15 Then
      Htu_heizen = 50
      Tmin_heizen = 80
      Tmax_heizen = 85
   End If



   'Heizung nur im Winter und der bergangszeit
   '###########################################
   If Sommer = 0 Then
      'Raumheizung nur im Winter
      Heizung_raum_time
      If Notbetrieb > 0 Then
       Heizung_raum_not
      Else
       Heizung_raum
      End If
   Else
      Heiz_meld = "Aus: Sommer     "

      H_heizen = 0
      H_brenner = 0
   End If

   Heizung_report


'Wahlschalter in Stellung 3 ist Handbetrieb
'd.h. Ausgnge werden nun nicht mehr von der
'Automatik gesteuert
If Wxx <> 3 Then


   'Ausgnge schalten
   Wasser = W_wasser Or M_wasser
   Brenner = W_brenner Or H_brenner
   Brenner = Brenner Or M_brenner
   Heizen = H_heizen Or M_heizen

End If



End Sub

'Messgeber KTY 81 210
' 70 Grad 819  (Errechnet)

' 40 Grad 839  (Gemessen)
' 25 Grad 849  (Gemessen)
'
'                    1 Digit = 1,5 Grad     865= 0 Grad
'
'
'

' - 40 Grad  889 (Errechnet)


'Messgeber fr T_wasser  Wassertank
' 40 Grad 967  (Gemessen)
' 62 Grad 979  (Vergleich mit KTY)
'

'  0 Grad = 865      bis 955   gilt t= w - 869 / 3
'  5 Grad = 880      ab  955   gilt t= w - 955 + 30
' 10 Grad = 895
' 15 Grad = 910
' 20 Grad = 926
' 25 Grad = 940

' 30 Grad = 955
' 40 Grad = 965
' 50 Grad = 975
' 60 Grad = 985
' 70 Grad = 995
' 80 Grad = 1005
' 90 Grad = 1015

'Messgeber fr T_raum    Wohnzimmer
' 0 Grad = 850      t=w-845 / 4
' 5 Grad = 870
'10 Grad = 890
'15 Grad = 910    880 ohm
'20 Grad = 930   1020 ohm
'21 Grad = 930                w- 845 / 4
'22 Grad = 930
'25 Gred = 950
'30 Grad = 970
'35 Grad = 990

'Messgeber fr T_aussen
' 1 Grad = 25 Ohm = 2,5
'Ohm    Wert
'2000=  825
'1000=  925
'0500=  975
'0250= 1000

'24 Grad   500 Ohm               975
'23
'22
'21
'20*Grad = 600 611 Ohm 959       965  1 Grad = 25 Ohm = 2,5
'19                    956
'18                    953
'17                    950
'16        700         947       955
'15 Grad =             944
'14 Grad =     790 Ohm 941
'13*Grad =     815 Ohm 938
'12 Grad = 800 840 ohm 935       945
'11
'10
'09
'08 Grad = 900 Ohm               935
'07
'06
'05
'04        1000 ohm              925
'03
'02
'01
'00 Grad   1100                  915
'01
'02
'03
'04        1200                  905

Sub Temperatur_control()



'AI0
'T_innen Geber im Wohnzimmer

   'Zahl = T_innen - 843                                     '13.10.11 von 844 nach 843
   'Zahl = Zahl / 4

   Zahl = T_innen - 925
   Zahl = Zahl * 3
   Zahl = Zahl + 200


   'Anfangswerte setzen nach Steuerungsneustart
   If Takt_innen_old = 0 And Takt_innen = 0 Then
     Takt_innen = Zahl
     Zahl11 = Takt_innen - 60
     Zahl12 = Takt_innen + 60
     Br_time = _time
     Wa_time = _time
   End If


   'Fehlmessungen
   If Zahl < 50 Then
      Zahl = Takt_innen
      Error_sensor = 1
   End If

   If Zahl > 280 Then
      Zahl = Takt_innen
      Error_sensor = 1
   End If




  'Messung ausfhren
   If Zahl > Zahl11 And Zahl < Zahl12 Then
    Takt_innen_c = Takt_innen_c + 1
    Takt_innen_old = Takt_innen_old + Zahl
   End If

  If Takt_innen_c > 100 Then
    Takt_innen_old = Takt_innen_old / Takt_innen_c

     If Takt_innen_old > Takt_innen Then
      Takt_innen = Takt_innen + 3
     End If
     If Takt_innen_old < Takt_innen Then
      Takt_innen = Takt_innen - 3
     End If



    Zahl11 = Takt_innen - 30
    Zahl12 = Takt_innen + 30

    Takt_innen_c = 0
    Takt_innen_old = 0
  End If




'AI1
'T_aussen Geber an der Hauswand
'Gemessen 955=27 Grad
'Gemessen 944=22 Grad
'Gemessen 928=14 Grad
'Gemessen 937=18 Grad
'Gemessen 900=1  Grad

  Zahl = T_aussen - 900                                     '944
  Zahl = Zahl / 2

 'Anfangswerte setzen nach Steuerungsneustart
  If Takt_aussen_old = 0 And Takt_aussen = 0 Then
     Takt_aussen = Zahl

     Zahl21 = Takt_aussen - 6
     Zahl22 = Takt_aussen + 6

  End If

  'Fehlmessungen
   If Zahl < -25 Then
      Zahl = Takt_aussen
      Error_sensor = 2
   End If

   If Zahl > 35 Then
      Zahl = Takt_aussen
      Error_sensor = 2
   End If






  'Messung ausfhren
   If Zahl => Zahl21 And Zahl < Zahl22 Then
    Takt_aussen_c = Takt_aussen_c + 1
    Takt_aussen_old = Takt_aussen_old + Zahl
   End If





   If Takt_aussen_c > 100 Then
    Takt_aussen_old = Takt_aussen_old / Takt_aussen_c

    If Takt_aussen_old > Takt_aussen Then
      Takt_aussen = Takt_aussen + 1
    End If
    If Takt_aussen_old < Takt_aussen Then
      Takt_aussen = Takt_aussen - 1
    End If

    Zahl21 = Takt_aussen - 4
    Zahl22 = Takt_aussen + 6

    Takt_aussen_c = 0
    Takt_aussen_old = 0

  End If





'AI2
'T_wasser Geber am Wassertank




 '  If T_wasser < 955 Then
 '  Takt_wasser = T_wasser - 869
 '  Takt_wasser = Takt_wasser / 3
 '  Else
 '  Takt_wasser = T_wasser - 954
 '  Takt_wasser = Takt_wasser + 30
 '  End If


  'Umwandlung auf Wassertemperatur, wenn der Geber direkt an der
  'Wasserpumpe angeschlossen ist, ist keine Korrektur notwendig.

  'Umwendlung auf Wassertemperatur, wenn der Geber am
  'Wassertank angeschlossen ist
   'Takt_wasser = Takt_wasser + 15

   If T_wasser >= 910 And T_wasser <= 915 Then
     Takt_wasser = 13
   End If
   If T_wasser > 915 And T_wasser <= 920 Then
     Takt_wasser = 18
   End If
   If T_wasser > 920 And T_wasser <= 930 Then
     Takt_wasser = 23
   End If
   If T_wasser > 930 And T_wasser <= 940 Then
     Takt_wasser = 28
   End If
   If T_wasser > 950 And T_wasser < 970 Then
     Takt_wasser = 33
   End If

   If T_wasser => 970 Then                                  'Grsser 33 Grad
    Zahl = T_wasser - 982
    Takt_wasser = Zahl + 48
   End If


  'Umwandlung auf Wassertemperatur, wenn der Geber am
  'Wassertank angeschlossen ist
   Takt_wasser = Takt_wasser - 3

  If Takt_wasser < 10 Then Error_sensor = 3
  If Takt_wasser > 85 Then Error_sensor = 3



'AI3
'T_heizen  Geber am Heizungsvorlauf


'   If T_heizen < 955 Then
'   Takt_heizen = T_heizen - 869
'   Takt_heizen = Takt_heizen / 3
'   Else
'   Takt_heizen = T_heizen - 955
'   Takt_heizen = Takt_heizen + 30
'   End If


   'Bereich 995 = 54 bis 999=62 bis 1008=80 bis 1014=90
   If T_heizen => 995 Then
     Zahl = T_heizen - 1008
     Zahl = Zahl * 2
     Zahl = Zahl + 80
   End If
   If T_heizen > 950 And T_heizen < 995 Then
     Zahl = T_heizen - 950
     Zahl = Zahl + 10
   End If
   If T_heizen > 900 And T_heizen <= 950 Then
     Zahl = 15
   End If


    If T_heizen = 940 Then Zahl = 24
    If T_heizen = 941 Then Zahl = 24
    If T_heizen = 942 Then Zahl = 25
    If T_heizen = 943 Then Zahl = 25
    If T_heizen = 944 Then Zahl = 26
    If T_heizen = 945 Then Zahl = 26
    If T_heizen = 946 Then Zahl = 27

    If T_heizen = 947 Then Zahl = 28
    If T_heizen = 948 Then Zahl = 29
    If T_heizen = 949 Then Zahl = 30
    If T_heizen = 950 Then Zahl = 30
    If T_heizen = 951 Then Zahl = 31
    If T_heizen = 952 Then Zahl = 32
    If T_heizen = 953 Then Zahl = 33
    If T_heizen = 954 Then Zahl = 33
    If T_heizen = 955 Then Zahl = 34
    If T_heizen = 956 Then Zahl = 34
    If T_heizen = 957 Then Zahl = 35
    If T_heizen = 958 Then Zahl = 35
    If T_heizen = 959 Then Zahl = 36
    If T_heizen = 960 Then Zahl = 36
    If T_heizen = 961 Then Zahl = 37
    If T_heizen = 962 Then Zahl = 37



   If T_heizen = 963 Then Zahl = 38                         '* Gemessen
   If T_heizen = 964 Then Zahl = 38
   If T_heizen = 965 Then Zahl = 39
   If T_heizen = 966 Then Zahl = 39
   If T_heizen = 968 Then Zahl = 40
   If T_heizen = 969 Then Zahl = 40
   If T_heizen = 970 Then Zahl = 41
   If T_heizen = 971 Then Zahl = 41


   If T_heizen = 972 Then Zahl = 42
   If T_heizen = 973 Then Zahl = 42
   If T_heizen = 974 Then Zahl = 43
   If T_heizen = 975 Then Zahl = 43

   If T_heizen = 976 Then Zahl = 44                         '* Gemessen
   If T_heizen = 977 Then Zahl = 45
   If T_heizen = 978 Then Zahl = 45
   If T_heizen = 979 Then Zahl = 46
   If T_heizen = 980 Then Zahl = 47
   If T_heizen = 981 Then Zahl = 48
   If T_heizen = 982 Then Zahl = 48
   If T_heizen = 983 Then Zahl = 49
   If T_heizen = 984 Then Zahl = 50                         '*Gemessen
   If T_heizen = 985 Then Zahl = 51
   If T_heizen = 986 Then Zahl = 52
   If T_heizen = 987 Then Zahl = 53
   If T_heizen = 988 Then Zahl = 54
   If T_heizen = 989 Then Zahl = 55
   If T_heizen = 990 Then Zahl = 56
   If T_heizen = 991 Then Zahl = 57
   If T_heizen = 992 Then Zahl = 58                         '*Gemessen
   If T_heizen = 993 Then Zahl = 59
   If T_heizen = 994 Then Zahl = 59
   If T_heizen = 995 Then Zahl = 60                         '*
   If T_heizen = 996 Then Zahl = 62
   If T_heizen = 997 Then Zahl = 64
   If T_heizen = 998 Then Zahl = 65
   If T_heizen = 999 Then Zahl = 66                         '*
   If T_heizen = 1001 Then Zahl = 70                        '*
   If T_heizen = 1002 Then Zahl = 70
   If T_heizen = 1003 Then Zahl = 71
   If T_heizen = 1004 Then Zahl = 72                        '*
   If T_heizen = 1005 Then Zahl = 74
   If T_heizen = 1006 Then Zahl = 76
   If T_heizen = 1007 Then Zahl = 78
   If T_heizen = 1008 Then Zahl = 80                        '*
   If T_heizen = 1009 Then Zahl = 82
   If T_heizen = 1010 Then Zahl = 84
   If T_heizen = 1011 Then Zahl = 86
   If T_heizen = 1012 Then Zahl = 88
   If T_heizen = 1013 Then Zahl = 90


  If Zahl < 10 Then
     Error_sensor = 4
     Takt_heizen = 10
  End If

  If Zahl > 85 Then
      Error_sensor = 4
      Takt_heizen = 85
  End If

  If Zahl => 10 And Zahl <= 85 Then
      Takt_heizen = Zahl
  End If


'AI4
'856=22 Grad
'  5
'  4 23
'  3
'  2 24
'  1
'  0 25
'  9
'  8 26
'  7
'846=27 Grad

'900 - 846 / 2 =27 Grad
'900 = 0 Grad


'T_Keller  Geber im Heizraum
'KTY 81 210
      'Zahl1 = 865 - T_keller
      Zahl1 = 890 - T_keller
      Takt_keller = Zahl1 / 2
      Takt_keller = Takt_keller + Zahl1

  If Takt_keller < -10 Then Error_sensor = 5
  If Takt_keller > 30 Then Error_sensor = 1


'AI5
'Reserve

'KTY 81 210
      'Zahl1 = 865 - Ai05
      Zahl1 = 890 - T_keller
      Takt_reserve = Zahl1 / 2
      Takt_reserve = Takt_reserve + Zahl1



End Sub




'Umlaufpuffer fr max. 2 Monate

Sub Heizung_report()

'Speicher Grundstellung
If Adatum(arcptr) <> _date And _day <> 0 And _day <= 31 And _month <> 0 And _month <= 12 Then
    Arcptr = Arcptr + 1
    If Arcptr >= 63 Then Arcptr = 1

    Br_zeit = 0
    Wa_zeit = 0

    St_wasser = 0
    St_heizen = 0

    Zeit_brenner = 0
    Zeit_heizen = 0
    Zeit_wasser = 0

    T_mittel_innen = Takt_innen
    T_mittel_aussen = Takt_aussen
    T_mittel_wasser = Takt_wasser
    T_mittel_heizen = Takt_heizen

    Temp_min_wasser = 100
    Temp_max_wasser = 0
    Temp_mit_wasser = 0

    Temp_min_heizen = 100
    Temp_max_heizen = 0
    Temp_mit_heizen = 0

    Temp_min_innen = 1000
    Temp_max_innen = 0
    Temp_mit_innen = 0

    Temp_min_aussen = 100
    Temp_max_aussen = -100
    Temp_mit_aussen = 0


 End If


 'Zeiten zhlen
 If _min <> Min_old Then
    Min_old = _min

  If Brenner = 1 Then
     Zeit_brenner = Zeit_brenner + 1

     If H_brenner = 1 Then
        Br_zeit = Br_zeit + 1
     End If

  End If

  If Wasser = 1 Then
     Zeit_wasser = Zeit_wasser + 1
  End If

  If Heizen = 1 Then
     Zeit_heizen = Zeit_heizen + 1
  End If

 End If

 'Mittelwert ermitteln
 If _hour <> Std_old Then
     Std_old = _hour
     If Std_old = 0 Then Ctemp = 0
     Incr Ctemp

     Temp_mit_innen = Temp_mit_innen + Takt_innen
     Temp_mit_aussen = Temp_mit_aussen + Takt_aussen
     Temp_mit_wasser = Temp_mit_wasser + Takt_wasser
     Temp_mit_heizen = Temp_mit_heizen + Takt_heizen

     T_mittel_innen = Temp_mit_innen / Ctemp
     T_mittel_aussen = Temp_mit_aussen / Ctemp
     T_mittel_wasser = Temp_mit_aussen / Ctemp
     T_mittel_heizen = Temp_mit_aussen / Ctemp


 End If


 'Minimum und Maximumwerte bilden
 If Takt_innen < Temp_min_innen Then Temp_min_innen = Takt_innen
 If Takt_innen > Temp_max_innen Then Temp_max_innen = Takt_innen

 If Takt_wasser < Temp_min_wasser Then Temp_min_wasser = Takt_wasser
 If Takt_wasser > Temp_max_wasser Then Temp_max_wasser = Takt_wasser

 If Takt_heizen < Temp_min_heizen Then Temp_min_heizen = Takt_heizen
 If Takt_heizen > Temp_max_heizen Then Temp_max_heizen = Takt_heizen

 If Takt_aussen < Temp_min_aussen Then Temp_min_aussen = Takt_aussen
 If Takt_aussen > Temp_max_aussen Then Temp_max_aussen = Takt_aussen

 If St_h = 1 Then
    St_h = 0
    St_heizen = St_heizen + 1
 End If

 If St_w = 1 Then
    St_w = 0
    St_wasser = St_wasser + 1
    Wa_time = _time
 End If




 'Archivwerte ablegen

     Adatum(arcptr) = _date

     Atim_wasser(arcptr) = Zeit_wasser                      'Wasserpumpe ein
     Atim_brenner(arcptr) = Zeit_brenner                    'Brenner ein
     Atim_heizen(arcptr) = Zeit_heizen                      'Heizungspump ein

     Aanz_wasser(arcptr) = St_wasser
     Aanz_brenner(arcptr) = St_heizen

     Amin_i(arcptr) = Temp_min_innen
     Amax_i(arcptr) = Temp_max_innen
     Amit_i(arcptr) = T_mittel_innen

     Amin_a(arcptr) = Temp_min_aussen
     Amax_a(arcptr) = Temp_max_aussen
     Amit_a(arcptr) = T_mittel_aussen

     Amin_w(arcptr) = Temp_min_wasser
     Amax_w(arcptr) = Temp_max_wasser
     Amit_w(arcptr) = T_mittel_wasser

     Amin_h(arcptr) = Temp_min_heizen
     Amax_h(arcptr) = Temp_max_heizen
     Amit_h(arcptr) = T_mittel_heizen

End Sub


Sub Init_eeprom()

Dim H As Byte
Dim L As Byte

'Werte aus dem EEprom lesen
If Eeprom_write = 0 Then
   Eeprom_write = 100

Readeeprom Ti_nachlauf , 2


Readeeprom H , 4
Readeeprom L , 5
Ti_betrieb = H
'Ti_betrieb = H * 255
'Ti_betrieb = Ti_betrieb + L

Readeeprom H , 6
Ti_warten = H

Readeeprom H , 8
Ti_pause = H
'Ti_pause = H * 255
'Ti_pause = Ti_warten + L


Readeeprom Wasser_std_on , 10
Readeeprom Wasser_min_on , 11

Readeeprom Wasser_std_off , 12
Readeeprom Wasser_min_off , 13

Readeeprom Tsol_wasser , 14


Readeeprom H , 104
Readeeprom L , 105
Hti_betrieb = H

Readeeprom H , 106
Hti_warten = H
'Ti_pause = H * 255
'Ti_pause = Ti_warten + L

Readeeprom H1_std_on , 110
Readeeprom H1_min_on , 111

Readeeprom H1_std_off , 112
Readeeprom H1_min_off , 113

Readeeprom Tsol_raum , 114

Tsol_raum = Tsol_raum * 10

End If


'Defaultwerte eintragen
If Eeprom_write = 1 Then
   Eeprom_write = 101

   'Wasser
   '#######

   'Zeiten
   Ti_betrieb = 20                                          'd.h. Brenner luft max. 20 min
   Ti_nachlauf = 15                                         'Nachlauf 20 min
   Ti_pause = 1                                             'Min 1 bis nchster Start ber Temperatur
   Ti_warten = 240                                          'Min. 240 min warten bis zum nchsten Starttzeiten

   Wasser_std_on = 7
   Wasser_min_on = 20
   Wasser_std_off = 18
   Wasser_min_off = 0


   'Grad Tmin = Ein Soll-2    Grad Tmax = Aus  Soll+13
   'Wasser sollte 50 bis 60 Grad sein.
   'Dies ist notwendig damit Krankheitserreger getted werden.
   'Beim Duschen kann es sonst durch Legionellen Bakterien zu
   'tdlichen Infekten kommen
   'Ab 2011 wurde deswegen die Trinkwasserverordnung gendert
   'Ab 400 l Brauchwassertank oder wenn mehr wie 3 l bis zur Verbrauchsstelle
   'in der Leitung ist muss die Anlage jhrlich untersucht werden
   'ob solche Keime vorhanden sind.
   Tsol_wasser = 55


   'Heizung
   '#######

   Hti_betrieb = 45                                         'd.h. Brenner Luft Max. 30 Min
   Hti_warten = 40                                          'd.h. Pause nach Brenner fertig von max 40 min

   H1_std_on = 6
   H1_min_on = 45

   H1_std_off = 20
   H1_min_off = 30

   Tsol_raum = 220

End If



'EEProm eintragen
If Eeprom_write = 2 Then
   Eeprom_write = 102

Writeeeprom Ti_nachlauf , 2


'H = Ti_betrieb / 255
'L = H * 255
'L = Ti_betrieb - L

H = Ti_betrieb
Writeeeprom H , 4
Writeeeprom L , 5


'H = Ti_warten / 255
'L = H * 255
'L = Ti_warten - L
H = Ti_warten
Writeeeprom H , 6
Writeeeprom L , 7

'H = Ti_pause / 255
'L = H * 255
'L = Ti_pause - L
H = Ti_pause
Writeeeprom H , 8
Writeeeprom L , 9

Writeeeprom Wasser_std_on , 10
Writeeeprom Wasser_min_on , 11
Writeeeprom Wasser_std_off , 12
Writeeeprom Wasser_min_off , 13


Writeeeprom Tsol_wasser , 14


H = Hti_betrieb
Writeeeprom H , 104
Writeeeprom L , 105

H = Hti_warten
Writeeeprom H , 106
Writeeeprom L , 107


Writeeeprom H1_std_on , 110
Writeeeprom H1_min_on , 111
Writeeeprom H1_std_off , 112
Writeeeprom H1_min_off , 113

Zahl = Tsol_raum / 10
Writeeeprom Zahl , 114


End If

'Brenner wird bei dieser Wassertemp. eingeschaltet
   Tmin_wasser = Tsol_wasser - 5
'Brenner wird ber die Kesselwassertemp AI03 ausgeschaltet
'Das Kesselwasser erwrmt das Brauchwasser weiter solange die
'Wasserpumpe luft
   Tmax_wasser = Tsol_wasser + 5


  'Handbedienung von Vorort z.B. im Wohnzimmer
  If Eingang3 = 0 And Eingang2 = 0 And Eingang1 = 0 Then
     Tsol_korr = 0
  End If

  If Eingang3 = 0 And Eingang2 = 0 And Eingang1 = 1 Then
     Tsol_korr = 10
  End If
  If Eingang3 = 0 And Eingang2 = 1 And Eingang1 = 0 Then
     Tsol_korr = 20
  End If
  If Eingang3 = 0 And Eingang2 = 1 And Eingang1 = 1 Then
     Tsol_korr = 30
  End If
  If Eingang3 = 1 And Eingang2 = 0 And Eingang1 = 0 Then
     Tsol_korr = 40
  End If

   If Eingang3 = 1 And Eingang2 = 0 And Eingang1 = 1 Then
     Tsol_korr = -10
   End If
   If Eingang3 = 1 And Eingang2 = 1 And Eingang1 = 0 Then
     Tsol_korr = -20
   End If

'Schaltpunkte fr Raumheizung
   Zahl1 = Tsol_raum                                        'z.B. 220
   Tmin_raum = Zahl1 - 5                                    'z.B. 215
   Tmax_raum = Zahl1 + 5                                    'z.B. 225


End Sub


'Ablauf
'Step 255  Neustart
'Step 1    Vorlauf d.h. Brenner aus und Wasser ein
'Step 2    Brenner ein und Wasser ein
'Step 3    Nachlauf d.h. Brenner aus und Wasser ein
'Step 4    Wartezeit zum nchsten Start d.h. Brenner aus und Wasser aus
'Step 5    Warten

'Start nur wenn eine Zeitschaltuhr die Freigabe gibt
'Steuerung ber Temperatur oder ber Zeit

'Buderus - Sommerbetrieb
'Wasser =45   Heizung =65
'Der Sensor des Wasserbehlter meldet 45 Grad
'Nun wird die Wasserpumpe eingeschaltet
'Der Brenner luft ca. 5 min bis der Wasserbehlter 65 Grad meldet
'Nachdem der Brenner aus ist luft die Wasserpumpe noch ca. 3 min
'Das Wasser im Behlter braucht ca. 4 Stunden bis es von 65 bis 45 Grad
'abgekhlt ist und ein neuer Zyklus beginnt.
'Am Tag luft der Brenner also ca. 45 min und die Pumpe ca. 60 min
'Der Brenner verbraucht ca. 1,5 qm Gas pro Tag

Sub Heizung_wasser()

   'Wartungslauf der Heizungspumpe im Sommerbetrieb
   'Alle 20 Tage fr 5 min ein
   If Sommer = 1 And Wasser_uhr = 1 Then
      If _day <> Wby_day Then
          Wby_day = _day

          Wday_warten = Wday_warten + 1
          If Wday_warten = 20 Then
            Wday_warten = 0
            H_heizen = 1                                    'Heizungspumpe ein
          End If

         If H_heizen = 1 And _min <> W1by_min Then
           W1by_min = _min
           W1min_warten = W1min_warten + 1
           If W1min_warten >= 5 Then
              W1min_warten = 0
              H_heizen = 0                                  'Heizungspumpe aus
           End If

         End If


       End If
   End If

   'Zeiten bilden
   If _min <> Wby_min Then
      Wby_min = _min

      'Vorlauf
      If Wasser_step = 1 Then
         Wmin_vorlauf = Wmin_vorlauf + 1
      End If


        'Run
      If Wasser_step = 2 Then
         Wmin_betrieb = Wmin_betrieb + 1
      End If

       'Warten
      If Wasser_step = 4 Or Wasser_step = 5 Then
       Wmin_warten = Wmin_warten + 1

       If Ti_pause <= Wmin_warten Then
          Wasser_step = 5
       End If


      End If

      'Nachlauf
      If Wasser_step = 3 Then
         Wmin_nachlauf = Wmin_nachlauf + 1
      End If

      'Tatschliche Brennerlaufzeit fr Wasser erfassen
      If W_brenner = 1 And H_brenner = 0 Then
        Wa_zeit = Wa_zeit + 1
      End If



       '10 min Warten wenn minimum Wassertemperatur erreicht ist
       If Takt_wasser <= Tmin_wasser Then
            Wasser_z1 = Wasser_z1 + 1
            If Wasser_z1 > 10 Then Wasser_z1 = 100
       Else
            Wasser_z1 = 0
       End If

       '2 min Warten wenn Kesselwasser fr Wassererwrmung erreicht ist
       Zahl1 = Tsol_wasser + 15
       If Takt_heizen >= Zahl1 Then
            Wasser_z2 = Wasser_z2 + 1
            If Wasser_z2 > 1 Then Wasser_z2 = 100
       Else
            Wasser_z2 = 0
       End If

      '30 min Warten wenn absolutes minimum der Vorlauftemperatur erreicht ist
      'Der Brenner erwrmt Kesselwasser (geringe Menge) Mit diesem
      'Kesselwasser werden die Heizkrper und das Brauchwasser erwrmt.
      'Damit es nicht zu Korrosion kommt kann aufgrund spezieller Werkstoffe
      'das Kesselwasser bis 30 Grad abgesenkt werden.
       If Takt_heizen <= 30 And H_mini = 0 Then
            Heiz_z4 = Heiz_z4 + 1
            If Heiz_z4 > 30 Then Heiz_z4 = 100
       Else
            Heiz_z4 = 0
       End If

   End If

   If _sec <> Wby_sec Then
      Wby_sec = _sec

   End If


   'Neustart, wenn Zeit abgelaufen und Zeitschaltuhr in den
   'Tagesbetrieb wechselt
   If Wasser_step = 255 And Wasser_uhr = 1 Then

        If Takt_wasser <= Tmin_wasser Then
            W_wasser = On

            Wasser_step = 1
            Wmin_betrieb = 0
        End If

   End If

  'Vorlauf Fertig wenn Zeit abgelaufen
   'If Wasser_step = 1 And 2 <= Wmin_vorlauf Then
    If Wasser_step = 1 Then
        St_w = 1

        W_brenner = On
        Wasser_step = 2

        Wmin_vorlauf = 0
        Wmin_nachlauf = 0
        Wmin_betrieb = 0
        Wmin_warten = 0
    End If


   'Run Fertig wenn Temperatur erreicht
   'Es wird das Kesselwasser erwrmt. Dieses Wasser gibt die
   'Wrme an das Brauchwasser ab.
   'Bis das Brauchwasser seine Temperatur erreicht hat dauert
   'es nun ca. 20 min
   'Beispiel: Kesselwasser wird mit Brenner auf ca. 65 Grad erwrmt,
   '          wenn Takt_wasser =50 Grad ist. Ist der Brenner aus luft
   '          die Pumpe noch 20 min und erwrmt das Wasser auf ca. 54 Grad
   '          Luft gleichzeitig die Heizungspumpe wird diese Temperatur
   '          nicht erreicht da nun auch Wrme ber die Heizkrper verloren geht.

   If Wasser_step = 2 And Wasser_z2 = 100 Then
       W_brenner = Off
       Wmin_vorlauf = 0
       Wmin_nachlauf = 0
       Wmin_betrieb = 0
       Wasser_step = 3
   End If

   'Run Fertig wenn Zeit abgelaufen
   If Wasser_step = 2 And Ti_betrieb <= Wmin_betrieb Then
        W_brenner = Off
        Wmin_vorlauf = 0
        Wmin_nachlauf = 0
        Wmin_betrieb = 0
        Wasser_step = 3
   End If


  'Nachlauf Fertig wenn Zeit abgelaufen
   If Wasser_step = 3 And H_mini = 0 And Wmin_nachlauf >= Ti_nachlauf Then
        W_wasser = Off
        Wmin_vorlauf = 0
        Wmin_nachlauf = 0
        Wmin_betrieb = 0
        Wmin_warten = 0
        Wasser_step = 4
   End If

   'Nach 7 min alles wieder aus, wenn Einschaltung durch
   'min. absolute Vorlauftemperatur von 30 Grad erfolgt ist
   'd.h. von 30 auf ca. 40 Grad
   If Wasser_step = 3 And H_mini = 1 And Wmin_nachlauf => 7 Then
       Wasser_step = 5

       W_brenner = Off
       W_wasser = Off

       Wmin_vorlauf = 0
       Wmin_nachlauf = 0
       Wmin_betrieb = 0
       Wmin_warten = 0

       H_mini = 0
   End If




   'Neu Start Wassererwrmung wenn Temperatur zu niedrig ist
   If Wasser_step = 5 And Wasser_z1 = 100 And Wasser_uhr = 1 Then


       Wasser_step = 255
       Wmin_betrieb = 0


   End If

   'Zwangseinschaltung alle 240 min
   'Neu Start Wassererwrmung wenn Wartezeit abgelaufen
   If Wasser_step = 5 And Ti_warten <= Wmin_warten And Wasser_uhr = 1 Then


       Wasser_step = 255
       Wmin_betrieb = 0


   End If

   'Aus wenn Nachtabsenkung
   If Wasser_uhr = 0 And Wasser_step > 3 Then
       Wasser_step = 255                                    'Warten auf Tagbetrieb

       W_brenner = Off
       W_wasser = Off

       Wmin_vorlauf = 0
       Wmin_nachlauf = 0
       Wmin_betrieb = 0
       Wmin_warten = 0

   End If

   'Ein wenn Kesselwasser fr 30 min kleiner 30 Grad
   'Rostschutz rund um die Uhr
   'In 06 min/Brenner von 27 Grad auf 42 Grad
   'In 20 min/Brenner von 27 Grad auf 70 Grad d.h. Wasser von 48 auf 54
   If H_mini = 0 And Heiz_z4 = 100 Then
           St_w = 1
           W_brenner = On                                   'Brenner Ein
           W_wasser = On                                    'Wasserpumpe Ein
           Wmin_vorlauf = 0
           Wmin_nachlauf = 0
           Wmin_betrieb = 0
           Wasser_step = 3
           H_mini = 1
           Heiz_z4 = 0
   End If



End Sub



Sub Heizung_wasser_time()

     'Einschalten
     If _hour >= Wasser_std_on And _hour < Wasser_std_off And Wasser_uhr = 0 Then
        If _hour = Wasser_std_on And _min >= Wasser_min_on Then
               Wasser_uhr = 1
               Wasser_step = 5
        End If
        If _hour > Wasser_std_on Then
               Wasser_uhr = 1
               Wasser_step = 5
        End If

     End If

     'Ausschalten
     If _hour >= Wasser_std_on And _hour < Wasser_std_off Then
     Else
        If _hour = Wasser_std_off And _min >= Wasser_min_off Then
            Wasser_uhr = 0
        End If
        If _hour <> Wasser_std_off Then
            Wasser_uhr = 0
        End If

     End If





End Sub








Sub Heizung_raum()

'Zeiten bilden
'################

 If _min <> H_min Then
      H_min = _min


         'Verzgerung fr die Heizungspumpe
         '=================================
         If Heizen_on = 1 Then
            Heizen_on_min = Heizen_on_min + 1
            If Heizen_on_min >= 10 Then
               Heizen_on = 2
               Heizen_on_min = 0
            End If

         End If





         'Step =1  Brenner ein
         '====================

         'Ermtteln wie lange der Brenner luft
         If H_brenner = 1 Then
            Hmin_betrieb = Hmin_betrieb + 1
            Hmin_warten = 0
         End If


         'Step =2  Warten nach Brenner ein
         '================================

         'Wartezeit verkrzen damit es schneller Warm wird
         If Heizen_uhr = 1 Then

              Zahl = Tsol_raum - Takt_innen

              Hti_korr = 0                                  '40 min > 21,8

              'Abhngig von der Innentemperatur
              If Zahl > 2 Then Hti_korr = 5                 '35 min <21,8
              If Zahl > 5 Then Hti_korr = 10                '30 min < 21,5
              If Zahl > 10 Then Hti_korr = 15               '25 min < 21,0
              If Zahl > 15 Then Hti_korr = 20               '20 min < 20,5
              If Zahl > 20 Then Hti_korr = 25               '15 min < 20,0


              'Abhngig von der Aussentemperatur
              If Takt_aussen <= 0 Then
                Hti_korr = Hti_korr + 5
              End If
              'If Takt_aussen > 0 Then
              '  Hti_korr = 10
              'End If
              'If Takt_aussen > 7 Then
              '  Hti_korr = 0
              'End If

              Zahl = Hti_warten - Hti_korr

              'Mindestwartezeit = 10 min
              If Zahl <= 10 Then
               Zahl = 10
              End If

              'Heizung ohne Zeit schalten, wenn Vorlauf zu niedrig
               If Takt_aussen <= 0 Then
Dim Temp As Integer
Temp = Tmin_heizen - 8

               If Takt_heizen < Tmin_heizen - 8 Then
                 Zahl = 0
               End If
               End If

         End If

         If Heizen_uhr = 0 Then
            Zahl = 120
         End If

         'Wartezeit nachdem der Brenner gelaufen ist
         If Heizen_step = 2 Then
            Hmin_betrieb = 0
            Hmin_warten = Hmin_warten + 1
            If Hmin_warten > Zahl Then
               Hmin_warten = 0
               Heizen_step = 0
            End If
         End If



       '
       '2 min Warten wenn Vorlauf zu niedrig
       If Takt_heizen <= Tmin And Heizen_step = 0 Then
         Heiz_z1 = Heiz_z1 + 1
         If Heiz_z1 > 2 Then Heiz_z1 = 100
       Else
         Heiz_z1 = 0
       End If

       '1 min Warten wenn maximum der Vorlauftemperatur erreicht ist
       If H_brenner = 1 And Takt_heizen => Tmax Then
            Heiz_z2 = Heiz_z2 + 1
            If Heiz_z2 > 1 Then Heiz_z2 = 100
       Else
            Heiz_z2 = 0
       End If

       '5 min Warten wenn maximum der Raumtemperatur erreicht ist
       If H_brenner = 1 And Takt_innen => Tmax_raum Then
            Heiz_z3 = Heiz_z3 + 1
            If Heiz_z3 > 5 Then Heiz_z3 = 100
       Else
            Heiz_z3 = 0
       End If



 End If





'Tagesbetrieb und Nachtbetrieb
'#############################


If Heizen_uhr = 1 Or Heizen_uhr = 0 Then


      If Heizen_uhr = 0 And H_tag = 1 Then
        H_tag = 0
      End If

      If Heizen_uhr = 1 Then

         'Ein wenn Umschaltung auf Tagesbetrieb
         If H_tag = 0 Then
            H_tag = 1
            Heizen_on = 2
         End If

         'Innentemperatur 10 min zu niedrig d.h. Pumpe ein
         If Takt_innen >= Tsol_raum And Heizen_on = 1 Then
             Heizen_on = 0
             Heizen_on_min = 0
         End If

         'Sofort Ein da Innentemperatur unter Minimum
         If Takt_innen <= Tmin_raum And H_heizen = 0 Then
            Heizen_on = 2
         End If

         'Ein nach Wartezeit
         If Takt_innen <= Tsol_raum And Heizen_on = 0 And H_heizen = 0 Then
            Heizen_on = 1
            Heizen_on_min = 0
         End If

     End If

     '##################
     'Pumpe Ein
     '##################

     'Heizungspumpe ein
     If Heizen_uhr = 1 And Heizen_on = 2 And Takt_aussen < 18 Then

          'Heizungspumpe ein
          H_heizen = 1

          Heizen_on = 0

      End If

     'Nachtabsenkung
     If Heizen_uhr = 0 And Takt_innen <= 170 And Takt_aussen < 0 Then

          'Heizungspumpe ein
          H_heizen = 1

          Heizen_on = 0


      End If




    'Brenner evtl. einschalten
    'Step =0 Warten auf Brenner Einschaltung
    'Step =1 Brenner ein
    'Step =2 Pause bis nchster Start mglich

    If Heizen_step = 0 Then

     'Brenner ein wenn VorlaufTemperatur zu niedrig und Raumtemperatur zu niedrig
     'Brenner luft ca. 6 min um von 60 bis 67 Grad zu heizen Verbrauch ca 0,15 qm
     'bis die Temperatur wieder unter 60 geht dauert es dann ca. 30 min
      If Heizen_uhr = 1 And H_heizen = 1 And Heiz_z1 = 100 And Takt_innen <= Tsol_raum Then
          H_brenner = 1
          Heizen_step = 1
          Br_time = _time
          Heiz_z1 = 0
      End If



      'Nachtabsenkung
      If Heizen_uhr = 0 And H_heizen = 1 And Takt_innen <= 160 And Takt_heizen < Htu_heizen Then
          H_brenner = 1
          Heizen_step = 1
          Br_time = _time
          Heiz_z1 = 0
      End If


    End If





    'Erhhung bis Raumtemperatur erreicht ist
    'Damit wird schneller geheizt
    Tmax_korr = Tsol_raum - Takt_innen
    'Tmin_korr = Tmax_korr / 2
    Tmin_korr = 0

    If Heizen_uhr = 0 Then
       Tmax_korr = 55 - Tmax_heizen
       Tmin_korr = Tmax_korr
    End If

    'If Heizen_uhr = 1 Then
      'Temperatur zu niedrig
     ' If Zahl >= 5 Then
      '   Tmax_korr = 5
      'End If
      'If Zahl >= 10 Then
      '   Tmax_korr = 10
     ' End If
      'If Zahl >= 20 Then
      '   Tmax_korr = 15
      'End If

      'Temperatur zu hoch
      'If Zahl < 0 Then
      ' Tmax_korr = 55 - Tmax_heizen
      'End If

   ' End If


    Zahl = Tmax_heizen + Tmax_korr
    If Zahl => 80 Then
       Tmax_korr = 80 - Tmax_heizen
       'Tmin_korr = Tmax_korr / 3
       'Tmin_korr = Tmin_korr * 2

    End If

    Tmax = Tmax_heizen + Tmax_korr
    Tmin = Tmin_heizen + Tmin_korr
    If Tmin < 30 Then Tmin = 30
    If Tmax > 85 Then Tmax = 85

    'Brenner aus wenn max. der Vorlauftemperatur erreicht ist
    If H_brenner = 1 And Heiz_z2 = 100 Then
       H_brenner = 0
       Heizen_step = 2                                      'Wartezeit
       St_fh = 0
       Heiz_z2 = 0
    End If

    'Brenner aus luft zu lange
    If H_brenner = 1 And Hmin_betrieb >= Hti_betrieb Then
       H_brenner = 0
       Heizen_step = 2                                      'Wartezeit
       St_fh = 0
    End If



   '#####################
   'Abschaltung
   '#####################


      Heiz_meld = "Aus: min<Tv<max "


    'Zwangsabschaltung und Meldungen

      'Wartezeit bis Brenner ein
      If Heiz_z1 > 0 And Heiz_z1 < 100 Then
         Zahl = 3 - Heiz_z1
         Heiz_meld = "Tv<Tmin " + Str(zahl) + " min "
      End If

     'Wartezeit bis Pumpe ein
      If Heizen_on = 1 Then
         Zahl = 10 - Heizen_on_min
         Heiz_meld = "TI<Tsoll " + Str(zahl) + " min "
      End If

      'Keine Heizung notwendig da zu Warm  Sommer
      If Takt_aussen > 17 And Takt_innen > Tsol_raum Then
         H_brenner = 0                                      'Brenner aus
         H_heizen = 0                                       'Heizungspumpe aus
         Heizen_step = 0
         Heizen_on = 0
         Heizen_on_min = 0
         Heiz_meld = "Aus: TA>17 Grad "
      End If


      'Zwangsabschaltung innen zu warm    Winter
      If Takt_innen >= Tsol_raum And Takt_aussen < 18 Then
         Heiz_meld = "Aus: TI>Tsoll   "
      End If

      'Zwangsabschaltung innen 5 min ber maximale Raumtemperatur
      If Heiz_z3 = 100 Then
         H_brenner = 0                                      'Brenner aus
         Heizen_step = 0
         Heizen_on = 0
         Heizen_on_min = 0
         Heiz_meld = "Aus: TI>maximum "
      End If

      'Nachtabsenkung mit Forstschutz luft
      If Heizen_uhr = 0 And H_heizen = 1 Then
          Heiz_meld = "Ein: Frotsschutz"
      End If

      'Heizungspumpe aus wenn Wasser Nachlauf luft
      'Wrme komplett fr die Wassererwrmung nutzen
      If H_heizen = 1 And W_brenner = 1 Then
         H_sperr = 1
         H_heizen = 0
      End If
      If H_heizen = 0 And H_sperr = 1 And W_brenner = 0 Then
         H_sperr = 0
         H_heizen = 1
      End If


      'Zwangsabschaltung Nachtbetrieb
      If Takt_innen > 170 And Heizen_uhr = 0 And Heizen_step = 0 Then
         H_brenner = 0                                      'Brenner aus
         H_heizen = 0                                       'Heizungspume aus
         Heizen_step = 0
         Heizen_on = 0
         Heizen_on_min = 0
         H_sperr = 0
         Heiz_meld = "Nachtabsenkung  "
      End If




End If










'Schaltspiele zhlen
If H_brenner = 1 And St_fh = 0 Then
          St_fh = 1
          St_h = 1
End If



End Sub



Sub Heizung_raum_not()

   If Heizen_uhr = 1 Then

   'Zeiten bilden
    If _min <> H_min Then
        H_min = _min
        'Minuten fr Notbetrieb zhlen
        Not_brenner = Not_brenner + 1
    End If



       'Heizungspumpe Ein
       H_heizen = 1

       'Brenner 15 min ein dann je nach Stufe warten
       'z.B. Stufe 1   75 min Pause
       'z.B. Stufe 9   15 min Pause
       If Not_brenner < 16 Then
          H_brenner = 1
          Heizen_step = 1
          Hmin_betrieb = Not_brenner
       Else
          H_brenner = 0
          Heizen_step = 0
          Hmin_warten = Not_brenner
       End If

      Select Case Notbetrieb

         Case 1:
                If Not_brenner >= 90 Then Not_brenner = 0
         Case 2:
                If Not_brenner >= 80 Then Not_brenner = 0
         Case 3:
                If Not_brenner >= 70 Then Not_brenner = 0
         Case 4:
                If Not_brenner >= 60 Then Not_brenner = 0
         Case 5:
                If Not_brenner >= 55 Then Not_brenner = 0
         Case 6:
                If Not_brenner >= 50 Then Not_brenner = 0
         Case 7:
                If Not_brenner >= 45 Then Not_brenner = 0
         Case 8:
                If Not_brenner >= 30 Then Not_brenner = 0

       End Select

   End If


End Sub



Sub Heizung_raum_time()


     'Einschalten
     If _hour >= H1_std_on And _hour < H1_std_off And Heizen_uhr = 0 Then
        If _hour = H1_std_on And _min >= H1_min_on Then
               Heizen_uhr = 1
        End If
        If _hour > H1_std_on Then
             Heizen_uhr = 1
        End If
     End If

     'Ausschalten
     If _hour >= H1_std_on And _hour < H1_std_off Then
     Else
        If _hour = H1_std_off And _min >= H1_min_off Then
            Heizen_uhr = 0
        End If
         If _hour <> H1_std_off Then
            Heizen_uhr = 0
        End If
     End If

    'Heizen ber Bedienung steuern
    If M_tagnacht = 1 Then
       Heizen_uhr = 1
    End If
    If M_tagnacht = 2 Then
       Heizen_uhr = 0
    End If



End Sub










'####################
'Modul Endekennung
'####################
Enduser: