'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_VAR.bas                                                     !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Hauptprogramm                                                         !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'

'##################################################
'# Zuordunungsliste
'##################################################

Beeper Alias Do07                                           'Beeper
Brenner Alias Do06                                          'Relais 7 Klemme 2/3
Wasser Alias Do05                                           'Relais 6 Klemme 12/7
Heizen Alias Do04                                           'Relais 5 Klemme 12/8
Do_res03 Alias Do03
Do_res02 Alias Do02
Do_res01 Alias Do01
Do_res00 Alias Do00


Di_res07 Alias Di07
Di_res06 Alias Di06
Di_res05 Alias Di05
Di_res04 Alias Di04
Eingang4 Alias Di03
Eingang3 Alias Di02
Eingang2 Alias Di01
Eingang1 Alias Di00


Ai_res07 Alias Ai07
Ai_res06 Alias Ai06
Ai_res05 Alias Ai05
T_keller Alias Ai04
T_heizen Alias Ai03
T_wasser Alias Ai02
T_aussen Alias Ai01
T_innen Alias Ai00



'Variablen Fr At_user.bas
'=========================

'Temperatur
Dim Tmin_wasser As Byte
Dim Tmax_wasser As Byte
Dim Tsol_wasser As Byte
Dim Takt_wasser As Byte

Dim Takt_keller As Byte
Dim Takt_reserve As Byte

'Zeit - Sollwerte
Dim Ti_nachlauf As Integer
Dim Ti_betrieb As Integer
Dim Ti_warten As Integer
Dim Ti_pause As Integer

'Steuerung Winterbetrieb d.h. heizen
Dim Takt_innen As Integer
Dim Takt_aussen As Integer
Dim Takt_heizen As Byte


Dim Tmin_heizen As Byte
Dim Tmax_heizen As Byte

Dim Tmin_raum As Integer
Dim Tmax_raum As Integer
Dim Tmax_korr As Integer
Dim Tmin_korr As Integer
Dim Tsol_raum As Integer
Dim Tsol_korr As Integer

Dim M_brenner As Bit
Dim M_heizen As Bit
Dim M_wasser As Bit
Dim M_tagnacht As Byte

'Steuerung Sommer/Winterbetrieb d.h. nur Wasser erwaermen
Dim Sommer As Bit
Dim Summer As Integer
Dim Somwin As Bit

Dim Wasser_uhr As Bit
Dim Heizen_uhr As Bit

Dim Notbetrieb As Byte
Dim Not_brenner As Integer

Dim Wasser_step As Byte
Dim Wmin_vorlauf As Integer
Dim Wmin_betrieb As Integer
Dim Wmin_warten As Integer
Dim Wmin_nachlauf As Integer
Dim Heiz_z4 As Byte


'Parameter

Dim Wasser_std_on As Byte
Dim Wasser_min_on As Byte

Dim Wasser_std_off As Byte
Dim Wasser_min_off As Byte


Dim Heizen_step As Byte

Dim H1_std_on As Byte
Dim H1_min_on As Byte

Dim H1_std_off As Byte
Dim H1_min_off As Byte


Dim Hti_betrieb As Integer
Dim Hti_warten As Integer
Dim Hti_korr As Byte

Dim Hmin_betrieb As Integer
Dim Hmin_warten As Integer

Dim Heiz_meld As String * 16

Dim Error_sensor As Byte


Dim St_heizen As Byte
Dim St_wasser As Byte

Dim Zeit_brenner As Integer
Dim Zeit_wasser As Integer
Dim Zeit_heizen As Integer

Dim Temp_min_innen As Integer
Dim Temp_max_innen As Integer
Dim Temp_mit_innen As Integer
Dim T_mittel_innen As Integer

Dim Temp_min_aussen As Integer
Dim Temp_max_aussen As Integer
Dim Temp_mit_aussen As Integer
Dim T_mittel_aussen As Integer

Dim Temp_min_wasser As Byte
Dim Temp_max_wasser As Byte
Dim Temp_mit_wasser As Integer
Dim T_mittel_wasser As Integer

Dim Temp_min_heizen As Byte
Dim Temp_max_heizen As Byte
Dim Temp_mit_heizen As Integer
Dim T_mittel_heizen As Integer


'Archiv
Dim Adatum(62) As String * 8

'Schaltungen
Dim Aanz_wasser(62) As Integer
Dim Aanz_brenner(62) As Integer

'Zeit
Dim Atim_wasser(62) As Integer
Dim Atim_brenner(62) As Integer
Dim Atim_heizen(62) As Integer

'Temperatur
Dim Amin_i(62) As Integer
Dim Amax_i(62) As Integer
Dim Amit_i(62) As Integer

Dim Amin_a(62) As Integer
Dim Amax_a(62) As Integer
Dim Amit_a(62) As Integer

Dim Amin_w(62) As Integer
Dim Amax_w(62) As Integer
Dim Amit_w(62) As Integer

Dim Amin_h(62) As Integer
Dim Amax_h(62) As Integer
Dim Amit_h(62) As Integer


Dim Br_time As String * 9
Dim Br_zeit As Integer

Dim Wa_time As String * 9
Dim Wa_zeit As Integer