'
'   !------------------------------------------------------------------------!
'   !  Modul: User_Men.bas                                                   !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Anwendung:         AT_Test                                                             !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'



$regfile = "m2561def.dat"                                   ' specify the used micro


$include "AT_DT.bas"
$include "AT_IO.bas"                                        'Interface fr Peripherie
$include "AT_LCD.bas"                                       'Interface fr Peripherie

$include "User_var.bas"                                     'Interface fr Peripherie




'##################################################
'# Zuordunungsliste
'##################################################





'###################################################
'Funktionen definieren
'###################################################

Declare Sub Clock_control()

Declare Sub Menue()

Declare Sub Men_text()

Declare Sub Men_w01()
Declare Sub Men_w02()
Declare Sub Men_w03()
Declare Sub Men_w04()

Declare Sub Men_w05()

Declare Sub Men_w12()

Declare Function Logo() As Integer



'###################################################

'Allgemeines

Dim Startlogo As Integer
Dim Cylogo As Integer
Dim Cyimp As Integer


Dim _wxx As Byte
Dim _pxx As Byte


Dim Err_clock As Bit
Dim Err_clock_sec As Byte
Dim Err_clock_min As Integer

Dim Eeprom_write As Byte


Dim Wert As String * 10
Dim Zahl As Integer
Dim Zahl1 As Integer
Dim Zahl2 As Integer

Dim W1 As Byte
Dim W2 As Byte
Dim W3 As Byte

Dim Sm01 As Byte
Dim Sm02 As Byte
Dim Sm03 As Byte
Dim Sm04 As Byte
Dim Sm05 As Byte
Dim Sm06 As Byte
Dim Sm07 As Byte
Dim Sm08 As Byte

Dim Lcdpos As Byte


Goto Endmenu


Function Logo() As Integer

If Startlogo = -1 Then
    Logo = Off
Else
    Logo = On

     If Cylogo = 0 And Startlogo = 0 Then

         Lcdtext = "*CoSoMa V050611*"
         Lcd_show 1 , 1 , Lcdtext
         Lcd_clear 2

     End If




         Cylogo = Cylogo + 1
         If Cylogo >= 2 Then
            Cylogo = 0

             Startlogo = Startlogo + 1
             If Startlogo >= 15 Then Startlogo = -1


         End If


End If
End Function

'Stellt die Uhr nach Netzaus auf 08:00:00
'Erzeugt jede Min eine Tonsignal bis Zeit und Datum
'auf einen gltigen Wert eingestellt sind

Sub Clock_control()


'Alarm starten
If _day = 0 And _month = 0 And Err_clock = 0 Then

   Err_clock = 1
   Err_clock_min = 1800

   _time = "08:00:00"
   Set_time

   If Wxx > 1 Then
    Lcdtext = "Wahlschalter 1  "
    Lcd_show 1 , 1 , Lcdtext
    Lcdtext = "Datum? Uhrzeit? "
    Lcd_show 2 , 1 , Lcdtext
  End If


End If

'Alarm aus
If _day > 0 And _month > 0 Then
     Err_clock = 0
     Err_clock_min = 0
End If

'Alarm aktiv
If Err_clock = 1 Then

   If _sec <> Err_clock_sec Then
       'Beeper = Off
       Do07 = Off
       Err_clock_sec = _sec
       Err_clock_min = Err_clock_min + 1
   End If

   'Alle 30 min einen Beepston ausgeben
   If Err_clock_min >= 1800 Then
       'Beeper = On
       Do07 = On
       Err_clock_min = 0
   End If


End If


End Sub


Sub Menue()

   'Verwaltet Wahlschalter und Keyboard
   'Wahlschalter wurde gendert
    If Wxx <> Wahlschalter Then
      Wxx = Wahlschalter
      Pxx = 1
      _pxx = 0
      Mxx = 0
    End If


  'Parameter verndern
  If Keyb = Asc( "*") Then
     Decr Pxx
     If Wxx = 1 And Pxx = 0 Then Pxx = 6
     If Wxx = 2 And Pxx = 0 Then Pxx = 10
     If Wxx = 3 And Pxx = 0 Then Pxx = 10
     If Wxx = 4 And Pxx = 0 Then Pxx = 12
     If Wxx = 5 And Pxx = 0 Then Pxx = 8

  End If

  If Keyb = Asc( "#") Then
     Incr Pxx


    'Obergrenzen

      If Wxx = 1 And Pxx > 6 Then Pxx = 1                   'Datum Uhr Betriebsart
      If Wxx = 2 And Pxx > 10 Then Pxx = 1                  'Betrieb
      If Wxx = 3 And Pxx > 10 Then Pxx = 1                  'Handbetrieb
      If Wxx = 4 And Pxx > 12 Then Pxx = 1                  'Eprom Parameter
      If Wxx = 5 And Pxx > 8 Then Pxx = 1                   'Report

      'If Wxx = 6 And Pxx > 8 Then Pxx = 1                   'Analog
      'If Wxx = 7 And Pxx > 2 Then Pxx = 1                   'Digital

 End If

  If Wxx = 6 Or Wxx = 7 Or Wxx = 8 Or Wxx = 9 Or Wxx = 10 Or Wxx = 11 Then
    If _wxx <> Wxx Then
      _wxx = Wxx
      Men_text
      Lcdtext = Mtext + "            "
      Lcd_show 1 , 1 , Lcdtext
      Lcdtext = "Reserve        "
      Lcd_show 2 , 1 , Lcdtext
    End If
  End If


  'Menue bearbeiten

  'Datum Uhrzeit und Betriebsarten
  Men_w01

  If Err_clock = 1 And Wxx > 1 Then
    Lcdtext = "Wahlschalter 1  "
    Lcd_show 1 , 1 , Lcdtext
    Lcdtext = "Datum? Uhrzeit? "
    Lcd_show 2 , 1 , Lcdtext
  End If


  If Err_clock = 0 Then

  'Betrieb Heizung/Warmwasser
  Men_w02


  'Test Relais
  Men_w03



  'EEProm Verwaltung
  Men_w04



  'Report
  Men_w05



  'Logo
  Men_w12


  End If

End Sub



 'Ermittelt den Menue Text z.B. 12/1
 'wenn sich Wahlschalter oder Programm gendert hat

Sub Men_text()



      If Wxx < 10 Then
         Lcdtext = "0" + Str(wxx)
      Else
         Lcdtext = Str(wxx)
      End If
      If Pxx < 10 Then
         Lcdtext = Lcdtext + "/" + Str(pxx) + " "
      Else
         Lcdtext = Lcdtext + "/" + Str(pxx) + " "
      End If

      Mtext = Lcdtext




End Sub




'Datum und Uhrzeit

Sub Men_w01()

If Wxx <> 01 Then
Exit Sub
End If

 If _wxx <> Wxx Or _pxx <> Pxx Then

      _wxx = Wxx
      _pxx = Pxx

      If Pxx = 1 Then Mxx = 1
      If Pxx = 2 Then Mxx = 2
      If Pxx = 3 Then Mxx = 3
      If Pxx = 4 Then Mxx = 4
      If Pxx = 5 Then Mxx = 5
      If Pxx = 6 Then Mxx = 6


 End If


If _sec <> Sec_old Then
      Sec_old = _sec


'Anzeigen Datum und Uhrzeit
If Pxx = 1 Then
   Mxx = 11


      Men_text
      Lcdtext = Mtext + _date + "   "
      Lcd_show 1 , 1 , Lcdtext
      Lcdtext = "     " + _time + "   "
      Lcd_show 2 , 1 , Lcdtext

      If Summer = 0 Then
         Lcdtext = "Au"
         Lcd_show 1 , 15 , Lcdtext
      End If
      If Summer = 1 Then
         Lcdtext = "So"
         Lcd_show 1 , 15 , Lcdtext
      End If
      If Summer = 2 Then
         Lcdtext = "Wi"
         Lcd_show 1 , 15 , Lcdtext
      End If

      If Notbetrieb = 0 Then
         Lcdtext = " "
         Lcd_show 2 , 15 , Lcdtext
      Else
         Lcdtext = "No"
         Lcd_show 2 , 15 , Lcdtext
      End If

End If

End If

'Eingabe Datum
If Pxx = 2 And Mxx = 2 Then
   Mxx = 12
   Men_text
   Lcd1 = "Set Date"
   Lcd_clear 1
   Lcdtext = Mtext + Lcd1
   Lcd_show 1 , 1 , Lcdtext
   Lcdtext = "     " + _date + "   "
   Lcd_show 2 , 1 , Lcdtext


   Lcdpos = 6
   Lcd_locate 2 , 6
   Lcd_cursor On

End If

'Eingabe der Zeit
If Pxx = 3 And Mxx = 3 Then
   Mxx = 13
   Men_text
   Lcd1 = "Set Time"
   Lcd_clear 1
   Lcdtext = Mtext + Lcd1
   Lcd_show 1 , 1 , Lcdtext
   Lcdtext = "     " + _time + "   "
   Lcd_show 2 , 1 , Lcdtext

   Lcdpos = 6
   Lcd_locate 2 , 6
   Lcd_cursor On

End If




'Eingabe Sommer oder Winter
If Pxx = 4 And Mxx = 4 Then
   Mxx = 14

   Lcd_clear 1
   Men_text
   Lcd1 = "Betriebsart"
   Lcdtext = Mtext + Lcd1
   Lcd_show 1 , 1 , Lcdtext

   If Summer = 0 Then Lcd1 = "***Automatik***"
   If Summer = 1 Then Lcd1 = "*** Sommer  ***"
   If Summer = 2 Then Lcd1 = "*** Winter  ***"


   Lcd_clear 2
   Lcdtext = Lcd1
   Lcd_show 2 , 1 , Lcdtext

   Lcdpos = 0

End If



'Eingabe Notbetrieb
If Pxx = 5 And Mxx = 5 Then
   Mxx = 15
   Men_text

   Lcd_clear 1
   Lcd_clear 2
   Lcd1 = "Notbetrieb"
   Lcdtext = Mtext + Lcd1
   Lcd_show 1 , 1 , Lcdtext

   If Notbetrieb = 0 Then Lcdtext = "***   Aus   ***"
   If Notbetrieb = 1 Then Lcdtext = "*** Stufe 1 ***"
   If Notbetrieb = 2 Then Lcdtext = "*** Stufe 2 ***"
   If Notbetrieb = 3 Then Lcdtext = "*** Stufe 3 ***"
   If Notbetrieb = 4 Then Lcdtext = "*** Stufe 4 ***"
   If Notbetrieb = 5 Then Lcdtext = "*** Stufe 5 ***"
   If Notbetrieb = 6 Then Lcdtext = "*** Stufe 6 ***"
   If Notbetrieb = 7 Then Lcdtext = "*** Stufe 7 ***"

   Lcd_show 2 , 1 , Lcdtext

   Lcdpos = 0

End If

'Start fr Wasserablauf
If Pxx = 6 And Mxx = 6 Then
   Mxx = 16
   Men_text

   Lcd_clear 1
   Lcd_clear 2
   Lcd1 = "StartWasser"
   Lcdtext = Mtext + Lcd1
   Lcd_show 1 , 1 , Lcdtext

   If Wasser_step = 1 Then Lcdtext = "***   Aus   ***"
   If Wasser_step > 1 Then Lcdtext = "***   Ein   ***"

   Lcd_show 2 , 1 , Lcdtext

   Lcdpos = 0

End If


'Eingabe der Werte

If Mxx > 10 Then


  'Taste 0,1, ... 9
  If Keyb >= Asc( "0") And Keyb <= Asc( "9") Then



      Select Case Lcdpos

         Case 0:

           If Mxx = 14 Then
              If Summer = 0 Then
                  Summer = 1
                     Lcdtext = "*** Sommer *** "
                     Lcd_show 2 , 1 , Lcdtext
              Else
                  If Summer = 1 Then
                     Summer = 2
                     Lcdtext = "*** Winter *** "
                     Lcd_show 2 , 1 , Lcdtext
                  Else
                     Summer = 0
                     Lcdtext = "***Automatik***"
                     Lcd_show 2 , 1 , Lcdtext
                  End If
              End If
            End If

            If Mxx = 15 Then
                 Notbetrieb = Notbetrieb + 1
                 If Notbetrieb = 9 Then Notbetrieb = 0


                  If Notbetrieb = 0 Then
                     Lcdtext = "  *** Aus ***   "
                     Lcd_show 2 , 1 , Lcdtext
                  Else
                     Lcdtext = "*** Stufe "
                     Lcdtext = Lcdtext + Str(notbetrieb)
                     Lcdtext = Lcdtext + " ***"
                     Lcd_show 2 , 1 , Lcdtext

                  End If

              End If

            If Mxx = 16 Then
                 Wasser_step = 255
                 Lcdtext = "***  Start  ***"
                 Lcd_show 2 , 1 , Lcdtext
            End If



         Case 6:
            W1 = Keyb - 48
            W1 = W1 * 10

            'Eingegebene Zahl Anzeigen
            Lcdtext = Chr(keyb)
            Lcd_show 2 , 6 , Lcdtext

            'Eingabe zur nchsten Position
            Lcdpos = 7
            Lcd_locate 2 , 7
            Lcd_cursor On

         Case 7:
            W1 = W1 + Keyb
            W1 = W1 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 7 , Lcdtext

            Lcdpos = 9
            Lcd_locate 2 , 9
            Lcd_cursor On


        Case 9:
            W2 = Keyb - 48
            W2 = W2 * 10

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 9 , Lcdtext

            Lcdpos = 10
            Lcd_locate 2 , 10
            Lcd_cursor On

         Case 10:
            W2 = W2 + Keyb
            W2 = W2 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 10 , Lcdtext

            Lcdpos = 12
            Lcd_locate 2 , 12
            Lcd_cursor On

        Case 12:
            W3 = Keyb - 48
            W3 = W3 * 10

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 12 , Lcdtext

            Lcdpos = 13
            Lcd_locate 2 , 13
            Lcd_cursor On

         Case 13:
            W3 = W3 + Keyb
            W3 = W3 - 48

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 13 , Lcdtext

           'Daten bernehmen
            Pxx = 1

            If Mxx = 12 Then
               If W1 > 31 Then W1 = 31
               If W2 > 12 Then W2 = 12

               If W1 < 10 Then
                  _date = "0" + Str(w1) + "."
               Else
                  _date = Str(w1) + "."
               End If

               If W2 < 10 Then
                  _date = _date + "0" + Str(w2) + "."
               Else
                  _date = _date + Str(w2) + "."
               End If

               If W3 < 10 Then
                  _date = _date + "0" + Str(w3)
               Else
                  _date = _date + Str(w3)
               End If

               Pxx = 3

            End If

            If Mxx = 13 Then
               If W1 > 24 Then W1 = 23
               If W2 > 59 Then W2 = 59
               If W3 > 59 Then W3 = 59

               If W1 < 10 Then
                  _time = "0" + Str(w1) + ":"
               Else
                  _time = Str(w1) + ":"
               End If

               If W2 < 10 Then
                  _time = _time + "0" + Str(w2) + ":"
               Else
                  _time = _time + Str(w2) + ":"
               End If

               If W3 < 10 Then
                  _time = _time + "0" + Str(w3)
               Else
                  _time = _time + Str(w3)
               End If
            End If



            Set_time

      End Select


  End If

End If



End Sub





'Betrieb

Sub Men_w02()

If Wxx <> 2 Then
  Exit Sub
End If




  If _wxx <> Wxx Or _pxx <> Pxx Then
      _wxx = Wxx
      _pxx = Pxx

  End If


     If Keyb = Asc( "0") Then
        M_brenner = 0
        M_wasser = 0
        M_heizen = 0
      End If

      If Keyb = Asc( "1") Then
         M_brenner = 1
      End If

      If Keyb = Asc( "2") Then
         M_wasser = 1
      End If

      If Keyb = Asc( "3") Then
        M_heizen = 1
      End If

      If Keyb = Asc( "6") Then
        M_tagnacht = M_tagnacht + 1
        If M_tagnacht = 3 Then M_tagnacht = 0
      End If


  If Sm02 <> _sec Then
     Sm02 = _sec

      Men_text
      If Sommer = 1 Then
        If Notbetrieb = 0 Then
         If Wasser_uhr = 1 Then
           Lcd1 = "ST      "
         Else
           Lcd1 = "SN      "
         End If

        Else
         Lcd1 = "NS      "
        End If

      Else
        If Notbetrieb = 0 Then
          If Heizen_uhr = 1 Then
            Lcd1 = "WT      "
          Else
            Lcd1 = "WN      "
          End If

        Else
          Lcd1 = "NW      "
        End If
      End If



      Lcdtext = Mtext + Lcd1
      Lcd_show 1 , 1 , Lcdtext





'Temperaturen anzeigen
If Pxx = 1 Then
   Lcdtext = ""

    Lcdtext = "Temp.   "
    Lcd_show 1 , 9 , Lcdtext

    'Aussentemperatur
   If Takt_aussen => 10 Then
   Lcdtext = "TA= +"
   Lcdtext = Lcdtext + Str(takt_aussen)
   End If
   If Takt_aussen < 10 Then
   Lcdtext = "TA= +0"
   Lcdtext = Lcdtext + Str(takt_aussen)
   End If
   If Takt_aussen < 0 Then
   Zahl = Takt_aussen * -1
   Lcdtext = "TA= -0"
   Lcdtext = Lcdtext + Str(zahl)
   End If
   If Takt_aussen <= -10 Then
   Lcdtext = "TA= -"
   Zahl = Takt_aussen * -1
   Lcdtext = Lcdtext + Str(zahl)
   End If

   'Innentemperatur
   Lcdtext = Lcdtext + " TI= "
   Lcdtext = Lcdtext + Str(takt_innen)
   Lcdtext = Lcdtext + "  "

   Lcd_show 2 , 1 , Lcdtext

End If

'Schaltpunkte Wassertemperatur
If Pxx = 2 Then
   Lcdtext = ""

    Lcdtext = "Wasser  "
    Lcd_show 1 , 9 , Lcdtext

   Lcdtext = "u="
   Lcdtext = Lcdtext + Str(tmin_wasser)

   Lcdtext = Lcdtext + " TW="
   Lcdtext = Lcdtext + Str(takt_wasser)

   Lcdtext = Lcdtext + " o="
   Lcdtext = Lcdtext + Str(tmax_wasser)
   Lcdtext = Lcdtext + "        "

   Lcd_show 2 , 1 , Lcdtext

End If

'Schaltpunkte Vorlauftemperatur
If Pxx = 3 Then
   Lcdtext = ""

   Lcdtext = "Heizen  "
   Lcd_show 1 , 9 , Lcdtext

   Lcdtext = "u="
   Zahl = Tmin_heizen + Tmin_korr
   Lcdtext = Lcdtext + Str(zahl)

   Lcdtext = Lcdtext + " TH="
   Lcdtext = Lcdtext + Str(takt_heizen)

   Lcdtext = Lcdtext + " o="
   Zahl = Tmax_heizen + Tmax_korr
   Lcdtext = Lcdtext + Str(zahl)
   Lcdtext = Lcdtext + "        "

   Lcd_show 2 , 1 , Lcdtext

End If

'Temperaturen anzeigen
If Pxx = 4 Then
   Lcdtext = ""

    Lcdtext = "Temp.   "
    Lcd_show 1 , 9 , Lcdtext

    'Temperatur im Heizraum
   Lcdtext = "TK= "
   Lcdtext = Lcdtext + Str(takt_keller)

   'Reserve
   Lcdtext = Lcdtext + " TR= "
   Lcdtext = Lcdtext + Str(takt_reserve)
   Lcdtext = Lcdtext + "  "


   Lcd_show 2 , 1 , Lcdtext

End If



If Pxx = 5 Then
   Lcdtext = "Wasser  "
   Lcd_show 1 , 9 , Lcdtext

   If Wasser_uhr = 0 And Wasser_step = 255 Then
      Lcdtext = "Nachtabsenkung  "
      Lcd_show 2 , 1 , Lcdtext
   End If


   'Vorlauf
   If Wasser_step = 1 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Vorlauf  min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = 2 - Wmin_vorlauf
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If

   'Betrieb

   If Wasser_step = 2 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Brenner  min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = Ti_betrieb - Wmin_betrieb
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext
   End If
   'Nachlauf
   If Wasser_step = 3 And Wasser_uhr = 1 Then
          Lcd_clear 2
          Lcdtext = "Nachlauf min "
          Lcd_show 2 , 1 , Lcdtext
          Zahl = Ti_nachlauf - Wmin_nachlauf
          Lcdtext = Str(zahl)
          Lcd_show 2 , 14 , Lcdtext
   End If
      'Pause
   If Wasser_step = 4 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Pause    min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = Ti_pause - Wmin_warten
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If
   'Warten
   If Wasser_step = 5 And Wasser_uhr = 1 Then
       Lcd_clear 2
       Lcdtext = "Warten   min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = Ti_warten - Wmin_warten
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If

   'Notlauf da Vorlauf kleiner 28 Grad
   If Heiz_z4 > 0 And Heiz_z4 < 100 Then
       Lcd_clear 2
       Lcdtext = "Tv<Min   min "
       Lcd_show 2 , 1 , Lcdtext
       Zahl = 30 - Heiz_z4
       Lcdtext = Str(zahl)
       Lcd_show 2 , 14 , Lcdtext

   End If


End If


If Pxx = 6 Then

   If Notbetrieb = 0 Then
     Lcdtext = "Heizen  "
     Lcd_show 1 , 9 , Lcdtext
   Else
      Select Case Notbetrieb
      Case 1 : Lcdtext = "Not 90  "
      Case 2 : Lcdtext = "Not 60  "
      Case 3 : Lcdtext = "Not 45  "
      Case 4 : Lcdtext = "Not 30  "
      Case 5 : Lcdtext = "Not 25  "
      Case 6 : Lcdtext = "Not 20  "
      Case 7 : Lcdtext = "Not 15  "
      Case 8 : Lcdtext = "Not 10  "


      End Select

      Lcd_show 1 , 9 , Lcdtext

   End If

   'Betrieb
   If Heizen_step <> 1 And Heizen_step <> 2 Then
       Lcd_clear 2
       Lcdtext = Heiz_meld
       Lcd_show 2 , 1 , Lcdtext
   End If




      If Heizen_step = 1 Then
         Lcd_clear 2
         Lcdtext = "Brenner  min "
         Lcd_show 2 , 1 , Lcdtext
         Zahl = Hti_betrieb - Hmin_betrieb
         Lcdtext = Str(zahl)
         Lcd_show 2 , 14 , Lcdtext
      End If
      If Heizen_step = 2 Then
         Lcd_clear 2
         Lcdtext = "Pause    min "
         Lcd_show 2 , 1 , Lcdtext

         Zahl = Hti_warten - Hti_korr
         If Zahl <= 10 Then Zahl = 10
         If Heizen_uhr = 0 Then Zahl = 120

         Zahl = Zahl - Hmin_warten
         Lcdtext = Str(zahl)
         Lcd_show 2 , 14 , Lcdtext
      End If





End If



'Betriebsanzeige
If Pxx = 7 Then



      Lcdtext = "Ausgang "
      Lcd_show 1 , 9 , Lcdtext

      If Brenner = 1 Then
         Lcdtext = "B=1 "
      Else
         Lcdtext = "B=0 "
      End If
      If Wasser = 1 Then
         Lcdtext = Lcdtext + "W=1 "
      Else
         Lcdtext = Lcdtext + "W=0 "
      End If
      If Heizen = 1 Then
         Lcdtext = Lcdtext + "H=1"
      Else
         Lcdtext = Lcdtext + "H=0"
      End If

      If M_tagnacht = 0 Then

       If Heizen_uhr = 0 Then
       Lcdtext = Lcdtext + " NA  "
       Else
       Lcdtext = Lcdtext + " TA  "
       End If

      End If

      If M_tagnacht = 1 Then
       Lcdtext = Lcdtext + " T   "
      End If
      If M_tagnacht = 2 Then
       Lcdtext = Lcdtext + " N   "
      End If

      Lcd_show 2 , 1 , Lcdtext



End If

'Uhrzeitanzeige
If Pxx = 8 Then


      Lcdtext = "Zeit   "
      Lcd_show 1 , 9 , Lcdtext


      Lcdtext = "     " + _time + "   "
      Lcd_show 2 , 1 , Lcdtext

End If

'Diagnose Heizen
If Pxx = 9 Then

      Lcdtext = "Heizen "
      Lcd_show 1 , 9 , Lcdtext


      Lcdtext = Br_time
      Lcdtext = Lcdtext + " "

      If St_heizen < 10 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(st_heizen)
      Lcdtext = Lcdtext + " "

      If Br_zeit < 10 Then
          Lcdtext = Lcdtext + "00"
      End If
      If Br_zeit > 9 And Br_zeit < 100 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(br_zeit)

      Lcd_show 2 , 1 , Lcdtext

End If


'Diagnose Wasser
If Pxx = 10 Then

      Lcdtext = "Wasser "
      Lcd_show 1 , 10 , Lcdtext


      Lcdtext = Wa_time
      Lcdtext = Lcdtext + " "

      If St_wasser < 10 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(st_wasser)
      Lcdtext = Lcdtext + " "

      If Wa_zeit < 10 Then
          Lcdtext = Lcdtext + "00"
      End If
      If Wa_zeit > 9 And Wa_zeit < 100 Then
          Lcdtext = Lcdtext + "0"
      End If
      Lcdtext = Lcdtext + Str(wa_zeit)

      Lcd_show 2 , 1 , Lcdtext

End If


End If


End Sub



'Handbetrieb
Sub Men_w03()

If Wxx <> 3 Then
Exit Sub
End If

 If _wxx <> Wxx Or _pxx <> Pxx Then
      _wxx = Wxx
      _pxx = Pxx

      Men_text

 End If


     If Keyb = Asc( "0") Then
        If Pxx = 1 Then Brenner = 0
        If Pxx = 2 Then Wasser = 0
        If Pxx = 3 Then Heizen = 0
        If Pxx = 4 Then Beeper = 0
      End If

      If Keyb = Asc( "1") Then
        If Pxx = 1 Then Brenner = 1
        If Pxx = 2 Then Wasser = 1
        If Pxx = 3 Then Heizen = 1
        If Pxx = 4 Then Beeper = 1
      End If





 If Sm03 <> _sec Then
     Sm03 = _sec



 If Pxx = 1 Then


       Lcd1 = "DO6/K7 Bren"
       Lcdtext = Mtext + Lcd1
       Lcd_show 1 , 1 , Lcdtext

     If Brenner = 0 Then
         Lcd2 = "0=Off 1=On   Off"
         Lcd_show 2 , 1 , Lcd2
  End If
  If Brenner = 1 Then
         Men_text
         Lcd2 = "0=Off 1=On   On "
         Lcd_show 2 , 1 , Lcd2
  End If




End If

If Pxx = 2 Then

         Lcd1 = "DO5/K6 Wass"
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

  If Wasser = 0 Then
         Lcd2 = "0=Off 1=On   Off"
         Lcd_show 2 , 1 , Lcd2
  End If
  If Wasser = 1 Then
         Men_text
         Lcd2 = "0=Off 1=On   On "
         Lcd_show 2 , 1 , Lcd2
  End If




End If


If Pxx = 3 Then

         Lcd1 = "DO4/K5 Heiz"
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

  If Heizen = 0 Then
         Lcd2 = "0=Off 1=On   Off"
         Lcd_show 2 , 1 , Lcd2
  End If
  If Heizen = 1 Then
         Men_text
         Lcd2 = "0=Off 1=On   On "
         Lcd_show 2 , 1 , Lcd2
  End If




End If


If Pxx = 4 Then

         Lcd1 = "DO7 Beeper "
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

  If Beeper = 0 Then
         Lcd2 = "0=Off 1=On   Off"
         Lcd_show 2 , 1 , Lcd2
  End If
  If Beeper = 1 Then
         Men_text
         Lcd2 = "0=Off 1=On   On "
         Lcd_show 2 , 1 , Lcd2
  End If



End If


 If Pxx >= 5 Then

      Lcd1 = "Analoginp."
      Lcdtext = Mtext + Lcd1
      Lcd_show 1 , 1 , Lcdtext

 End If

 If Pxx = 5 Then

      Lcd2 = "AI00 "

      Wert = Str(ai00) + " " + Str(takt_innen) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If
  If Pxx = 6 Then

      Lcd2 = "AI01 "

      Wert = Str(ai01) + " " + Str(takt_aussen) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If

  If Pxx = 7 Then

      Lcd2 = "AI02 "

      Wert = Str(ai02) + " " + Str(takt_wasser) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If


  If Pxx = 8 Then

      Lcd2 = "AI03 "

      Wert = Str(ai03) + " " + Str(takt_heizen) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If
  If Pxx = 9 Then

      Lcd2 = "AI04 "

      'KTY 81 210
      Zahl1 = 865 - Ai04
      Zahl = Zahl1 / 2
      Zahl = Zahl + Zahl1

      Wert = Str(ai04) + " " + Str(zahl) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If

  If Pxx = 10 Then

      Lcd2 = "AI05 "

      'KTY 81 210
      Zahl1 = 865 - Ai04
      Zahl = Zahl1 / 2
      Zahl = Zahl + Zahl1

      Wert = Str(ai05) + " " + Str(zahl) + " C     "
      Lcd2 = Lcd2 + Wert

      Lcd_show 2 , 1 , Lcd2


  End If








End If


End Sub




'EEprom Verwaltung
Sub Men_w04()

If Wxx <> 4 Then
Exit Sub
End If



      If _pxx <> Pxx Then
         _pxx = Pxx
         Mxx = 1
      End If

     If Sm04 <> _sec Then
        Sm04 = _sec


         If Pxx = 1 Then
            Mxx = 11

            Men_text
            Lcd1 = "R=0 D=1 W=2       "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(eeprom_write) + "              "
            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Locate 2 , 1
            Lcd_cursor On


         End If


          If Pxx = 2 And Mxx = 1 Then
            Mxx = 12

            Men_text
            Lcd1 = "Wasser Temp  "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(tsol_wasser) + "  C        "
            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On


         End If

          If Pxx = 3 And Mxx = 1 Then
             Mxx = 13


            Men_text
            Lcd1 = "Raum Temp  "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            Zahl = Tsol_raum / 10
            Lcd2 = Str(zahl) + "  C       "
            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On




         End If




           If Pxx = 4 And Mxx = 1 Then
            Mxx = 14

            Men_text
            Lcd1 = "Wasser On       "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If Wasser_std_on > 9 And Wasser_min_on > 9 Then
            Lcd2 = Str(wasser_std_on) + ":" + Str(wasser_min_on) + " Uhr         "
            End If
            If Wasser_std_on < 10 And Wasser_min_on < 10 Then
            Lcd2 = "0" + Str(wasser_std_on) + ":0" + Str(wasser_min_on) + " Uhr         "
            End If
            If Wasser_std_on < 10 And Wasser_min_on > 9 Then
            Lcd2 = "0" + Str(wasser_std_on) + ":" + Str(wasser_min_on) + " Uhr         "
            End If
            If Wasser_std_on > 9 And Wasser_min_on < 10 Then
            Lcd2 = Str(wasser_std_on) + ":0" + Str(wasser_min_on) + " Uhr         "
            End If


            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If

           If Pxx = 5 And Mxx = 1 Then
             Mxx = 15

            Men_text
            Lcd1 = "Wasser Off      "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If Wasser_std_off > 9 And Wasser_min_off > 9 Then
            Lcd2 = Str(wasser_std_off) + ":" + Str(wasser_min_off) + " Uhr         "
            End If
            If Wasser_std_off < 10 And Wasser_min_off < 10 Then
            Lcd2 = "0" + Str(wasser_std_off) + ":0" + Str(wasser_min_off) + " Uhr         "
            End If
            If Wasser_std_off < 10 And Wasser_min_off > 9 Then
            Lcd2 = "0" + Str(wasser_std_off) + ":" + Str(wasser_min_off) + " Uhr         "
            End If
            If Wasser_std_off > 9 And Wasser_min_off < 10 Then
            Lcd2 = Str(wasser_std_off) + ":0" + Str(wasser_min_off) + " Uhr         "
            End If

            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If


           If Pxx = 6 And Mxx = 1 Then
             Mxx = 16

            Men_text
            Lcd1 = "Heizen On       "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If H1_std_on > 9 And H1_min_on > 9 Then
            Lcd2 = Str(h1_std_on) + ":" + Str(h1_min_on) + " Uhr         "
            End If
            If H1_std_on < 10 And H1_min_on < 10 Then
            Lcd2 = "0" + Str(h1_std_on) + ":0" + Str(h1_min_on) + " Uhr         "
            End If
            If H1_std_on < 10 And H1_min_on > 9 Then
            Lcd2 = "0" + Str(h1_std_on) + ":" + Str(h1_min_on) + " Uhr         "
            End If
            If H1_std_on > 9 And H1_min_on < 10 Then
            Lcd2 = Str(h1_std_on) + ":0" + Str(h1_min_on) + " Uhr         "
            End If

            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If

           If Pxx = 7 And Mxx = 1 Then
              Mxx = 17

            Men_text
            Lcd1 = "Heizen Off      "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext

            If H1_std_off > 9 And H1_min_off > 9 Then
            Lcd2 = Str(h1_std_off) + ":" + Str(h1_min_off) + " Uhr         "
            End If
            If H1_std_off < 10 And H1_min_off < 10 Then
            Lcd2 = "0" + Str(h1_std_off) + ":0" + Str(h1_min_off) + " Uhr         "
            End If
            If H1_std_off < 10 And H1_min_off > 9 Then
            Lcd2 = "0" + Str(h1_std_off) + ":" + Str(h1_min_off) + " Uhr         "
            End If
            If H1_std_off > 9 And H1_min_off < 10 Then
            Lcd2 = Str(h1_std_off) + ":0" + Str(h1_min_off) + " Uhr         "
            End If

            Lcd_show 2 , 1 , Lcd2

            Lcdpos = 1
            Lcd_locate 2 , 1
            Lcd_cursor On

         End If







         If Pxx = 8 And Mxx = 1 Then
            Mxx = 18

            Men_text
            Lcd1 = "Wasser Nach    "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(ti_nachlauf) + " min           "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If

         If Pxx = 9 Then
            Mxx = 19

            Men_text
            Lcd1 = "Wasser Betrieb "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(ti_betrieb) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If

           If Pxx = 10 And Mxx = 1 Then
            Mxx = 20

            Men_text
            Lcd1 = "Wasser Warten  "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(ti_warten) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If





         If Pxx = 11 And Mxx = 1 Then
            Mxx = 21

            Men_text
            Lcd1 = "Heizen Betrieb "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(hti_betrieb) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If


        If Pxx = 12 And Mxx = 1 Then
            Mxx = 22

            Men_text
            Lcd1 = "Heizen Pause   "
            Lcdtext = Mtext + Lcd1
            Lcd_show 1 , 1 , Lcdtext


            Lcd2 = Str(hti_warten) + " min        "
            Lcd_show 2 , 1 , Lcd2

            Lcd_cursor Off

         End If



End If


      'Eingabe der Werte
      '#################

      If Mxx = 11 Then
        'Taste 0,1, ... 9
         If Keyb >= Asc( "0") And Keyb <= Asc( "2") Then


            Eeprom_write = Keyb - 48

            'Eingegebene Zahl Anzeigen
            Lcdtext = Chr(keyb) + "     "
            Lcd_show 2 , 1 , Lcdtext
         End If

      End If


      If Mxx >= 12 And Mxx <= 22 Then
        'Taste 0,1, ... 9
         If Keyb >= Asc( "0") And Keyb <= Asc( "9") Then



         Select Case Lcdpos

            Case 1:
            W1 = Keyb - 48
            W1 = W1 * 10

            'Eingegebene Zahl Anzeigen
            Lcdtext = Chr(keyb)
            Lcd_show 2 , 1 , Lcdtext

            'Eingabe zur nchsten Position
            Lcdpos = 2
            Lcd_locate 2 , 2
            Lcd_cursor On

            Case 2:
            W1 = W1 + Keyb
            W1 = W1 - 48
            If W1 < 10 Then
               Lcdtext = "0" + Chr(keyb)
            Else
               Lcdtext = Chr(keyb)
            End If
            Lcd_show 2 , 1 , Lcdtext

            Lcdpos = 4
            Lcd_locate 2 , 4
            Lcd_cursor On

            If Mxx = 12 Then
               Tsol_wasser = W1
               Mxx = 1
            End If
            If Mxx = 13 Then
               Tsol_raum = W1 * 10
               Mxx = 1
            End If
            If Mxx = 14 Then
               Wasser_std_on = W1
            End If
            If Mxx = 15 Then
               Wasser_std_off = W1
            End If
            If Mxx = 16 Then
               H1_std_on = W1
            End If
            If Mxx = 17 Then
               H1_std_off = W1
            End If

            If Mxx = 18 Then
              Ti_nachlauf = W1
               Mxx = 1
            End If
            If Mxx = 19 Then
              Ti_betrieb = W1
              Mxx = 1
            End If

            If Mxx = 20 Then
               Lcdpos = 4
               Lcd_locate 2 , 3
               Lcd_cursor On
            End If

            If Mxx = 21 Then
              Hti_betrieb = W1
              Mxx = 1
            End If

            If Mxx = 22 Then
              Hti_warten = W1
              Mxx = 1
            End If


            Case 4:
            W2 = Keyb - 48

            If Mxx = 20 Then
               Ti_warten = W1 * 10
               Ti_warten = Ti_warten + W2
            End If


            W2 = W2 * 10

            Lcdtext = Chr(keyb)
            Lcd_show 2 , 4 , Lcdtext

            Lcdpos = 5
            Lcd_locate 2 , 5
            Lcd_cursor On

            Case 5:
            W2 = W2 + Keyb
            W2 = W2 - 48

            If W2 < 10 Then
            Lcdtext = "0" + Chr(keyb)
            Else
            Lcdtext = Chr(keyb)
            End If
            Lcd_show 2 , 4 , Lcdtext

            Lcd_cursor Off

            If Mxx = 14 Then
               Wasser_min_on = W2
                Mxx = 1
           End If
            If Mxx = 15 Then
                Wasser_min_off = W2
                Mxx = 1
              End If
            If Mxx = 16 Then
               H1_min_on = W2
               Mxx = 1
            End If
            If Mxx = 17 Then
               H1_min_off = W2
               Mxx = 1
            End If

            End Select


         End If

      End If




End Sub












'report


Sub Men_w05()

If Wxx <> 5 Then
Exit Sub
End If


      If _wxx <> Wxx Then
          _wxx = Wxx
          Men_text

      End If

      If Sm05 <> _sec Then
         Sm05 = _sec



If Pxx = 1 Then

         Men_text
         Lcd1 = "Schalten      "
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = "STW="
         Lcd2 = Lcd2 + Str(st_wasser)
         Lcd2 = Lcd2 + " STB="
         Lcd2 = Lcd2 + Str(st_heizen)
         Lcd2 = Lcd2 + "          "
         Lcd_show 2 , 1 , Lcd2

End If

If Pxx = 2 Then

         Men_text
         Lcd1 = "Brenner On "
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = Str(zeit_brenner)
         Lcd2 = Lcd2 + " min"
         Lcd2 = Lcd2 + "           "
         Lcd_show 2 , 1 , Lcd2

End If

If Pxx = 3 Then

         Men_text
         Lcd1 = "Wasser On "
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = Str(zeit_wasser)
         Lcd2 = Lcd2 + " min"
         Lcd2 = Lcd2 + "          "
         Lcd_show 2 , 1 , Lcd2

End If

If Pxx = 4 Then

         Men_text
         Lcd1 = "Heizen On "
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = Str(zeit_heizen)
         Lcd2 = Lcd2 + " min"
         Lcd2 = Lcd2 + "          "
         Lcd_show 2 , 1 , Lcd2

End If

If Pxx = 5 Then

         Men_text
         Lcd1 = "Innen C "
         Lcd1 = Lcd1 + Str(t_mittel_innen)
         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = "Min="
         Lcd2 = Lcd2 + Str(temp_min_innen)
         Lcd2 = Lcd2 + " Max="
         Lcd2 = Lcd2 + Str(temp_max_innen)
         Lcd2 = Lcd2 + "       "
         Lcd_show 2 , 1 , Lcd2

End If

If Pxx = 6 Then

         Men_text
         Lcd1 = "Aussen C "
         Lcd1 = Lcd1 + Str(t_mittel_aussen)

         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = "Min="
         Lcd2 = Lcd2 + Str(temp_min_aussen)
         Lcd2 = Lcd2 + " Max="
         Lcd2 = Lcd2 + Str(temp_max_aussen)
         Lcd2 = Lcd2 + "       "
         Lcd_show 2 , 1 , Lcd2

End If

If Pxx = 7 Then

         Men_text
         Lcd1 = "Wasser C "
         Lcd1 = Lcd1 + Str(t_mittel_wasser)

         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = "Min="
         Lcd2 = Lcd2 + Str(temp_min_wasser)
         Lcd2 = Lcd2 + " Max="
         Lcd2 = Lcd2 + Str(temp_max_wasser)
         Lcd2 = Lcd2 + "       "
         Lcd_show 2 , 1 , Lcd2

End If



If Pxx = 8 Then

         Men_text
         Lcd1 = "Heizen C "
         Lcd1 = Lcd1 + Str(t_mittel_heizen)

         Lcdtext = Mtext + Lcd1
         Lcd_show 1 , 1 , Lcdtext

         Lcd2 = "Min="
         Lcd2 = Lcd2 + Str(temp_min_heizen)
         Lcd2 = Lcd2 + " Max="
         Lcd2 = Lcd2 + Str(temp_max_heizen)
         Lcd2 = Lcd2 + "       "
         Lcd_show 2 , 1 , Lcd2

End If

End If


End Sub













'StartLogo Anzeigen
Sub Men_w12()

If Wxx <> 12 Then
Exit Sub
End If

    If Startlogo = -1 Then
        Startlogo = 0
    End If


End Sub






'####################
'Modul Endekennung
'####################


Endmenu: