'
'   !------------------------------------------------------------------------!
'   !  Modul: User_COM.bas                                                     !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Com Schnittstelle                                                     !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !
'   !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'

$regfile = "m2561def.dat"                                   ' specify the used micro

$include "AT_Com.bas"


'###################################################
'Funktionen definieren
'###################################################

Declare Sub Com_send_cycl(byval Fkt As Integer)
Declare Sub Com_send_para(byval Fkt As Integer)
Declare Sub Com_send_arch(byval Fkt As Integer)

Dim _sendsec As Byte
Dim Sendsec As Byte

Dim Czahl As Integer
Dim Cdatum As String * 8

Dim Ix As Integer
Dim Nx As Byte
Dim Text As String * 10

Goto Endcom

'Zyklischen werden die Betriebswerte gesendet
'oder wenn PC ein V sendet
Sub Com_send_cycl(fkt As Integer)

If _sec <> _sendsec Then
   _sendsec = _sec
   Sendsec = Sendsec + 1
End If

If Sendsec => 30 Or Fkt = 1 Then
   Sendsec = 0

   Sendtext = "V001;" + Str(takt_innen)
   Sendtext = Sendtext + ";AI00 Temperatur Wohnen"
   Com1_send Sendtext

   Sendtext = "V002;" + Str(takt_aussen)
   Sendtext = Sendtext + ";AI01 Temperatur Aussen"
   Com1_send Sendtext

   Sendtext = "V003;" + Str(takt_wasser)
   Sendtext = Sendtext + ";[C] AI02 Temperatur Wasser"
   Com1_send Sendtext

   Sendtext = "V004;" + Str(takt_heizen)
   Sendtext = Sendtext + ";[C] AI03 Temperatur Heizen"
   Com1_send Sendtext

   Sendtext = "V005;" + Str(do06)
   Sendtext = Sendtext + ";[C] DO06 Brenner"
   Com1_send Sendtext

   Sendtext = "V006;" + Str(do05)
   Sendtext = Sendtext + ";DO05 Wasserpumpe"
   Com1_send Sendtext

   Sendtext = "V007;" + Str(do04)
   Sendtext = Sendtext + ";DO04 Heizungspumpe"
   Com1_send Sendtext

   Sendtext = "V008;" + Str(sommer)
   Sendtext = Sendtext + ";Sommer(1)/Winter(0)"
   Com1_send Sendtext

   Sendtext = "V009;" + Str(wasser_uhr)
   Sendtext = Sendtext + ";Wasser Tag(1)/Nacht(0)"
   Com1_send Sendtext


   Sendtext = "V010;" + Str(heizen_uhr)
   Sendtext = Sendtext + ";Heizen Tag(1)/Nacht(0)"
   Com1_send Sendtext

   Sendtext = "V011;" + Str(notbetrieb)
   Sendtext = Sendtext + ";Notbetrieb Aus(0) Stufe 1-7"
   Com1_send Sendtext


   '####Wasser###

   Sendtext = "V012;" + Str(wasser_step)
   Sendtext = Sendtext + ";Step Wasser"
   Com1_send Sendtext


   If Wasser_step = 1 Then
   Czahl = Ti_nachlauf - Wmin_vorlauf
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[sec] Wasser Vorlaufzeit"


   End If

   If Wasser_step = 2 Then
   Czahl = Ti_betrieb - Wmin_betrieb
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Wasser Betriebszeit"
   End If

   If Wasser_step = 3 Then
   Czahl = Ti_nachlauf - Wmin_nachlauf
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[sec] Wasser Nachlaufzeit"
   End If

   If Wasser_step = 4 Then
   Czahl = Ti_pause - Wmin_warten
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Wasser Pausenzeit"
   End If

   If Wasser_step = 5 Then
   Czahl = Ti_warten - Wmin_warten
   Sendtext = "V013;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Wasser Wartezeit"
   End If

   Com1_send Sendtext

   '####Heizen###


   Sendtext = "V014;" + Str(tmin_heizen)
   Sendtext = Sendtext + ";[C] Tmin Heizen Vorlauf"
   Com1_send Sendtext

   Sendtext = "V015;" + Str(tmax_heizen)
   Sendtext = Sendtext + ";[C] Tmax Heizen Vorlauf"
   Com1_send Sendtext

   Sendtext = "V016;" + Str(heizen_step)
   Sendtext = Sendtext + ";Step Wasser"
   Com1_send Sendtext



   If Heizen_step = 1 Then
   Czahl = Hti_betrieb - Hmin_betrieb
   Sendtext = "V017;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Heizen Betriebszeit"
   End If

   If Heizen_step = 2 Then
   Czahl = Hti_warten - Hmin_warten
   Sendtext = "V017;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Heizen Pausenzeit"
   End If

   If Heizen_step = 3 Then
   Czahl = Hmin_warten
   Sendtext = "V017;" + Str(czahl)
   Sendtext = Sendtext + ";[min] Heizen Wartezeit"
   End If


End If

End Sub

'Wenn PC ein P sendet dann die Parameterwerte zurck
Sub Com_send_para(fkt As Integer)


'####Wasser####

   Cdatum = Str(wasser_std_on) + ":" + Str(wasser_min_on) + ":00"

   Sendtext = "P001;" + Cdatum
   Sendtext = Sendtext + ";Tagesbetrieb Ein"
   Com1_send Sendtext

     Cdatum = Str(wasser_std_off) + ":" + Str(wasser_min_off) + ":00"
   Sendtext = "P002;" + Cdatum
   Sendtext = Sendtext + ";Nachtbetrieb Ein"
   Com1_send Sendtext

   Sendtext = "P003;" + Str(tsol_wasser)
   Sendtext = Sendtext + ";[C] Soll Wassertemperatur"
   Com1_send Sendtext

   Sendtext = "P004;" + Str(ti_betrieb)
   Sendtext = Sendtext + ";[min] Zeit Brenner Ein"
   Com1_send Sendtext

   Sendtext = "P005;" + Str(ti_pause)
   Sendtext = Sendtext + ";[min] Zeit Brenner Pause"
   Com1_send Sendtext

   Sendtext = "P006;" + Str(ti_nachlauf)
   Sendtext = Sendtext + ";[sec] Vor-/Nachlaufzeit"
   Com1_send Sendtext

   Sendtext = "P007;" + Str(ti_warten)
   Sendtext = Sendtext + ";[min] Wartezeit"
   Com1_send Sendtext




'####Heizen###


    Cdatum = Str(h1_std_on) + ":" + Str(h1_min_on) + ":00"

   Sendtext = "P008;" + Cdatum
   Sendtext = Sendtext + ";Tag Betrieb Ein"
   Com1_send Sendtext

   Cdatum = Str(h1_std_off) + ":" + Str(h1_min_off) + ":00"

   Sendtext = "P009;" + Cdatum
   Sendtext = Sendtext + ";Nachtbetrieb Ein"
   Com1_send Sendtext

   Sendtext = "P010;" + Str(tsol_raum)
   Sendtext = Sendtext + ";[C] Soll Raumtemperatur"
   Com1_send Sendtext






End Sub

'Wenn PC ein A sendet dann die Parameterwerte zurck
Sub Com_send_arch(fkt As Integer)

   Nx = 0
   For Ix = 1 To 62
     If Len(adatum(ix)) > 0 Then
       Incr Nx
     End If
   Next Ix

          Sendtext = Str(nx)
          Sendtext = Sendtext + ";Tage im Archiv"
          Com1_send Sendtext



     For Ix = 1 To 62

      If Len(adatum(ix)) > 0 Then

          Text = "A000;" + Adatum(ix)
          Sendtext = Text
          Sendtext = Sendtext + ";Archivname"
          Com1_send Sendtext

          Sendtext = "A001;"
          Sendtext = Sendtext + Str(aanz_wasser(ix) )
          Sendtext = Sendtext + ";Anzahl Schaltungen Wasserpumpe"
          Com1_send Sendtext


          Sendtext = "A002;"
          Sendtext = Sendtext + Str(aanz_brenner(ix))
          Sendtext = Sendtext + ";Anzahl Schaltungen Brenner"
          Com1_send Sendtext

          Sendtext = "A003;"
          Sendtext = Sendtext + Str(atim_wasser(ix))
          Sendtext = Sendtext + ";[min] Time Wasserpumpe"
          Com1_send Sendtext

          Sendtext = "A004;"
          Sendtext = Sendtext + Str(atim_brenner(ix))
          Sendtext = Sendtext + ";[min] Time Brenner"
          Com1_send Sendtext

          Sendtext = "A005;"
          Sendtext = Sendtext + Str(atim_heizen(ix))
          Sendtext = Sendtext + ";[min] Time Heizungspumpe"
          Com1_send Sendtext

          Sendtext = "A006;"
          Sendtext = Sendtext + Str(amin_i(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Innen"
          Com1_send Sendtext

          Sendtext = "A007;"
          Sendtext = Sendtext + Str(amax_i(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Innen"
          Com1_send Sendtext

          Sendtext = "A008;"
          Sendtext = Sendtext + Str(amit_i(ix))
          Sendtext = Sendtext + ";[C] Temperatur Mittelw. Innen"
          Com1_send Sendtext

          Sendtext = "A009;"
          Sendtext = Sendtext + Str(amin_a(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Aussen"
          Com1_send Sendtext

          Sendtext = "A010;"
          Sendtext = Sendtext + Str(amax_a(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Aussen"
          Com1_send Sendtext

          Sendtext = "A011;"
          Sendtext = Sendtext + Str(amit_a(ix))
          Sendtext = Sendtext + ";[C] Temperatur Mittelw. Aussen"
          Com1_send Sendtext

          Sendtext = "A012;"
          Sendtext = Sendtext + Str(amin_w(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Wasser"
          Com1_send Sendtext

          Sendtext = "A013;"
          Sendtext = Sendtext + Str(amax_w(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Wasser"
          Com1_send Sendtext

          Sendtext = "A014;"
          Sendtext = Sendtext + Str(amit_w(ix))
          Sendtext = Sendtext + ";[C] Temperatur Mittelw. Wasser"
          Com1_send Sendtext

         #if 0
          Sendtext = "A015;"
          Sendtext = Sendtext + Str(amin_h(ix))
          Sendtext = Sendtext + ";[C] Temperatur min. Heizungs Vorlauf"
          Com1_send Sendtext

          Sendtext = "A016;"
          Sendtext = Sendtext + Str(amax_h(ix))
          Sendtext = Sendtext + ";[C] Temperatur max. Heizungs Vorlauf"
          Com1_send Sendtext

          Sendtext = "A017;"
          Sendtext = Sendtext + Str(amit_h(ix))
          Sendtext = Sendtext + ";[C] Temperatur Mittelw. Heizungs Vorlauf"
          Com1_send Sendtext
          #endif


       End If
      Next Ix


End Sub


'####################
'Modul Endekennung
'####################
Endcom: